theory Protocol_Isac_PIDE
imports Main
begin
ML_file "~~/src/HOL/TPTP/sledgehammer_tactics.ML"

ML{*
local

val session_lthy = 
  Synchronized.var "isabelle_isac.session_lthy" (Inttab.empty: local_theory Inttab.table)

in

structure Operations = struct

fun init id thy =
  let
    fun upd table =
      case Inttab.lookup table id of
        NONE => Inttab.update_new (id, Named_Target.init "" thy) table
      | SOME _ => error "Local theory already initialized"
  in
    Synchronized.change session_lthy upd;
    XML.Encode.string (Context.theory_name thy)
  end

fun test_fun raw_id [raw_str] =
  let
    val id = XML.Decode.string raw_id
    val str = XML.Decode.string raw_str
  in
    XML.Encode.string ("hello " ^ str ^ " " ^ id)
  end;

end
end
*}

ML{*
local
fun response sys_id req_id: Properties.T =
  [(Markup.functionN, "isabelle_isac_response"),
   ("sys_id", Markup.print_int sys_id),
   ("req_id", Markup.print_int req_id)];

val encode_result = XML.Encode.variant
  [fn Exn.Res a => ([], a),
   fn Exn.Exn exn => ([], XML.Encode.string (@{make_string} exn))]
in
val _ = Session.protocol_handler "isac.isa.System$Handler"
val _ = Isabelle_Process.protocol_command "isabelle_isac"
  (fn sys_id :: req_id :: cmd :: args =>
    let
      val sys_id = Markup.parse_int sys_id
      val req_id = Markup.parse_int req_id
      val id = (sys_id, req_id)
      fun exec f x =
        (Future.fork (fn () =>
          let
            val res = Exn.interruptible_capture f x
            val yxml = YXML.string_of_body (encode_result res)
          in
            Output.protocol_message (response sys_id req_id) [yxml]
          end);
        ())
      val args = map YXML.parse_body args
    in
      case (cmd, args) of
        ("init", []) => exec (Operations.init sys_id) @{theory}
      | ("test_fun", id :: data) => exec (Operations.test_fun id) data
      | _ => error "isabelle/isac-repl: unknown command"
    end)
end
*}ML{*
*}ML{*
*}ML{*
*}ML{*
*}

end
