header {* clariying questions related to Polynomials *}

theory Try_Polynomial
imports Complex_Main (*"/usr/local/isabisac/src/Doc/IsarRef/Base"*) "~~/src/HOL/Library/Polynomial"
(*      |-for type rat |-for isabelle code       |- *)
  "/usr/local/isabisac/src/Tools/isac/Knowledge/GCD_Poly_ML"
begin
text {*
  # "AD" in section headers refers to respective sections in 
    "~~/src/HOL/Library/Polynomial.thy".
  # isar-ref is "The Isabelle/Isar Reference Manual" contained
    in the release Isabelle2013 from February 12, 2013. 
  # The subsections of section "AD sections of HOL/Library/Polynomial.thy" contain texts
    ## of code copied from Polynomial.thy marked with "code"
      (NOT outcommented code generates Comment_Poly.poly, etc)
    ## with explanations already found in isar-ref, marked !!! 
    ## with questions not yet resolved, marked with ???
    ## with questions to Florian, marked with ???FH???
*}

section {* Preparations for the paper "Isabelle ... for the ... Mathematician" ##################*}
subsection {* Isabelle concepts not (yet) described in the paper ================================*}
text {*
  Prerequisites:
  # type variable
  # context
  #locales, definitional specifications -- "module system"
    https://lists.cam.ac.uk/mailman/htdig/cl-isabelle-users/2013-July/msg00117.html
*}

subsection {* minimal locale -- executability of local definition? ------------------------------*}
  locale ll1 =
    fixes fff :: "int \<Rightarrow> int \<Rightarrow> int"
    assumes ccc: "fff a b = fff b a"
      and ddd : "fff (fff a b) c = fff a (fff b c)"
  begin  
    lemma aaa [code]: "fff a b = a + b"
    sorry
    value "fff 1 2" --{*"fff 1 2" :: "int" SEE 
      https://lists.cam.ac.uk/mailman/htdig/cl-isabelle-users/2013-November/msg00028.html*}

  definition
    ggg :: "int \<Rightarrow> int \<Rightarrow> int"
    where "ggg a b = a + b"
     
  end

thm "ll1_def"   --{**}
(* How do I get a computable version of "fff" from "ll1" ? --- impossible from "fixes" !!!!!!!!
  These are still free... *)
term "fff"      --{*"fff" :: "'a"*}
term "ll1 fff"  --{*"fff" :: "'a"*}
(*term "ll1.fff"  ...Undeclared constant: "ll1.fff"*)
(*term ll1.fff --{*Undeclared constant: "ll1.fff"*} !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*)

term ll1.ggg    --{*"ll1.ggg" :: "int \<Rightarrow> int \<Rightarrow> int"*}
thm ll1.ggg_def --{*"ll1.ggg" :: "int \<Rightarrow> int \<Rightarrow> int"*}
value "ll1.ggg 1 2"        --{*"ll1.ggg 1 2 :: "int" !!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!!*}

  interpretation kkk: ll1
  --{*goal (1 subgoal):
      1. ll1 hhh*}
  sorry

term kkk.ggg        --{*"kkk.ggg" : "int \<Rightarrow> int \<Rightarrow> int"*}
value "kkk.ggg 1 2" --{*"3" :: "int" !!!!!!!!!!!!!!!!!!!!!!!!!!! OKokOK !!!!!!!!!!!!!!!!!!!!!!*}

subsection {* inappropriate locale -- signature of local definition! --------------------------*}
locale poly_XXX =
  fixes div2 :: "int poly \<Rightarrow> int poly \<Rightarrow> (int \<times> int poly)" (infixl "div2" 70)
    and mod2 :: "int poly \<Rightarrow> int poly \<Rightarrow> int poly" (infixl "mod2" 70)
  assumes div2_def "x div2 y = (THE (a, q). \<exists>r. pdivmod2_rel a x y q r)"
    and mod2_def "x mod2 y = (THE r. \<exists>a q. pdivmod2_rel a x y q r)"
begin
  definition pdivmod2 :: "int poly => int poly => (int \<times> int poly) \<times> int poly"
  where
    "pdivmod2 p q = (p div2 q, p mod2 q)"
  term "pdivmod2" --{*:: "int poly \<Rightarrow> int poly \<Rightarrow> (int \<times> int poly) \<times> int poly"*}

  definition fact_quot :: "int \<Rightarrow> int \<Rightarrow> int \<times> int"
  where
    "fact_quot c1 c2 = (let d = gcd c1 c2; n = c2 div d; q = c1 div d
      in if n > 0 then (n, q) else (-1 * n, -1 * q))"

  lemma pdivmod2_fold_coeffs [code]:
    "pdivmod2 p q = (if q = 0 then ((0, 0), p)
      else fold_coeffs (\<lambda>a ((m, s), r).
        let (m', n) = fact_quot (coeff (pCons a r) (degree q)) (coeff q (degree q))
        in ((if m' = 0 then m else m * m', pCons n (smult m' s)), 
          smult m' (pCons (a * m) r) - smult n q)
     ) p ((1, 0), 0))"
  sorry
  value "pdivmod2 [:9, 8, 7,  6, 5, 4:] [:1, 2, 3:]
    = ((81, [:112, 84, 63, 108:]), [:617, 340:])"   --{*NOT evaluated*}
end (*locale*)
term "poly_XXX.pdivmod2" --{*:: "int poly \<Rightarrow> int poly \<Rightarrow> (int \<times> int poly) \<times> int poly"*}

interpretation poly_remainder: poly_XXX
sorry
term "poly_remainder.pdivmod2" --{*:: "
  (int poly \<Rightarrow> int poly \<Rightarrow> int \<times> int poly) \<Rightarrow>                ...div2
    (int poly \<Rightarrow> int poly \<Rightarrow> int poly) \<Rightarrow>                    ...mod2 
      int poly \<Rightarrow> int poly \<Rightarrow> (int \<times> int poly) \<times> int poly"  ...pdivmod2*}

(*but we cannot get function0-constants out of the locales which have "fixes", 
  see section "minimal locale -- executability of local definition?"*)




subsection {* another inappropriate locale ====================================================*}
(*semiring_div =  comm_semiring_1_cancel + no_zero_divisors + div + ...
  TODO: STILL NOT ANALOGOUS  ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^!*)
locale ring_pring_div = 
  fixes div2 :: "'a::comm_semiring_1 poly \<Rightarrow> 'a poly \<Rightarrow> ('a \<times> 'a poly)" (infixl "div2" 70)
    and mod2 :: "'a poly \<Rightarrow> 'a poly \<Rightarrow> 'a poly" (infixl "mod2" 70)
  assumes mod2_div2_equality: "snd (a div2 b) * b + a mod2 b = smult (fst (a div2 b))a"
    and div2_by_0 [simp]: "a div2 0 = (0, 0)"
    and div2_0 [simp]: "0 div2 a = (0, 0)"
  (*and div_mult_self1 [simp]: "b \<noteq> 0 \<Longrightarrow> (a + c * b) div b = c + a div b"
    and div_mult_mult1 [simp]: "c \<noteq> 0 \<Longrightarrow> (c * a) div (c * b) = a div b"   TODO: MAKE ANALOGOUS*)
interpretation poly_remainder: ring_pring_div
proof
oops

subsection {* Survey on type classes specific for division of polynomials ======================*}
notepad begin
  fix x :: "'a1::zero" (* = fixes zero :: 'a  ("0")*)
  fix x :: "'a2::plus" (* = fixes plus :: "'a \<Rightarrow> 'a \<Rightarrow> 'a"  (infixl "+" 65)*)
  fix x :: "'a3::times" (* = fixes times :: "'a \<Rightarrow> 'a \<Rightarrow> 'a"  (infixl "*" 70)*)
  fix x :: "'a4::mult_zero" (* = times + zero +
  assumes mult_zero_left [simp]: "0 * a = 0"
  assumes mult_zero_right [simp]: "a * 0 = 0"*)
  fix x :: "'a5::semigroup_add" (* = plus +
  assumes add_assoc [algebra_simps, field_simps]: "(a + b) + c = a + (b + c)"*)
  fix x :: "'a6::semigroup_mult" (* = times +
  assumes mult_assoc [algebra_simps, field_simps]: "(a * b) * c = a * (b * c)"*)
  fix x :: "'a7::ab_semigroup_add" (* = semigroup_add +
  assumes add_commute [algebra_simps, field_simps]: "a + b = b + a"*)
  fix x :: "'a8::ab_semigroup_mult" (* = semigroup_mult +
  assumes mult_commute [algebra_simps, field_simps]: "a * b = b * a"*)
  fix x :: "'a9::comm_monoid_add" (* = zero + ab_semigroup_add +
  assumes add_0: "0 + a = a"*)
  fix x :: "'a10::comm_semiring" (* = ab_semigroup_add + ab_semigroup_mult +
  assumes distrib: "(a + b) * c = a * c + b * c"*)
  fix x :: "'a11::comm_semiring_0" (* = comm_semiring + comm_monoid_add + mult_zero*)

  fix x :: "'a12::one" (* = fixes one  :: 'a  ("1")*)
  fix x :: "'a13(*::dvd*)" (* = times ++ definition dvd, lemma dvdI, lemma dvdE *)
  fix x :: "'a14::comm_monoid_mult" (* = one + ab_semigroup_mult +
  assumes mult_1: "1 * a = a"*)
  fix x :: "'a15::zero_neq_one" (* = zero + one + 
  assumes zero_neq_one [simp]: "0 \<noteq> 1"*)
  fix x :: "'a16::comm_semiring_1" (* = zero_neq_one + comm_semiring_0 + comm_monoid_mult + dvd
                  =============== FOR pdivmod_rel :: "'a::comm_semiring_1 poly => ...
                                      ================================================*)
  fix x :: "'a21::uminus" (* = fixes uminus :: "'a \<Rightarrow> 'a"  ("- _" [81] 80)*)
  fix x :: "'a22::minus" (* = fixes minus :: "'a \<Rightarrow> 'a \<Rightarrow> 'a"  (infixl "-" 65)*)
  fix x :: "'a23::comm_semiring_1" (**)
  fix x :: "'a24::cancel_ab_semigroup_add" (* = 'a7::ab_semigroup_add +
  assumes add_imp_eq: "a + b = a + c \<Longrightarrow> b = c"*)
  fix x :: "'a25::cancel_comm_monoid_add" (* = cancel_ab_semigroup_add + 'a9::comm_monoid_add*)
  fix x :: "'a26(*::div*)" (* = 'a13dvd +
  fixes div :: "'a \<Rightarrow> 'a \<Rightarrow> 'a" (infixl "div" 70)
    and mod :: "'a \<Rightarrow> 'a \<Rightarrow> 'a" (infixl "mod" 70)*)
  fix x :: "'a27::ab_group_add" (* = minus + uminus + 'a9::comm_monoid_add +
  assumes ab_left_minus: "- a + a = 0"
  assumes ab_diff_minus: "a - b = a + (- b)"*)
  fix x :: "'a28::comm_ring" (* = 'a10::comm_semiring + ab_group_add*)
  fix x :: "'a29::comm_ring_1" (* = comm_ring + 'a15::zero_neq_one + 'a14::comm_monoid_mult*)
  fix x :: "'a30::no_zero_divisors" (* = 'a1::zero + 'a3::times +
  assumes no_zero_divisors: "a \<noteq> 0 \<Longrightarrow> b \<noteq> 0 \<Longrightarrow> a * b \<noteq> 0"*)
  fix x :: "'a31::comm_semiring_1_cancel" (* = 'a10::comm_semiring + cancel_comm_monoid_add
    + 'a15::zero_neq_one + 'a14::comm_monoid_mult*)
  fix x :: "'a32::semiring_div" (* = comm_semiring_1_cancel + no_zero_divisors + div +
  assumes mod_div_equality: "a div b * b + a mod b = a"
    and div_by_0 [simp]: "a div 0 = 0"
    and div_0 [simp]: "0 div a = 0"
    and div_mult_self1 [simp]: "b \<noteq> 0 \<Longrightarrow> (a + c * b) div b = c + a div b"
    and div_mult_mult1 [simp]: "c \<noteq> 0 \<Longrightarrow> (c * a) div (c * b) = a div b"*)
  fix x :: "'a33::ring_div" (* = semiring_div + comm_ring_1
                  ======== FOR instantiation poly :: (field) ring_div ...
                               ==========================================*)
  value "x :: 'a33::ring_div"

  fix x :: "'a48::no_zero_divisors" (* = 'a1::zero + 'a3::times +
  assumes no_zero_divisors: "a \<noteq> 0 \<Longrightarrow> b \<noteq> 0 \<Longrightarrow> a * b \<noteq> 0"*)
  fix x :: "'a49::idom" (* = 'a29::comm_ring_1 + no_zero_divisors
                  ==== FOR instance poly :: (idom) idom ...
                           ================================*)
end

subsection {* Survey on division of polynomials ===============================================*}
text {* code
Polynomial.thy
  definition pdivmod_rel :: "'a::field poly \<Rightarrow> 'a poly \<Rightarrow> 'a poly \<Rightarrow> 'a poly \<Rightarrow> bool"
  where
    "pdivmod_rel x y q r \<longleftrightarrow>
      x = q * y + r \<and> (if y = 0 then q = 0 else (r = 0 \<or> degree r < degree y))"

  instantiation poly :: (field) ring_div
  begin
  definition div_poly where
    "x div y = (THE q. \<exists>r. pdivmod_rel x y q r)"
  definition mod_poly where
    "x mod y = (THE r. \<exists>q. pdivmod_rel x y q r)"
  :
  instance proof
  :
  end

  definition pdivmod :: "'a::field poly \<Rightarrow> 'a poly \<Rightarrow> 'a poly \<times> 'a poly"
  where
    "pdivmod p q = (p div q, p mod q)"

  (* THIS MAKES DIVISION EXECUTABLE, FINALLY ...*)
  lemma pdivmod_fold_coeffs [code]:
    "pdivmod p q = (if q = 0 then (0, p)
      else fold_coeffs (\<lambda>a (s, r).
        let b = coeff (pCons a r) (degree q) / coeff q (degree q)
        in (pCons b s, pCons a r - smult b q)
     ) p (0, 0))"

  gcd IMMEDIATELY REFERS TO mod
*}

subsection {* poly with various numerals =======================================================*}
text {* polynomials over the natural numbers *}
value "let p = [:1::nat, 2, 3:]; q = [:4, 5, 6:] in
p + q = [:5, 7, 9:]"
(*value "let p = [:1::nat, 2, 3:]; q = [:4, 5, 6:] in
p * q" 
Wellsortedness error:
Type nat not of sort {equal,idom}
No type arity nat :: idom*)
(*value "let p = [:1::nat, 2, 3:]; q = [:4, 5, 6:] in
p / q"
No type arity poly :: inverse*)
value "let p = [:1::nat, 2, 3:]; q = [:4, 5, 6:] in
p div q = [:1 / 2:]"                             --{* :: "real poly"*}
value "let p = [:1::nat, 2, 3:]; q = [:4, 5, 6:] in
p mod q = [:-1, -1 / 2:]"                        --{* :: "real poly"*}
value "let p = [:1::nat, 2, 3:]; q = [:4, 5, 6:] in
gcd p q = [:1:]"                                 --{* :: "real poly"*}

text {* polynomials over the integer numbers *}
value "let p = [:1::int, 2, 3:]; q = [:4, 5, 6:] in
p + q = [:5, 7, 9:]"
value "let p = [:1::int, 2, 3:]; q = [:4, 5, 6:] in
p * q = [:4, 13, 28, 27, 18:]"
(*value "let p = [:1::int, 2, 3:]; q = [:4, 5, 6:] in
p / q"
No type arity poly :: inverse*)
value "let p = [:1::int, 2, 3:]; q = [:4, 5, 6:] in
p div q = [:1 / 2:]"                             --{* :: "real poly"*}
value "let p = [:1::int, 2, 3:]; q = [:4, 5, 6:] in
p mod q = [:-1, -1 / 2:]"                        --{* :: "real poly"*}
value "let p = [:1::int, 2, 3:]; q = [:4, 5, 6:] in
gcd p q = [:1:]"                                 --{* :: "real poly"*}

text {* polynomials over the rational numbers *}
value "let p = [:(1::rat) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
p + q = [:13 / 10, 45 / 28, 31 / 18:]"
value "let p = [:(1::rat) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
p * q = [:2 / 5, 36 / 35, 221 / 126, 29 / 21, 20 / 27:]"
(*value "let p = [:(1::rat) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
p / q"
No type arity poly :: inverse*)
value "let p = [:(1::rat) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
p div q = [:15 / 16:]"
value "let p = [:(1::rat) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
p mod q = [:-1 / 4, -3 / 56:]"
value "let p = [:(1::rat) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
gcd p q = [:1:]"                                 --{* :: "real poly"*}

text {* polynomials over the real numbers *}
value "let p = [:(1::real) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
p + q = [:13 / 10, 45 / 28, 31 / 18:]"
value "let p = [:(1::real) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
p * q = [:2 / 5, 36 / 35, 221 / 126, 29 / 21, 20 / 27:]"
(*value "let p = [:(1::real) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
p / q"
No type arity poly :: inverse*)
value "let p = [:(1::real) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
p div q = [:15 / 16:]"
value "let p = [:(1::real) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
p mod q = [:-1 / 4, -3 / 56:]"
value "let p = [:(1::real) / 2, 3 / 4, 5 / 6:]; q = [:4 / 5, 6 / 7, 8 / 9:] in
gcd p q = [:1:]"
value "let p = [:(7::real) / 2, 7, 7 / 2:]; q = [:1 / 2, 0, -1 / 2:] in
gcd p q = [:1, 1:]"

text {* reals can be input as floating point numbers *}
value "let p = [:1.1::real, 2.2, 3.3:]; q = [:4.4, 5.5, 6.6:] in
p + q = [:11 / 2, 77 / 10, 99 / 10:]"

text {* polynomials over the complex numbers *}
value "let p = [:Complex 1 2, Complex 3 4, Complex 5 6:]; q = [:Complex 4 5, Complex 6 7, Complex 8 9:] in
p + q = [:Complex 5 7, Complex 9 11, Complex 13 15:]"
value "let p = [:Complex 1 2, Complex 3 4, Complex 5 6:]; q = [:Complex 4 5, Complex 6 7, Complex 8 9:] in
p * q = [:Complex -6 13, Complex -16 50, Complex -30 119, Complex -24 130, Complex -14 93:]"
(*value "let p = [:Complex 1 2, Complex 3 4, Complex 5 6:]; q = [:Complex 4 5, Complex 6 7, Complex 8 9:] in
p / q"
No type arity poly :: inverse*)
value "let p = [:Complex 1 2, Complex 3 4, Complex 5 6:]; q = [:Complex 4 5, Complex 6 7, Complex 8 9:] in
p div q = [:Complex (94 / 145) (3 / 145):]"
value "let p = [:Complex 1 2, Complex 3 4, Complex 5 6:]; q = [:Complex 4 5, Complex 6 7, Complex 8 9:] in
p mod q = [:Complex (-216 / 145) (-192 / 145), Complex (-108 / 145) (-96 / 145):]"
value "let p = [:Complex 1 2, Complex 3 4, Complex 5 6:]; q = [:Complex 4 5, Complex 6 7, Complex 8 9:] in
gcd p q = [:Complex 1 0:]"
value "let p = [:Complex 1 0, Complex 2 0, Complex 1 0:]; q = [:Complex -1 0, Complex 0 0, Complex 1 0:] in
gcd p q = [:Complex 1 0, Complex 1 0:]"

value "xxx"

section {* AD subsections of HOL/Library/Polynomial.thy ########################################*}
subsection {* AD Auxiliary: operations for lists (later) representing coefficients =============*}
subsection {* AD Almost everywhere zero functions ==============================================*}
subsection {* AD Definition of type @{text poly} ===============================================*}
text {* code
  typedef 'a poly = "{f :: nat \<Rightarrow> 'a::zero. almost_everywhere_zero f}"
    morphisms coeff Abs_poly
    unfolding almost_everywhere_zero_def by auto
*}
text {* !!! isar-ref p.241:
  "This is a Gordon/HOL-style type definition, a certain axiom scheme that 
  identifies a new type with a subset of an existing type. More
  precisely, the new type is defined by exhibiting an existing type
  @{text \<tau>}, a set @{text "A :: \<tau> set"}, and a theorem that proves
  @{prop "\<exists>x. x \<in> A"}.  Thus @{text A} is a non-empty subset of @{text
  \<tau>}, and the new type denotes this subset.
*}
term "coeff :: 'a::zero poly \<Rightarrow> (nat \<Rightarrow> 'a)"
term "Abs_poly :: (nat \<Rightarrow> 'a) \<Rightarrow> 'a::zero poly"


term "[:[:[:0, 1:], [:2:]:], [:[:3:]:]:]" --{*:: "'a poly poly poly"*}
term "[:[:[:0, 1::int:], [:2:]:], [:[:3:]:]:]:: int poly poly poly" --{*:: "'a poly poly poly"*}
term "(1::int)::int" --{**}
(*term "(1::int)::'a" --{*Failed to meet type constraint: | Term:  1 :: int | Type:  'a*}*)
(*term "(1::'a)::int" --{*Failed to meet type constraint: | Term:  1 :: int | Type:  'a*}*)
value "[:0::int,1,2,3:]" --{**}
value "[:[:0::int,1,2,3:],[:0::int,1,2,3:],[:1:],[:1:]:]" --{**}
term "xxx" --{**}


thm almost_everywhere_zeroI (*lemma proven above the definition*)

term "0 :: 'a::zero poly" --{*type OK*}
term "[:0:] :: 'a::zero poly" --{*type OK*}
(*term "[:[:0:]:] :: 'a::zero poly" 
  --{*ERROR: Failed to meet type constraint:Term:  [:[:0:]:] :: ??'a poly poly*}*)

(*term "1 :: 'a poly" 
  --{**ERROR: Failed to meet type constraint: Term:  1 :: ??'a Type:  'a poly*}*)
term "[:1:] :: 'a::{one,zero} poly" --{*type OK*}
(*term "[:[:1:]:] :: 'a::zero poly" 
  --{*ERROR: Failed to meet type constraint:Term:  [:[:1:]:] :: ??'a poly poly*}*)

text {* but this is indefinitely recursive... *}
term "0 :: 'a::zero poly" --{*type OK*}
term "0 :: 'a::zero poly poly" --{*type OK*}
term "0 :: 'a::zero poly poly poly" --{*type OK*}
term "0 :: 'a::zero poly poly poly poly" --{*type OK*}

term "xxx" --{**}

subsubsection {* AD @{text "morphisms coeff Abs_poly"} =========================================*}
(*For @{command (HOL) "typedef"}~@{text "t = A"} the newly introduced*)
text {* !!! isar-ref.p.242:
  bijection between the representing set @{text A} and the new type @{text t}.
  For @{text "(HOL) typedef"}~@{text "t = A"} the newly introduced
  type @{text t} is accompanied by a pair of morphisms to relate it to
  the representing set over the old type.  By default, the injection
  from type to set is called @{text Rep_t} and its inverse @{text
  Abs_t}.
  In the definition of poly we have @{text coeff} and @{text Abs_poly}.
*}
term Abs_poly (*... generated by definition of poly *)
term Rep_poly (*... NOT generated, because "coeff" has been specified instead *) 
term coeff    (*... generated by definition of poly *)

(* isar-ref.p.242:
general theorems ...              automatically specialised to definition ...*)
thm type_definition.Rep
thm type_definition.Abs_inverse   thm Abs_poly_inverse
thm type_definition.Rep_inverse   thm coeff_inverse (*... see "morphisms coeff"*)
thm type_definition.Abs_inject    thm Abs_poly_inject
thm type_definition.Rep_inject    thm coeff_inject  (*... see "morphisms coeff"*)
thm type_definition.Abs_induct    thm Abs_poly_induct
thm type_definition.Rep_induct    thm coeff_induct  (*... see "morphisms coeff"*)
thm type_definition.Abs_cases     thm Abs_poly_cases
thm type_definition.Rep_cases     thm coeff_cases   (*... see "morphisms coeff"*)
text {* 
  The automatically generated (and proven) theorems above are worth to be studied in detail.
*}

subsubsection {* AD @{text "unfolding almost_everywhere_zero_def by auto"} =====================*}
text {* !!! isar-ref.p.243
  AD pt.2: As mentioned above, "lifting" is the mapping @{text "A \<rightarrow> \<tau>"}, i.e.
  from the representing set @{text A} to the new type @{text \<tau>}, @{text poly}.

  isar-ref.p.32: @{text unfolding} is part of the Isar proof language and
  just applies the addressed theorem.
  The 3rd line in the definition  of poly proves that @{text P} holds for @{text \<tau>} 
  by lifting @{text P} from the representation. isar-ref.pdf p.242
*}

subsubsection {* @{text "setup_lifting (no_code) type_definition_poly"} ========================*}
thm type_definition_poly (* automatically generated by "typedef poly":
type_definition coeff Abs_poly {f. almost_everywhere_zero f}
type_definition Rep   Abs      A              ...isar-ref.p.251 *)
text {* !!! isar-ref.p.251 "12.3 Lifting package":
  The package
  configures transfer rules for equality and quantifiers on the type, and
  sets up the "lift_definition" command to work with the type.

  The abstract
  type implicitly defined by the theorem is declared as an abstract type
  in the code generator. This allows "lift_definition" to register (gener-
  ated) code certificate theorems as abstract code equations in the code
  generator.

  See an in example in subsection "AD The zero polynomial" below.
*}
(* !!! isar-ref.p.252 12.3 Lifting package
ALL OCCURRENCES OF lift_definition IN Polynomial.thy:

lift_definition zero_poly :: "'a poly"
  is "\<lambda>_. 0" by (rule almost_everywhere_zeroI) simp
lift_definition pCons :: "'a::zero \<Rightarrow> 'a poly \<Rightarrow> 'a poly"
  is "\<lambda>a p. nat_case a (coeff p)"
  using coeff_almost_everywhere_zero by (rule almost_everywhere_zero_nat_case)
lift_definition monom :: "'a \<Rightarrow> nat \<Rightarrow> 'a::zero poly"
  is "\<lambda>a m n. if m = n then a else 0"
  by (auto intro!: almost_everywhere_zeroI)

lift_definition plus_poly :: "'a poly \<Rightarrow> 'a poly \<Rightarrow> 'a poly"
  is "\<lambda>p q n. coeff p n + coeff q n"
lift_definition uminus_poly :: "'a poly \<Rightarrow> 'a poly"
  is "\<lambda>p n. - coeff p n"
lift_definition minus_poly :: "'a poly \<Rightarrow> 'a poly \<Rightarrow> 'a poly"
  is "\<lambda>p q n. coeff p n - coeff q n"
lift_definition smult :: "'a::comm_semiring_0 \<Rightarrow> 'a poly \<Rightarrow> 'a poly"
  is "\<lambda>a p n. a * coeff p n"
*)

(* !!! instantiation: unnamed context isar-ref.p.78:  5.2 Local theory targets
                    : isar-ref.p.90:  5.6.3 Locale interpretation: theory \<rightarrow> proof (prove)
ALL OCCURRENCES OF instantiation IN Polynomial.thy:

instantiation poly :: (zero) zero
... lift_definition zero_poly :: "'a poly"
instantiation poly :: ("{zero, equal}") equal
... definition [code]: "HOL.equal (p::'a poly) q \<longleftrightarrow> HOL.equal (coeffs p) (coeffs q)"
instantiation poly :: (comm_monoid_add) comm_monoid_add
... lift_definition plus_poly :: "'a poly \<Rightarrow> 'a poly \<Rightarrow> 'a poly"
... instance proof
... instance poly :: (cancel_comm_monoid_add) cancel_comm_monoid_add
instantiation poly :: (ab_group_add) ab_group_add
... lift_definition uminus_poly :: "'a poly \<Rightarrow> 'a poly"
instantiation poly :: (comm_semiring_0) comm_semiring_0
... definition "p * q = fold_coeffs (\<lambda>a p. smult a q + pCons 0 p) p 0"
... instance proof ... axioms comm_semiring_0
... instance poly :: (comm_semiring_0_cancel) comm_semiring_0_cancel ..
instantiation poly :: (comm_semiring_1) comm_semiring_1
... definition one_poly_def: "1 = pCons 1 0"
... instance proof ... show "1 * p = p"
... instance poly :: (comm_semiring_1_cancel) comm_semiring_1_cancel ..
... instance poly :: (comm_ring) comm_ring ..
... instance poly :: (comm_ring_1) comm_ring_1 ..
... instance poly :: (idom) idom
instantiation poly :: (linordered_idom) linordered_idom
... definition "x < y \<longleftrightarrow> pos_poly (y - x)"  ... \<le>, abs, sgn
... instance proof ...
instantiation poly :: (field) ring_div
... definition div_poly where "x div y = (THE q. \<exists>r. pdivmod_rel x y q r)" ... mod
... instance proof ... axioms ring_div
instantiation poly :: (field) gcd
... function gcd_poly :: "'a::field poly \<Rightarrow> 'a poly \<Rightarrow> 'a poly"
... instance ..
      proof (prove): step 0      
      goal (1 subgoal):
       1. OFCLASS('a poly, gcd_class)
*)
subsubsection {* investigate if "coeff" / "coeffs" finds univariate base case =================*}

value "[:0, [:0, [:0, 1::int:]:]:]" --{*  x * y * z  *}
value "coeff [:0, [:0, [:0, 1::int:]:]:] 0" --{*"Poly []"*}
value "coeff [:0, [:0, [:0, 1::int:]:]:] 1" --{*"Poly [Poly [], Poly [0, 1]]"*}

value "coeff (coeff [:0, [:0, [:0, 1::int:]:]:] 0) 0" --{*"Poly []" !!!*}
value "coeff (coeff [:0, [:0, [:0, 1::int:]:]:] 0) 1" --{*"Poly []" !!!*}
value "coeff (coeff [:0, [:0, [:0, 1::int:]:]:] 1) 0" --{*"Poly []"*}
value "coeff (coeff [:0, [:0, [:0, 1::int:]:]:] 1) 1" --{*"Poly [0, 1]"*}

value          "coeff (coeff (coeff [:0, [:0, [:0, 1::int:]:]:] 0) 0) 0" --{*"0"*}
(*value "coeff (coeff (coeff (coeff [:0, [:0, [:0, 1::int:]:]:] 0) 0) 0)" 
  --{*Clash of types "int" and "_ poly"*}*)
value "coeff (coeff (coeff [:0, [:0, [:0, 1::int:]:]:] 0) 0) 123" --{*"0"*}
value "coeff (coeff (coeff [:0, [:0, [:0, 1::int:]:]:] 0) 123) 0" --{*"0"*}
value "coeff (coeff (coeff [:0, [:0, [:0, 1::int:]:]:] 123) 0) 0" --{*"0"*}

value "coeff (coeff (coeff [:0, [:0, [:0, 2::int:]:]:] 1) 1) 1" --{*"2"*}
value "coeff (coeff (coeff [:0, [:0, [:0, 2::int:]:]:] 1) 1) 1" --{*"2"*}
value "coeff (coeff (coeff [:0, [:0, [:0, 2::int:]:]:] 1) 1) 1" --{*"2"*}



subsection {* AD Degree of a polynomial =======================================================*}
(* degree doesn't work for multivariate polynomials: all = 0: *)
value "degree [:0, [:0, [:0, 1::int:]:]:]" --{*"Suc 0" :: "nat"  ...    x * y * z*}
value "degree [:1, [:0, [:0, 1::int:]:]:]" --{*"Suc 0" :: "nat"  ...1 + x * y * z*}
value "degree [:[:[:0, 2::int:], 1:], 1:]" --{*"Suc 0" :: "nat"  ...2*x + y + z  *}
value "degree [:[:[:3, 0,  0, -1:], [:2:]:], [:0, 6, [:4::int:]:]:]" 
  --{*"Suc 0" :: "nat"  ...-1 * x^3 + 2 * y + 5*y^2 + 4 * y^2 * z + 3*}

subsubsection {* in ML decompose degree ------------------------------------------------------*}

subsection {* AD The zero polynomial  =========================================================*}
text {* code
  instantiation poly :: (zero) zero
  begin
  
  lift_definition zero_poly :: "'a poly"
    is "\<lambda>_. 0" by (rule almost_everywhere_zeroI) simp
                                (*proof (prove): step 0
                                
                                goal (1 subgoal):
                                 1. almost_everywhere_zero (\<lambda>_. 0)*)
  instance ..
                                (*proof (prove): step 0
                                
                                goal (1 subgoal):
                                 1. OFCLASS('a poly, zero_class)*)
  end
*}
text {* !!! 
  isar-ref.p.78: "5.2 Local theory targets": Unnamed context
  isar-ref.p.93: "5.7 Classes"
  isar-ref.p.95: instantiation, instance
  isar-ref.p.251: lift definition
  ~~/doc/classes.pdf
*}
print_classes (*see Output !*)

thm almost_everywhere_zeroI (*(\<And>i. ?n < i \<Longrightarrow> ?f i = 0) \<Longrightarrow> almost_everywhere_zero ?f*)

(* !!! isar-ref.p.252:*)
thm zero_poly.rsp      (* Lifting.invariant almost_everywhere_zero (\<lambda>_. 0) (\<lambda>_. 0) *)
thm zero_poly.transfer (* cr_poly (\<lambda>_. 0) 0      || "cr_poly" ... only occurrence  *)
thm zero_poly.rep_eq   (* coeff 0 = (\<lambda>_. 0) *)
thm zero_poly.abs_eq   (* 0 = Abs_poly (\<lambda>_. 0) *)

subsection {* AD List-style constructor for polynomials  =======================================*}
text {* code
  lift_definition pCons :: "'a::zero \<Rightarrow> 'a poly \<Rightarrow> 'a poly"
    is "\<lambda>a p. nat_case a (coeff p)"
    using coeff_almost_everywhere_zero by (rule almost_everywhere_zero_nat_case)
  
  lemmas coeff_pCons = pCons.rep_eq
*}
term nat_case --"  :: 'a \<Rightarrow> (nat \<Rightarrow> 'a) \<Rightarrow> nat \<Rightarrow> 'a"
value "nat_case "
thm coeff_almost_everywhere_zero    --"almost_everywhere_zero (coeff ?p)"
(* disappeared at Isabelle2003-2\<longrightarrow>2014-RC02
thm almost_everywhere_zero_nat_case 
  --"almost_everywhere_zero ?f \<Longrightarrow> almost_everywhere_zero (nat_case ?a ?f)"*)

thm pCons.rep_eq (*isar-ref.p.252: The equation is a code certificate that
  defines f using the representation function*)

value "pCons (3::int) (0::int poly)"
value "pCons (2::int) (pCons (3::int) (0::int poly))"
value "pCons (1::int) (pCons (2::int) (pCons (3::int) (0::int poly)))"
  --"Poly [1, 2, 3] :: int poly"
value "xxx" --""

subsubsection {* in ML decompose pCons ---------------------------------------------------------*}
(* we define all in "real", because "pdivmod" switches from "int" to "real" *)
value "[:1,2,3::real:]" (*"Poly [1, 2, 3]" :: "real poly"*)
ML {*
datatype 'a poly = Poly of 'a list;
Poly [1.0, 2.0, 3.0];  (* = Poly [1.0, 2.0, 3.0]: real poly*)
*}
value "pCons" --{**}
value "pCons 1 (pCons 2 (pCons 3 (0::real poly)))" 
                                              (*"Poly [1, 2, 3]" :: "real poly"*)
ML {*
fun pCons x (Poly xs) = Poly (x :: xs);
pCons 1.0 (pCons 2.0 (pCons 3.0 (Poly []))) (* = Poly [1.0, 2.0, 3.0]: real poly*);
*} 

value "coeff" --{*"\<lambda>u. nth_default 0 (coeffs u)" :: "'a poly \<Rightarrow> nat \<Rightarrow> 'a"*}
value "let p = pCons 1 (pCons 2 (pCons 3 (0::real poly))) in 
  coeff p 2"                      (*"3" :: "real"*)
ML {*
fun coeff (Poly xs) i = if 0 <= i andalso i < length xs then nth xs i else 0.0;
fun coeff' (Poly xs) i = if 0 <= i andalso i < length xs then nth xs i else 0;
coeff (Poly [1.0, 2.0, 3.0]) 2; (* = 3.0: real*)
coeff (Poly [1.0, 2.0]) 2; (* = 0.0: real*)
*}

(*can we have "int poly poly" in SML?*)
ML {*
pCons (* = fn: 'a -> 'a poly -> 'a poly*);
              pCons 1 (Poly [])                       (* : int poly*);
       pCons (pCons 1 (Poly [])) (Poly [])            (* : int poly poly*);
pCons (pCons (pCons 1 (Poly [])) (Poly [])) (Poly []) (* : int poly poly poly*);
*} ML {*
*} ML {*
*} ML {*
pCons 1 (pCons 2 (pCons 3 (Poly []))) (* : int poly*)
*} ML {*
val p = pCons 1 (pCons 2 (pCons 3 (Poly []))) : int poly
*} ML {*
pCons 0 p
*} ML {*
*} ML {*
*} 

value "Cons 1 (Cons 1 (Cons 1 Nil))"
value "Cons 1 Nil"
value "1 # []"

subsection {* AD List-style syntax for polynomials  ============================================*}

subsection {* AD Representation of polynomials by lists of coefficients ========================*}
text {* !!!
  So far, the definition does not know, that the representation is by lists:
  "coeff" is just a function with a certain signature created by typedef 
  and does not know about "coeffs" and a constructor "Poly".

  The representation is introduced as follows:
*}
text {* code
  definition coeffs :: "'a poly \<Rightarrow> 'a::zero list"
  where
    "coeffs p = (if p = 0 then [] else map (\<lambda>i. coeff p i) [0 ..< Suc (degree p)])"
Type unification failed: No type arity Preparations.poly :: zero (*... HOW ORGANISE DEMO ???*)
*}

(*AS LONG AS typedef 'a poly WAS *NOT* A TEXT BUT CODE, WE HAD PROBLEMS...*)
term "coeff" --":: 'a Preparations.poly \<Rightarrow> nat \<Rightarrow> 'a"
(*term "coeff [:0,1,2:]"
Type unification failed: Clash of types "_ Polynomial.poly" and "_ Preparations.poly"*)
term "[:00,11,22::int:]"
term "coeff [:00,11,22::int:]"
value "coeff [:00,11,22::int:] 1" --"11"
value "coeff [:00,1,2:] 1" --{*"nth_default 0
  (coeffs (Poly (cCons 0 
    (coeffs (Poly (cCons 1 
      (coeffs (Poly (cCons (1 + 1) 
        (coeffs (Poly [])))))))))))
  (Suc 0)" :: "'a"*}
term "coeffs" --":: 'a poly \<Rightarrow> 'a list"
term "cCons" --":: 'a \<Rightarrow> 'a list \<Rightarrow> 'a list"
term "Poly" --":: 'a list \<Rightarrow> 'a poly"
term "Poly [1,2,3::int]" --"Poly [1, 2, 3]"
term "Poly [1,2,3::int] + 0" --"Poly [1, 2, 3] + 0"
term "Poly [1,2,3::int] + Poly [10,20,33::int]" --"Poly [1, 2, 3] + Poly [10, 20, 33]"
(*value "Poly [1,2,3::int] + Poly [10,20,33::int]" --"Poly [1, 2, 3] + 0"
Abstraction violation: constant Poly                                     ???FH???*)
term "xxx" --""
value "xxx" --""

text {* !!! AD definition coeffs:
  @{text "p = 0"} addresses the zero polynomial.
  @{text "[0 ..< Suc (degree p)]"} is Isabelle syntax for intervals, see HOL/Set_Interval.thy,
  and means @{text "{x. x < u}"} where @{text "u = degree p) + 1"}.

  Thus the @{text "definition coeffs"} establishes the connection to 
  @{text "typedef 'a poly"}, which in turn defined @{text "coeff"} as one of the
  two morphisms.

  isar-ref.p.83:
  @{text "definition coeffs"} is not implemented as @{text "typedef"}, because
  it introduces just a function constant and not a new type.
*}
subsubsection {* in ML decompose coeffs --------------------------------------------------------*}

value "coeffs" --{*"coeffs" :: "'a poly \<Rightarrow> 'a list"*}
value "let p = pCons 1 (pCons 2 (pCons 3 (0::real poly))) in 
  coeffs p"                      (*"[1, 2, 3]" :: "real list"*)
ML {*
fun coeffs (Poly xs) = xs;
coeffs (Poly [1.0, 2.0, 3.0]); (* = [1.0, 2.0, 3.0]: real list*)
coeffs; (* = fn: 'a poly -> 'a list*)
*} 

subsubsection {* Algoritymically relevant representations of polynomials =======================*}
lemmas eval_power_numeral = power_numeral_even power_numeral_odd
lemma -- {* Univariate polynomial in implicit and algebraic representation *}
  fixes x :: "'a::comm_ring_1"
  shows "x^2 + 2 * x + 3 = poly [:3, 2, 1:] x"
 by (simp add: algebra_simps power_numeral_even power_numeral_odd)

subsubsection {* To what extent does Polynomial.thy need the representation ?===================*}
text {* see further subsubsection with same headline below:
        these show the location in respective subsections in Polynomial.thy, 
        where ERRORs occurred when cutting these subsections in Polynomial.thy: *}
text {*
  # cut subsections "Representation.." + "Fold.." + "Canonical..eval": 
    ERROR in "Monomials" coeffs_monom, ...
  # ... + cut in "Monomials" coeffs_monom, ...: 
    ERROR in "Addition" coeffs_plus_eq_plus_coeffs, ...
  # ... + ... + cut in "Addition" coeffs_plus_eq_plus_coeffs, ...: 
    ERROR in "Multiplication" coeffs_plus_eq_plus_coeffs, ...
*}

subsection {* AD Fold combinator for polynomials ===============================================*}
text {* !!! we follow the lemmas, the further usages
  in order to understand the meaning of fold_coeffs:
*}
(*fold_coeffs_0_eq*)
value "fold_coeffs"   --" :: ('a \<Rightarrow> 'b \<Rightarrow> 'b) \<Rightarrow> 'a poly \<Rightarrow> 'b \<Rightarrow> 'b"
value "fold_coeffs pCons 0 [:1,2,3::int:]" --"Poly [1, 2, 3]"
value "fold_coeffs pCons 1 [:1,2,3::int:]" --"Poly [1, 1, 2, 3]"
value "fold_coeffs (op +) 0 [:1,2,3::int:]" --"Poly [1, 2, 3]"
value "fold_coeffs (op +) 10 [:1,2,3::int:]" --"Poly [11, 2, 3]"
value "fold_coeffs (op *) 0 [:1,2,3::int:]" --"Poly [1, 2, 3]"
value "fold_coeffs (op *) 10 [:1,2,3::int:]" --"Poly [10, 20, 30]"

(*fold_coeffs_pCons_eq*)
(*fold_coeffs_pCons_0_0_eq*)
(*fold_coeffs_pCons_coeff_not_0_eq*)
(*fold_coeffs_pCons_not_0_0_eq*)
value "fold_coeffs f (pCons a p)" --""
value "fold_coeffs (op +) (pCons 1 [:1,2,3::int:]) " --""
value "fold_coeffs (op +) (pCons 1 [:1,2,3::int:]) 1" --"8"
value "fold_coeffs (op +) (pCons 1 [:0::int:]) 1" --"2"
value "fold_coeffs (op +) (pCons 2 [:0::int:]) 2" --"4 ...? equal !"

value "f a \<circ> fold_coeffs f p" --""
value "(op +) 1 \<circ> fold_coeffs (op +) [:1,2,3::int:]" --""
value "((op +) 1 \<circ> fold_coeffs (op +) [:1,2,3::int:]) 1" --"8"
value "((op +) 1 \<circ> fold_coeffs (op +) [:0::int:]) 1" --"2"
value "((op +) 2 \<circ> fold_coeffs (op +) [:0::int:]) 2" --"4 ...? equal !"

(*further usage: Horner schema*)
value "\<lambda>a f x. a + x * f x"   --"  :: 'a \<Rightarrow> ('a \<Rightarrow> 'a) \<Rightarrow> 'a \<Rightarrow> 'a"
value "fold_coeffs (\<lambda>a f x. a + x * f x) [:1,2,3::int:] (\<lambda>x. 0) 0" --"1"
value "fold_coeffs (\<lambda>a f x. a + x * f x) [:1,2,3::int:] (\<lambda>x. 0) 1" --"6"
value "fold_coeffs (\<lambda>a f x. a + x * f x) [:1,2,3::int:] (\<lambda>x. 0) 2" --"17"

(*further usage: fold_coeffs_monom*)
value "monom (4::int) 2" --{*"Poly [0, 0, 4]"*}

value "fold_coeffs f (monom a n)" --{**}
value "fold_coeffs (op +) (monom (4::int) 2) 3" --{*"7"*}

value "f 0 ^^ n \<circ> f a" --{**}
value "(((op +) 0) ^^ 2 \<circ> (op +) (4::int)) 3" --{*"7"*}
value "xxx" --{**}

(*further usage: definition p * q *)
value "fold_coeffs (\<lambda>a p. smult (a::int) q + pCons 0 p) p 0" --{**}
value "fold_coeffs (\<lambda>a p. smult (a::int) [:0:] + pCons 0 p) [:0:] 0" --"Poly []"
value "fold_coeffs (\<lambda>a p. smult (a::int) [:1:] + pCons 0 p) [:1:] 0" --"Poly [1]"
value "fold_coeffs (\<lambda>a p. smult (a::int) [:1,1:] + pCons 0 p) [:1,1:] 0" --"Poly [1, 2, 1]"

(*further usage: definition synthetic_divmod*)
value "synthetic_divmod [:1,1::int:] 1" --"(Poly [1], 2)"
value "synthetic_divmod [:2,1::int:] 1" --"(Poly [1], 3)"
value "synthetic_divmod [:1,2::int:] 1" --"(Poly [2], 3)"
value "synthetic_divmod [:1,1::int:] 2" --"(Poly [1], 3)"

value "synthetic_divmod [:2,2::int:] 2" --"(Poly [2], 6)"
value "xxx" --{**}

value "fold_coeffs (\<lambda>a (q, r). (pCons r q, a + c * r)) p (0::int poly, 0::int)" --{**}
value "fold_coeffs (\<lambda>a (q, r). (pCons r q, a + c * r)) p (0::int poly, 0::int)" --{**}
value "xxx" --{**}

subsubsection {* in ML decompose fold_coeffs ---------------------------------------------------*}

value "foldr" --{*"\<lambda>u ua. fold u (rev ua)" ::         "('a \<Rightarrow> 'b \<Rightarrow> 'b) \<Rightarrow> 'a list \<Rightarrow> 'b \<Rightarrow> 'b"*}
ML {*
fun id x = x
*} ML {*
fun foldr (_ : 'a -> 'b -> 'b) ([] : 'a list) = (id : 'b -> 'b)
  | foldr f (x :: xs) = (f x) o (foldr f xs); (* = fn: ('a -> 'b -> 'b) -> 'a list -> 'b -> 'b*)
*} 
ML {*
fun fold_coeffs f p = foldr f (coeffs p) (* = fn: ('a -> 'b -> 'b) -> 'a poly -> 'b -> 'b*);
*} ML {*

*} ML {*
*} ML {*
*} 

value "xxx" --{**}
value "xxx" --{**}

subsection {* AD Canonical morphism on polynomials -- evaluation ===============================*}
value "poly" --"  :: 'a poly \<Rightarrow> 'a \<Rightarrow> 'a"
value "poly [:1,2,3::int:] 0" --"1"
value "poly [:1,2,3::int:] 1" --"6"
value "poly [:1,2,3::int:] 2" --"17"

subsubsection {* Examples from Poly_Example.thy sent by FH early 2013 -------------------------*}
thm power_numeral_even
thm power_numeral_odd

lemma (*1*)-- {* Univariate polynomial in implicit and algebraic representation *}
  fixes x :: "'a::comm_ring_1"
  shows "x^2 + 2 * x + 3 = poly [:3, 2, 1:] x"
  by (simp add: algebra_simps eval_power_numeral)

lemma (*2*)-- {* Multivariate polynomial in implicit and algebraic, nested representation *}
  fixes x y :: "'a::comm_ring_1"
  shows "x^2 + 2 * y + 3 = poly [:poly [:3, 0, 1:] x, 2:] y"
  by (simp add: algebra_simps eval_power_numeral)

lemma (*3*)-- {* Multivariate polynomial in implicit and algebraic, 
  formally completed nested representation *}
  fixes x y :: "'a::comm_ring_1"
  shows "x^2 + 2 * y + 3 = poly [:poly [:3, 0, 1:] x, poly [:2:] x:] y"
  by (simp add: algebra_simps eval_power_numeral)

lemma (*4*)-- {* Multivariate polynomial in implicit
  and algebraic curried representation with lifting of secondary variable(s) *}
  fixes x y :: "'a::comm_ring_1"
  shows "x^2 + 2 * y + 3 = poly (poly [:[:3, 0, 1:], [:2:]:] [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)

lemma (*5*)-- {* Multivariate polynomial in implicit
  and algebraic curried representation with lifting of secondary variable(s) *}
  fixes x y z :: "'a::comm_ring_1"
  shows "x^2 + 2 * y + 3 + y * z =
    poly (poly (poly [:[:[:3, 0, 1:], [:2:]:], [:0, [:1:]:]:] [:[:z:]:]) [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)

subsubsection {* Simple investigation of examples ---------------------------------------------*}
(* negative coefficients*)
lemma -- {* Univariate polynomial in implicit and algebraic representation *}
  fixes x :: "'a::comm_ring_1"
  shows "-1*x^2 + 2 * x - 3 = poly [:-3, 2, -1:] x"
  by (simp add: algebra_simps eval_power_numeral)

(* trials on evaluation *)
value "[:3, 0, 1::int:]" --"Poly [3, 0, 1]" value "[:2::int:]" --"Poly [2]"

value "[:0, 0, 1::int:]" --"Poly [0, 0, 1]" value "[:0, 0, -1::int:]" --"Poly [0, 0, 1]"
value "poly [:0, 0, 1::int:] x" --""        value "poly [:0, 0,-1::int:] y" --""
term  "poly [:0, 0, 1::int:] x" --""        term  "poly [:0, 0,-1::int:] y" --""

(* exchange variables *)
lemma
  fixes x y :: "'a::comm_ring_1"
  shows "y^3 + 2 * x + 3 = poly (poly [:[:3, 0,  0, 1:], [:2:]:] [:x:]) y" (*x <-> y*)
  by (simp add: algebra_simps eval_power_numeral)

subsubsection {* Example from the last mail to Tobias Nipkow ----------------------------------*}
term "x^2 - y^2" (* numerator... *)

term "             poly [:poly [:0, 0, 1:] x, poly [:0:] x, poly [:-1:] x:] y"
lemma (*3*)-- {* Multivariate polynomial in implicit and algebraic, 
  formally completed nested representation *}
  fixes x y :: "'a::comm_ring_1"
  shows "x^2 - y^2 = poly [:poly [:0, 0, 1:] x, poly [:0:] x, poly [:-1:] x:] y"
  by (simp add: algebra_simps eval_power_numeral)

term "             poly (poly ([:[:0, 0, 1:], [:0:], [:-1:]:]) [:y:]) x"
lemma (*4*)-- {* Multivariate polynomial in implicit
  and algebraic curried representation with lifting of secondary variable(s) *}
  fixes x y :: "'a::comm_ring_1"
  shows "x^2 - y^2 = poly (poly ([:[:0, 0, 1:], [:0:], [:-1:]:]) [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)

term "x^2 - x*y" (* denominator... *)

term "              poly [:poly [:0, -1, 1:] x, poly [:-1:] x:] y"
lemma (*3*)-- {* Multivariate polynomial in implicit and algebraic, 
  formally completed nested representation *}
  fixes x y :: "'a::comm_ring_1"
  shows "x^2 - x*y = poly [:poly [:0, -1, 1:] x, poly [:1:] x:] y"
  apply (simp add: algebra_simps eval_power_numeral)
  sorry (* ??? *)

term "              poly (poly ([:[:0, -1, 1:], [:1:]:]) [:y:]) x"
lemma (*4*)-- {* Multivariate polynomial in implicit
  and algebraic curried representation with lifting of secondary variable(s) *}
  fixes x y :: "'a::comm_ring_1"
  shows "x^2 - x*y = poly (poly ([:[:0, -1, 1:], [:1:]:]) [:y:]) x"
  apply (simp add: algebra_simps eval_power_numeral)
  sorry (* ??? *)

subsubsection {* Decompose example (*4*) from Poly_Examples.thy--------------------------------*}
(* a slight variant of example (*4*) *)
lemma
  fixes x y :: "'a::comm_ring_1"
  shows "x^3 + 2 * y + 3 = poly (poly [:[:3, 0,  0, 1:], [:2:]:] [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)

(*DECOMPOSE above poly into elements*)
                         term "poly (poly [:[:3, 0,  0, 1:], [:2:]:] [:y:]) x"
                         term "     (poly [:[:3, 0,  0, 1:], [:2:]:] [:y:])  "
                         term "poly         [:3, 0,  0, 1:]                 x"
lemma
  fixes x y :: "'a::comm_ring_1"
  shows "x^3 (*+ 2 * x*) + 3 = poly         [:3, 0,  0, 1:]                 x"
  by (simp add: algebra_simps eval_power_numeral)

                         term "poly (poly [:[:3, 0,  0, 1:], [:2:]:] [:y:]) x"
                         term "      poly [: 0             ,   2  :]   y     "
lemma
  fixes x y :: "'a::comm_ring_1"
  shows "(*x^3 +*) 2 * y (*+ 3*) =   poly [: 0             ,   2  :]   y     "
  by (simp add: algebra_simps eval_power_numeral)

                         term "poly (poly [:[:3, 0,  0, 1:], [:2:]:] [:y:]) x" --{*:: "'a"*}
                         term "     (poly [:[:3, 0,  0, 1:], [:2:]:] [:y:])  " --{*:: "'a poly"*}
(*lemma
  fixes x y :: "'a::comm_ring_1"
  shows "(*x^3 +*) 2 * y (*+ 3*) =   poly [:[:3, 0,  0, 1:], [:2:]:] [:y:]     "
  by (simp add: algebra_simps eval_power_numeral)
Type unification failed
Operator:  op = (2 * y) :: 'a \<Rightarrow> bool
Operand:   poly [:[:3, 0, 0, 1:], [:2:]:] [:y:] :: 'a poly*)

subsubsection {* Decompose last example (*5*) from Poly_Examples.thy --------------------------*}
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * x^3 + 2 * y + 4 * y * z + 3 =              (* ^3 DECOMPOSED *)
      poly (poly (poly [:[:[: 3, 0, 0, -1:], [:2:]:], [: 0, [:4:]:]:] [:[:z:]:]) [:y:]) x"
(*    poly (=     =    |=|=| x0,x2,x2, x3-|                      =|=|                 ) x
           (poly (=    [=[:-------y0-------, --y1-:], [:y0, --y1-:]=|          ) [:y:])  
           (     (poly [:-------------z0------------, ----z1-------:] [:[:z:]:])      )  *)
    by (simp add: algebra_simps eval_power_numeral)

term "poly (poly (poly [:[:[: 3, 0, 0, -1:], [:2:]:], [: 0, [:4:]:]:] [:[:z:]:]) [:y:]) x"--{*:: "'a"*}
(*    poly (=    (=    [=[=[:x0,x2,x2, x3:]                      =]=]          )      ) x *)
term "poly (poly (poly [:[:[: 3, 0, 0, -1:], [:2:]:], [: 0, [:4:]:]:] [:[:z:]:]) [:y:])"--{*:: "'a \<Rightarrow> 'a"*}
term "     (poly (poly [:[:[: 3, 0, 0, -1:], [:2:]:], [: 0, [:4:]:]:] [:[:z:]:]) [:y:])"--{*:: "'a poly"*}
(*         (poly (=    [=[:-------y0-------, --y1-:], [:y0, --y1-:]=|          ) [:y:])   *)
term "     (poly (poly [:[:[: 3, 0, 0, -1:], [:2:]:], [: 0, [:4:]:]:] [:[:z:]:])      )"--{*:: "'a poly \<Rightarrow> 'a poly"*}
term "     (     (poly [:[:[: 3, 0, 0, -1:], [:2:]:], [: 0, [:4:]:]:] [:[:z:]:])      )"--{*:: "'a poly poly"*}
(*         (     (poly [:-------------z0------------, ----z1-------:] [:[:z:]:])      )   *)
term "     (     (poly [:[:[: 3, 0, 0, -1:], [:2:]:], [: 0, [:4:]:]:]          )      )"--{*:: "'a poly poly \<Rightarrow> 'a poly poly"*}
term "     (     (     [:[:[: 3, 0, 0, -1:], [:2:]:], [: 0, [:4:]:]:]          )      )"--{*:: "'a poly poly poly"*}
(*         (     (     [:-------------z0------------, ----z1-------:]          )      )   *)
(*         (     (     [=[:-------y0-------, --y1-:], [:y0, --y1-:]=|          )      )   *)
(*         (     (     [=[:[:x0,x2,x2, x3:], --y1-:], [:y0, --y1-:]=|          )      )   *)
term "     (     (       [:[: 3, 0, 0, -1:], [:2:]:]                           )      )"--{*:: "'a poly poly"*}
term "     (     (         [: 3, 0, 0, -1:]                                    )      )"--{*:: "'a poly"*}


term "     (     (       [:[: 3, 0, 0, -1:], [:2:]:], [: 0, [:4:]:]            )      )"--{*:: "'a poly poly \<times> 'b poly poly"*}
term "     (     (         [: 3, 0, 0, -1:], [:2:]                             )      )"--{*:: "'a poly \<times> 'b poly"*}
term "     (     (         [: 3, 0, 0, -1:], [:2:], [:222:]                    )      )"--{*:: "'a poly \<times> 'b poly \<times> 'c poly"*}

text {* earlier trials ........................................................................*}
term "poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:]:], [:0, [:4:]:]:] [:[:z:]:]) [:y:]) x"
term "poly                 [:3, 0,  0, -1:]                                            x"
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * x^3 (*+ 2 * y + 4 * y * z*) + 3=
      poly                 [:3, 0,  0, -1:]                                            x"
  by (simp add: algebra_simps eval_power_numeral)

term "poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:]:], [:0, [:4:]:]:] [:[:z:]:]) [:y:]) x" (* :: "'a"*)
term "     (poly (       [:[:3, 0,  0, -1:], [:2:]:]                          )      )  " (* :: "'a poly \<Rightarrow> 'a poly"*)
term "     (poly (       [:[:3, 0,  0, -1:], [:2:]:]                          ) [:y:])  " (* :: "'a poly"*)
term "poly (poly (       [:[:3, 0,  0, -1:], [:2:]:]                          ) [:y:]) x" (* :: "'a"*)
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * x^3 + 2 * y + (*4 * y * z +*) 3 =
      poly (     (poly   [:[:3, 0,  0, -1:], [:2:]:]                          ) [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)

term "poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:]:], [:0, [:4:]:]:] [:[:z:]:]) [:y:]) x" (* :: "'a"*)
term "poly (poly (       [:[:3, 0,  0, -1:], [:2:]:]                          ) [:y:]) x" (* :: "'a"*)
term "poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:]:], [:   [:4:]:]:] [:[:z:]:]) [:y:]) x" (* :: "'a"*)
(*                     |----------------------------, -------------|                    *)
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * x^3 + 2 * y + 4 * (*y **) z + 3 =
      poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:]:], [:   [:4:]:]:] [:[:z:]:]) [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)

term "poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:], [:5:]:], [:   [:4:]:]:] [:[:z:]:]) [:y:]) x"
(*    poly (               | 3, 0,  0, -x^3|                                                ) x*)
(*    poly (poly (       | xxxxxxxxxxxxxxxx,   2y ,   5y^2|                          ) yyyyy  x*)
(*    poly (poly (poly | yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy, -------4z----| zzzzzzzzz) yyyyy  x*)
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * x^3 + 2 * y + 5*y^2 + 4 * (*y **) z + 3 =
      poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:], [:5:]:], [:   [:4:]:]:] [:[:z:]:]) [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)

term "poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:], [:5:]:], [:0, [:4:]:]:] [:[:z:]:]) [:y:]) x"
(*    poly (               | 3, 0,  0, -x^3|                                                ) x*)
(*    poly (poly (       | xxxxxxxxxxxxxxxx,   2y ,   5y^2|                          ) yyyyy  x*)
(*    poly (poly (poly | yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy, --y----4z----| zzzzzzzzz) yyyyy  x*)
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * x^3 + 2 * y + 5*y^2 + 4 * y * z + 3 =
      poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:], [:5:]:], [:0, [:4:]:]:] [:[:z:]:]) [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)

term "poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:], [:5:]:], [:0, 0, [:4:]:]:] [:[:z:]:]) [:y:]) x"
(*    poly (               | 3, 0,  0, -x^3|                                                   ) x*)
(*    poly (poly (       | xxxxxxxxxxxxxxxx,   2y ,   5y^2|                             ) yyyyy  x*)
(*    poly (poly (poly | yyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyyy, --y--y----4z----| zzzzzzzzz) yyyyy  x*)
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * x^3 + 2 * y + 5*y^2 + 4 * y^2(*lemma poly_pCons*) * z + 3 = 
      poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:], [:5:]:], [:0, 0, [:4:]:]:] [:[:z:]:]) [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)

term "poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:]:], [:0, 6, [:4:]:]:] [:[:z:]:]) [:y:]) x"
(*    poly (               | 3, 0,  0, -x^3|                                            ) x*)
(*    poly (poly (       | xxxxxxxxxxxxxxxx,   2y  |                             ) yyyyy  x*)
(*    poly (poly (poly | yyyyyyyyyyyyyyyyyyyyyyyyyyy, --y--y----4y^2z-| zzzzzzzzz) yyyyy  x*)
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * x^3 + 6 * y * z + 4 * y^2 * z + 3 = 
      poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:]:], [:0, 6, [:4:]:]:] [:[:z:]:]) [:y:]) x"
(*by (simp add: algebra_simps eval_power_numeral)  ..TODO*)
sorry

subsubsection {* compose x * y * z ----------------------------------------------------------*}

term "poly (     ([:0,      1  :])      ) x"
term "poly (poly ([:0, [:0, 1:]:]) [:y:]) x"
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "x * y = poly (poly ([:0, [:0, 1:]:]) [:y:]) x"
    by (simp add: algebra_simps eval_power_numeral)

term "poly (     ([:1,      1  :])      ) x" --{*:: "'a"*}
term "poly (     ([:1, [:1, 1:]:])      ) x" --{*"'a poly"*}
term "poly (poly ([:1, [:1, 1:]:]) [:y:]) x" --{*:: "'a"*}

term "poly (poly (poly ([:0, [:0, [:0, 11:]:]:]) [:[:z:]:]) [:y:]) x"
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "4 * x * y * z = poly (poly (poly ([:0, [:0, [:0, 4:]:]:]) [:[:z:]:]) [:y:]) x"
    by (simp add: algebra_simps eval_power_numeral)

term "poly (poly (poly ([:1(*2///*), [:0, [:0, 1:]:]:]) [:[:z:]:]) [:y:]) x"
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "1(*2///*) + x * y * z = poly (poly (poly ([:1, [:0, [:0, 1:]:]:]) [:[:z:]:]) [:y:]) x"
    by (simp add: algebra_simps eval_power_numeral)
value "[:1, [:0, [:0, 1::int:]:]:]" 
                            --{*"Poly [Poly [Poly [1]], Poly [Poly [], Poly [0, 1]]]"
                                             Poly |-|         Poly ||  Poly |-, -|
                                       Poly |--------|  Poly |-------, -----------|
                                 Poly |---------------,----------------------------|*}

(*/------------------------- trials for Wolfgang -----------------------\*)
(*lemmas eval_power_numeral = power_numeral_even power_numeral_odd*)

term "[:0, 1:]" --{*:: "'a poly"*}
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "x = poly [:0, 1:] x"
    by (simp add: algebra_simps eval_power_numeral)

term "[:0, [:0, 1:]:]" --{*:: "'a poly poly"*}
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "x * y = poly (poly [:0, [:0, 1:]:] [:y:]) x"
    by (simp add: algebra_simps eval_power_numeral)

term "[:0, [:0, [:0, 1:]:]:]" --{*:: "'a poly poly poly"*}
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "x * y * z = poly (poly (poly [:0, [:0, [:0, 1:]:]:] [:[:z:]:]) [:y:]) x"
    by (simp add: algebra_simps eval_power_numeral)

term "etc" --{**}

term "[:0, 1:]" --{*:: "'a poly"*}
term "[:0, [:0, 1:]:]" --{*:: "'a poly",         'a instantiiert mit "'a poly"*}
term "[:0, [:0, [:0, 1:]:]:]" --{*:: "'a poly",  'a instantiiert mit "'a poly poly"*}

value "[:0, 1:] + [:0, 1::int:]"
value "[:0, 1:] + [:0, [:0, 1::int:]:]"
value "[:0, 1:] + [:0, [:0, 1:]:] + [:0, [:0, [:0, 1::int:]:]:]"

(*\------------------------- trials for Wolfgang -----------------------/*)

subsubsection {* compose x + y + z ----------------------------------------------------------*}

term "[:0, 1:]" --{*:: "'a poly"*}
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "x = poly [:0, 1:] x"
    by (simp add: algebra_simps eval_power_numeral)

term "[:[:0, 1:], 1:]" --{*:: "'a poly"*}
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "x + y = poly (poly [:[:0, 1:], 1:] [:y:]) x"
    by (simp add: algebra_simps eval_power_numeral)

term "[:[:[:0, 1:], 1:], 1:]" --{*:: "'a poly poly poly"*}
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "2*x + y + z = poly (poly (poly [:[:[:0, 2:], 1:], 1:] [:[:z:]:]) [:y:]) x"
    by (simp add: algebra_simps eval_power_numeral)
value "[:[:[:0, 2::int:], 1:], 1:]" 
                  --{*"Poly [Poly [Poly [0, 2], Poly [1]], Poly [Poly [1]]]"
                                   Poly |-,--|  Poly |-|         Poly |-|
                             Poly |-----------,---------|  Poly |--------|
                       Poly |----------------------------,----------------|*}

(* type correct terms ... *)
term "[:[:[:0, 1:], 2:], 3:]"                       --{*:: "'a poly poly poly"*}
term "poly (poly (poly [:[:[:0, 1:], 2:], 3:] [:[:z:]:]) [:y:]) x" --{*:: "'a"*}

(*... cannot be evaluated ...
value "poly (poly (poly [:[:[:0, 1:], 2:], 3:] [:[:z:]:]) [:y:]) x"
  ERROR: Type 'a poly not of sort comm_semiring_0 *)

(*... unless the recursive nesting is completed to equal depth:*)
value "[:[:[:0, 1::int:], 2:], 3:]"             (*...incomplete*)
  --{*"Poly [Poly [Poly [0, 1], Poly [2]], Poly [Poly [3]]]"
  :: "int poly poly poly"*}
value "[:[:[:0, 1::int:], [:2:]:], [:[:3:]:]:]" (*...completed*)
  --{*"Poly [Poly [Poly [0, 1], Poly [2]], Poly [Poly [3]]]"
  :: "int poly poly poly"*}
value "poly (poly (poly [:[:[:0, 1::int:], [:2:]:], [:[:3:]:]:] [:[:z:]:]) [:y:]) x"
  --{*                                                                 (R [x,y]) [z]  reverse!!!*}
(*... now the initial polynomial is evaluated; with the expected value:*)
  lemma
    fixes x y z :: "'a::comm_ring_1"
    shows "x + 2*y + 3*z = poly (poly (poly [:[:[:0, 1:], [:2:]:], [:[:3:]:]:] [:[:z:]:]) [:y:]) x"
      by (simp add: algebra_simps power_numeral_even power_numeral_odd)

(*invert the sequence of variables*)
term "poly (poly (poly [:[:[:0, 3:], [:2:]:], [:[:1:]:]:] [:[:x:]:]) [:y:]) z" 
  --{*                                                           (R [z,y]) [x]  reverse!!!*}
  lemma
    fixes x y z :: "'a::comm_ring_1"
    shows "x + 2*y + 3*z = poly (poly (poly [:[:[:0, 3:], [:2:]:], [:[:1:]:]:] [:[:x:]:]) [:y:]) z"
      by (simp add: algebra_simps power_numeral_even power_numeral_odd)

term "[:[:[:0, 3:]:], [:[:2:]:]:]" --{**}
term "poly (poly (poly [:[:[:0, 3:]:], [:[:2:]:]:] [:[:x:]:]) [:y:]) z" --{**}
  lemma
    fixes x y z :: "'a::comm_ring_1"
    shows "2*x + 3*z^4 = poly (poly (poly [:[:[:0, 0, 0, 0, 3:]:], [:[:2:]:]:] [:[:x:]:]) [:y:]) z"
      by (simp add: algebra_simps power_numeral_even power_numeral_odd)

subsubsection {* preparations.tex for paper --------------------------------------------------*}

  lemma
    fixes x :: "'a::comm_ring_1"
    shows "x^2 + 3 * x + 4 = poly [:4, 3, 1:] x"
    by (simp add: algebra_simps power_numeral_even power_numeral_odd)

  lemma
    fixes x y z :: "'a::comm_ring_1"
    shows "x + y + z = 
      poly (poly (poly [:[:[:0, 1:], 1:], 1:] [:[:z:]:]) [:y:]) x"
    by (simp add: algebra_simps power_numeral_even power_numeral_odd)

  lemma
    fixes x y z :: "'a::comm_ring_1"
    shows "4 * x * y * z =
      poly (poly (poly ([:0, [:0, [:0, 4:]:]:]) [:[:z:]:]) [:y:]) x"
    by (simp add: algebra_simps power_numeral_even power_numeral_odd)

  lemma
    fixes x y z :: "'a::comm_ring_1"
    shows 
      "let q = poly (poly (poly [:[:[:0, 1:], 1:], 1:] [:[:z:]:]) [:y:]) x;
        p = poly (poly (poly ([:0, [:0, [:0, 4:]:]:]) [:[:z:]:]) [:y:]) x
      in x + y + z + 4 * x * y * z = p + q"
    by (simp add: algebra_simps power_numeral_even power_numeral_odd)

subsubsection {* initial trials --------------------------------------------------------------*}
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * y^3 + 2 * x + 4 * x * z + 3 =              (* x <-> y*)
    poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:]:], [:0, [:4:]:]:] [:[:z:]:]) [:x:]) y"
  by (simp add: algebra_simps eval_power_numeral)
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * x^3 + 2 * y + 4 * y * z + 5 * x + 3 =      (* added 5*x *)
    poly (poly (poly [:[:[:3, 5,  0, -1:], [:2:]:], [:0, [:4:]:]:] [:[:z:]:]) [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * x^3 + 2 * y + 4 * y * z (*+ 6 * z^2*) + 3 = (* added 6*z^2  TODO*)
    poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:]:], [:0, [:4:](*, 6*):]:] [:[:z:]:]) [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)
lemma
  fixes x y z :: "'a::comm_ring_1"
  shows "-1 * x^3 + 2 * y + 4 * y * z + 3 =              (* added 7*y TODO *)
    poly (poly (poly [:[:[:3, 0,  0, -1:], [:2:]:], [:0, [:4:]:]:] [:[:z:]:]) [:y:]) x"
  by (simp add: algebra_simps eval_power_numeral)

value "xxx" --{**}
value "xxx" --{**}

subsection {* AD Monomials =====================================================================*}
(* monom doesn't work for multivariate polynomials:
  lemma poly_monom:
    fixes a x :: "'a::{comm_semiring_1}"
    shows "poly (monom a n) x = a * x ^ n"  
*)
value "monom (123::int) 2" --"Poly [0, 0, 123]" 




subsubsection {* To what extent does Polynomial.thy need the representation ?===================*}
text {*
  OK ... degree_monom_eq
  NOK lemma coeffs_monom: ERROR Not an abstract equation, in theorem: ?coeffs (monom ?a ?n) \<equiv> ..
*}

subsection {* AD Addition and subtraction ======================================================*}
text {* code
(*Groups.thy:*) class comm_monoid_add = zero + ab_semigroup_add +
                  assumes add_0: "0 + a = a"

  instantiation poly :: (comm_monoid_add) comm_monoid_add (*reused in "fun plus_coeffs"*)
  begin
  
  lift_definition plus_poly :: "'a poly \<Rightarrow> 'a poly \<Rightarrow> 'a poly"
    is "\<lambda>p q n. coeff p n + coeff q n"
  proof (rule almost_everywhere_zeroI) 
    fix q p :: "'a poly" and i
    assume "max (degree q) (degree p) < i"
    then show "coeff p i + coeff q i = 0"
      by (simp add: coeff_eq_0)
  qed
  
  lemma coeff_add [simp]:
    "coeff (p + q) n = coeff p n + coeff q n"
    by (simp add: plus_poly.rep_eq)
  
  instance proof
    fix p q r :: "'a poly"
    show "(p + q) + r = p + (q + r)"
      by (simp add: poly_eq_iff add_assoc)
    show "p + q = q + p"
      by (simp add: poly_eq_iff add_commute)
    show "0 + p = p"
      by (simp add: poly_eq_iff)
  qed
  
  end
*}
thm poly_eq_iff        --"(?p = ?q) = (\<forall>n. coeff ?p n = coeff ?q n)"
thm coeff_eq_0         --"degree ?p < ?n \<Longrightarrow> coeff ?p ?n = 0"
thm plus_poly.rep_eq   --"coeff (?x + ?xa) = (\<lambda>n. coeff ?x n + coeff ?xa n)"

value "(monom (1::int) 0) + (monom (2::int) 1) + (monom (3::int) 2)" --"Poly [1, 2, 3]"

value "[:1, (1::int):]" --""
value "[:1, 2:] + [:10, (20::int):]" --"Poly [11, 22]"
value "xxx" --""
value "xxx" --{**}

subsubsection {* in ML decompose addition ------------------------------------------------------*}

value "op+ :: (real poly \<Rightarrow> real poly \<Rightarrow> real poly)"
value "let p = pCons 1 (pCons 2 (pCons 3 (0::real poly)));
           q = pCons 4 (pCons 5 (0::real poly)) in 
  p + q"                            (*"Poly [5, 7, 3]" :: "real poly"*)
ML {*
fun drop' i (Poly p) = Poly (drop i p) 
fun drop_tl_zeros' (Poly p) = Poly ((rev o drop_hd_zeros o rev) p);
fun add [] [] = []
  | add (x::xs) (y::ys) = x + y   :: add xs ys
  | add (x::xs) []      = (x:real):: add xs []
  | add []      (y::ys) =     y   :: add [] ys;
fun add' [] [] = []
  | add' (x::xs) (y::ys) = x + y   :: add' xs ys
  | add' (x::xs) []      = (x:int) :: add' xs []
  | add' []      (y::ys) =     y   :: add' [] ys;
*} ML {*
infix ++ -- +++ --- *** ****
*} ML {*
fun (Poly xs) ++ (Poly ys) = Poly (add xs ys)               (*: real poly * real poly -> real poly*)
fun (Poly xs) +++ (Poly ys) = Poly (add' xs ys)             (*: int poly * int poly -> int poly*)
fun (Poly xs) -- (Poly ys) = Poly (add xs (map (curry op * ~1.0) ys))
fun (Poly xs) --- (Poly ys) = Poly (add' xs (map (curry op * ~1) ys))
fun (Poly []) *** (Poly _) = Poly []                       (*: int poly * int poly -> int poly*)
  | (Poly xs) *** (Poly ys) = Poly (xs %*% ys) (*... univarariate from GCD_Poly_ML *)
*} ML {*
*} ML {*
fun (Poly []) **** (Poly _) = Poly []                       (*: int poly * int poly -> int poly*)
  | (Poly xs) **** (Poly ys) = Poly (xs %%*%% ys)
*} ML {*
*} ML {*
*} ML {*
*} ML {*
;
(Poly [1.0, 2.0, 3.0]) ++ (Poly [4.0, 5.0]) (* = Poly [5.0, 7.0, 3.0]: real poly*);
(Poly [1.0, 2.0, 3.0]) -- (Poly [4.0, 5.0]) (* = Poly [~3.0, ~3.0, 3.0]: real poly*);
*} ML {*
((Poly [1, 2, 3]) +++ (Poly [4, 5])) = Poly [5, 7, 3];
((Poly [1, 2, 3]) *** (Poly [4, 5])) = Poly [4, 13, 22, 15];
*} ML {*
*}
(*------------------- can this be generalised to int poly poly ? -------------------
  ?YES?, if +++ is defined via pCons 
*)
ML {*
*} ML {*
(*
(fn a' => (fn p' => (*(\<lambda>a p. smult a q + pCons 0 p) in definition "p * q = ..."*)
  (writeln ("xxxxx " ^ PolyML.makestring a' ^ " " ^ PolyML.makestring p' ^ 
    " \<longrightarrow> " ^ PolyML.makestring (smult' a' q' +++ pCons 0 p'));
  smult' a' q'(*is free here*) +++ pCons 0 p')))
*)
*} ML {*
*} ML {*
(*fun p +++ q = Poly [Poly []]*)
*} ML {*
*} ML {*
*} ML {*
*}


subsubsection {* To what extent does Polynomial.thy need the representation ?===================*}
text {*
  OK ... fun plus_coeffs
  NOK coeffs_plus_eq_plus_coeffs: ERROR Unknown fact "coeffs_eqI"
  OK lemma [code]: fixes p q :: "'a::ab_group_add poly" shows "p - q = p + - q" by simp
  NOK lemma poly_add: ERROR Unable to figure out induct rule
*}

subsection {* AD Multiplication by a constant, polynomial multiplication and the unit polynomial*}
value "[:1, (1::int):]" --""
value "[:1, 1:] * [:1, (1::int):]" --"Poly [1, 2, 1]"
value "[:1, 1:] * [:1, (-1::int):]" --"Poly [1, 0, -1]"
value "xxx" --""

subsubsection {* in ML decompose smult ------------------------------------------------------*}

value "degree" --{*"\<lambda>u. List.gen_length 0 (coeffs u) - Suc 0" :: "'a poly \<Rightarrow> nat"*}
value "let p = pCons 1 (pCons 2 (pCons 3 (0::real poly))) in 
  degree p"                   (*"2" :: "nat"*)
ML {*
fun degree (Poly xs) = length xs - 1; (*defined later, in AD List-style constructor*)
degree (Poly [1.0, 2.0, 3.0]) (* = 2: int*)
*} 

value "smult (4::real)" --{*"_" :: "real poly \<Rightarrow> real poly"*}
value "let p = pCons 1 (pCons 2 (pCons 3 (0::real poly))) in 
  smult 4 p"               (*"Poly [4, 8, 12]" :: "real poly"*)
ML {*
fun smult i (Poly xs : real poly) = Poly (map (curry op * i) xs);
fun smult' i (Poly xs : int poly) = Poly (map (curry op * i) xs);
smult 4.0 (Poly [1.0, 2.0, 3.0]) (* = Poly [4.0, 8.0, 12.0]: real poly*)
*} 

value "(\<lambda>a p. smult (a::real) q + pCons 0 p)" --{*  :: "real \<Rightarrow> real poly \<Rightarrow> real poly"*}
value "let a = 10;
           p = pCons 1 (pCons 2 (pCons 3 (0::real poly)));
           q = pCons 4 (pCons 5 (0::real poly)) in 
  (\<lambda>a p. smult (a::real) q + pCons 0 p) a p"   (*"Poly [40, 51, 2, 3]" :: "real poly"*)
ML {*
val a = 10.0;
val p = Poly [1.0, 2.0, 3.0];
val q = Poly [4.0, 5.0];
fun xxxxx a p = 
  (writeln ("xxxxx " ^ PolyML.makestring a ^ " " ^ PolyML.makestring b ^ 
    " \<longrightarrow> " ^ PolyML.makestring (smult a q ++ pCons 0.0 p));
  smult a q ++ pCons 0.0 p)
;
xxxxx a p;                                   (* = Poly [40.0, 51.0, 2.0, 3.0]: real poly*)
*} ML {*
*}

value "fold_coeffs"                        (* :: "('a \<Rightarrow> 'b \<Rightarrow> 'b) \<Rightarrow> 'a poly \<Rightarrow> 'b \<Rightarrow> 'b"*)
value "(\<lambda>a p. smult (a::real) q + pCons 0 p)" --{*  :: "real \<Rightarrow> real poly \<Rightarrow> real poly"*}
value "let p = pCons 1 (pCons 2 (pCons 3 (0::real poly)));
           q = pCons 4 (pCons 5 (0::real poly)) in 
  fold_coeffs (\<lambda>a p. smult a q + pCons 0 p) p 0"  (*"Poly [4, 13, 22, 15]" :: "real poly"*)
ML {*
fold_coeffs xxxxx p (Poly [])                   (* = Poly [4.0, 13.0, 22.0, 15.0]: real poly*)
*} ML {*
*} ML {*
*} 
subsubsection {* in ML fold_coeffs 1 var ------------------------------------------------------*}
ML {*
val a' = 2;
val p' = Poly [1, 2, 3];
val q' = Poly [4, 5];
*} ML {*
(fn a' => (fn p' => (*(\<lambda>a p. smult a q + pCons 0 p) in definition "p * q = ..."*)
  (writeln ("xxxxx " ^ PolyML.makestring a' ^ " " ^ PolyML.makestring p' ^ 
    " \<longrightarrow> " ^ PolyML.makestring (smult' a' q' +++ pCons 0 p'));
  smult' a' q'(*is free here*) +++ pCons 0 p')))
;
fun xxxxx' a' p' = 
  (writeln ("xxxxx " ^ PolyML.makestring a' ^ " " ^ PolyML.makestring p' ^ 
    " \<longrightarrow> " ^ PolyML.makestring (smult' a' q' +++ pCons 0 p'));
  smult' a' q'(*is free here*) +++ pCons 0 p') 
;
(* the same defined directly *)
val xxxxx' = (fn a' => (fn p' => (*(\<lambda>a p. smult a q + pCons 0 p) in definition "p * q = ..."*)
  (writeln ("xxxxx " ^ PolyML.makestring a' ^ " " ^ PolyML.makestring p' ^ 
    " \<longrightarrow> " ^ PolyML.makestring (smult' a' q' +++ pCons 0 p'));
  smult' a' q'(*is free here*) +++ pCons 0 p')))
*} ML {*
fold_coeffs : ('a -> 'b -> 'b) -> 'a poly -> 'b       -> 'b;
fold_coeffs xxxxx'             : int poly -> int poly -> int poly;
fold_coeffs xxxxx' p'                      : int poly -> int poly;
fold_coeffs xxxxx' p' (Poly [0])                       : int poly;
*} ML {*
fold_coeffs xxxxx' p' (Poly [0]) = Poly [4, 13, 22, 15] (*vvv fold is correct*)
*} ML {*
(p' *** q')                      = Poly [4, 13, 22, 15] (*^^^ fold is correct*)
*} ML {*
fun foldr' _ [] = id
  | foldr' f (x :: xs) = (f x) o (foldr' f xs) 
*} 
thm o_def (* ?f \<circ> ?g = (\<lambda>x. ?f (?g x)) *)
ML {*
(fold_coeffs xxxxx' p'                                    ) (Poly [0]);  (*def fold_coeffs...*)
*} ML {*                                              
val f = xxxxx';                                       
(foldr f (coeffs p')                                     ) (Poly [0]);  (*def foldr 2...*)
(foldr f [1,2,3]                                         ) (Poly [0]);  (*take consts*)
*} ML {*                                                 
((f 1) o (foldr f [2,3]       )                          ) (Poly [0]);  (*def foldr 2...*)
*} ML {*                                                               
((f 1) o ((f 2) o (foldr f [3])         )                ) (Poly [0]);  (*def foldr 2...*)
*} ML {*                                                               
((f 1) o ((f 2) o ((f 3) o (foldr f [])))                ) (Poly [0]);  (*def foldr 1...*)
*} ML {*                                                               
((f 1) o ((f 2) o ((f 3) o (id)        ))                ) (Poly [0]);  (*def o_def...*)
*} ML {*                                                               
((f 1) o ((f 2) o ((fn x => f 3 (id x))))                ) (Poly [0]);  (*def id...*)
*} ML {*                                                               
((f 1) o ((f 2) o ((fn x => f 3 x     )))                ) (Poly [0]);  (*rearranged...*)
*} ML {*                                                               
(        (f 1) o (       (f 2) o      (fn x => f 3 x))   ) (Poly [0]);  (*def o_def...*)
*} ML {*                                                   
(        (f 1) o (fn y => (f 2)      ((fn x => f 3 x) y))) (Poly [0]);  (*reduce ()...*)
*} ML {*                                                   
(        (f 1) o (fn y =>  f 2       ((fn x => f 3 x) y))) (Poly [0]);  (*def o_def...*)
*} ML {*                                                 
(fn z => (f 1)   ((fn y => f 2 ((fn x => f 3 x) y)) z)   ) (Poly [0]);  (*reduce ()...*)
*} ML {*                                                 
(fn z =>  f 1    ((fn y => f 2 ((fn x => f 3 x) y)) z)   ) (Poly [0]);  (*def fn...*)
*} ML {*
          f 1    ((fn y => f 2 ((fn x => f 3 x) y)) (Poly [0]));        (*def fn...*)
*} ML {*                                                                
          f 1    ((        f 2 ((fn x => f 3 x) (Poly [0])))  );        (*def f=xxxxx'...vvv*)
*} ML {*                                                                
          f 1    ((        f 2 (         Poly [12, 15]    ))  );        (*def f=xxxxx'...^^^*)
*} ML {*                                                                
          f 1    ((        Poly [8, 22, 15]                )  );        (*def f=xxxxx'...*)
*} ML {*
          Poly [4, 13, 22, 15];
*} ML {*
*} ML {*
*} ML {*
*}

subsubsection {* in ML fold_coeffs 2 var ------------------------------------------------------*}
ML {*
(* observe  |       |       |       |             |          |         | *)
val pq = 
Poly [Poly [0,      0,      0,      1]     ,Poly [0] , Poly [0] ,Poly [~1]   ];
(*     y^0.(0.x^0 + 0.x^1 + 0.x^2 + 1.x^3) +  y^1.0  +   y^2.0  + y^3.(-1.x^0) =  x^3 + -1.y^3   *)
*} ML {*
val p = 
Poly [Poly [0,      1]     , Poly [~1]]
(*     y^0.(0.x^0 + 1.x^1) +  y^1.(-1.x^0)                                     =  x + -1.y       *)
*} ML {*
val q = 
Poly [Poly [0,      0,      1]     , Poly [0,      1]     , Poly [1]]
(*     y^0.(0.x^0 + 0.x^1 + 1.x^2) +  y^1.(0.x^0 + 1.x^1  +  y^2.(1.x^0)       =  x^2 + x.y + y^2*)
*} ML {*
(* STOPPED, see --- can this be generalised to int poly poly ? --- ABOVE: pCons involved !!! type*)
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*}


subsubsection {* To what extent does Polynomial.thy need the representation ?===================*}
text {*
  OK ... lemma smult_eq_0_iff [simp]:
  NOK lemma coeffs_smult [code abstract]: ERROR Unknown fact "coeffs_eqI"
  NOK definition "p * q = fold_coeffs (\<lambda>a p. smult a q + pCons 0 p) p 0"
                          ^^^^^^^^^^^
  NOK instantiation poly :: (comm_semiring_0) comm_semiring_0, etc
*}


subsubsection {* trials with Wolfgang Nov.7. ==================================================*}
definition double :: "'a::comm_monoid_add poly => 'a poly"
where
  "double p = p + p"
definition ddouble :: "'a::comm_monoid_add poly => 'a poly"
where
  "ddouble p = double (double p)"
definition idouble :: "int poly => int poly"
where
  "idouble p = double (double p)"

value "double (p::int poly)"
value (simp) "let p = [:1,2,3:]
  in double (p::int poly)"
value (nbe) "let p = [:1,2,3:]
  in double (p::int poly)"
value (code) "let p = [:1,2,3:]
  in double (p::int poly)"
value "let p = [:1,2,3:]
  in double (p::int poly)"

code_thms double
(*
export_code double in SML module_name Double file "~/tmp/double.sml"
export_code ddouble in SML module_name DDouble file "~/tmp/ddouble.sml"
export_code idouble in SML module_name IDouble file "~/tmp/idouble.sml"
*)


subsection {* AD Lemmas about divisibility =====================================================*}

subsubsection {* To what extent does Polynomial.thy need the representation ?===================*}
text {*
  NOK lemma dvd_smult: No type arity poly :: dvd
*}

subsection {* AD Polynomials form an integral domain ===========================================*}
subsection {* AD Polynomials form an ordered integral domain ===================================*}
subsection {* AD Synthetic division and polynomial roots =======================================*}
value "synthetic_divmod" --{**}
thm dvd_iff_poly_eq_0 (*[:c, 1:] dvd p \<longleftrightarrow> poly p (-c) = 0*)

(*value "[:2, 1::int:] dvd [:2, 1:]" --{**}
Wellsortedness error:
Type int poly not of sort {semiring_div,equal}
No type arity int :: field  ...WE NEED ANOTHER TYPE FOR THE POLY:*)
value "[:2, 1::complex:] dvd [:2, 1:]" --"True" (*requires Complex_Main*)
value "[:2, 1::real:] dvd [:2, 1:]" --"True"    (*requires Complex_Main*)

value "[:2, 1::rat:] dvd [:2, 1:]" --"True"    value "poly [:2, 1:] (-2::rat)" --"0"
value "[:2, 1::rat:] dvd [:6, 3:]" --"True"
value "[:2, 1::rat:] dvd [:4, 4, 1:]" --"True" value "poly [:4, 4, 1:] (-2::rat)" --"0"

value "[:1, 1::rat:] dvd [:-1, 0, 1:]" --"True  ..1/2 VON DIANA'S ARBEIT IST SCHON IMPLEMENTIERT"
(*declare [[simp_trace]]    Zeile unterhalb macht Output Buffer "ubervoll*)
value "[:-1, 0, 1:] div [:1, 1::rat:]" --"Poly [-1, 1]    ..1/2 VON DIANA'S ARBEIT"

subsection {* AD Long division of polynomials ==================================================*}
subsubsection {* trials with evaluation ------------------------------------------------------- *}
value "[:6::int:] div [:6:]" --{*"Poly [1]" :: "real poly"*}
value "[:6::int:] div [:4:]" --{*"Poly [3 / 2]" :: "real poly"*}
value "[:6::int:] div [:3:]" --{*"Poly [2]" :: "real poly"*}
(*       1  -x  +  x^2    =  x(x+1)(x-1) + 1*)
value "[:1, -1, 0, 1::int:] div [:1, 1:]" --{*"Poly [0, -1, 1]" :: "real poly"*}
value "[:1, -1, 0, 1::int:] mod [:1, 1:]" --{*"Poly [1]" :: "real poly"*}

value "xxx" --{**}
value "xxx" --{**}

subsubsection {* in ML decompose pdivmod ------------------------------------------------------*}


(*... fold_coeffs works with multiplication; we proceed to pdivmod2_fold_coeffs ...*)
value "
let a = 10; 
    s = pCons 20 (0::real poly); 
    r = pCons 30 (0::real poly);
    p = pCons 1 (pCons 2 (pCons 3 (0::real poly)));
    q = pCons 4 (pCons 5 (0::real poly));
    yyyyy = (\<lambda>a (s, r).
      let b = coeff (pCons a r) (degree q) / coeff q (degree q)
      in (pCons b s, pCons a r - smult b q)
   ) in 
  yyyyy" (*  :: "real \<Rightarrow> real poly \<times> real poly \<Rightarrow> real poly \<times> real poly"*)

ML {*
val s = Poly [20.0];
val r = Poly [30.0];
fun yyyyy a (s, r) = 
  let
    val b = coeff (pCons a r) (degree q) / coeff q (degree q)
    val _ = writeln ("a = " ^ PolyML.makestring a ^ 
      ", b = " ^ PolyML.makestring b ^ 
      ", pCons a r = " ^ PolyML.makestring (pCons a r) ^ 
      ", smult b q = " ^ PolyML.makestring (smult b q) ^ 
      ", s: " ^ PolyML.makestring s ^ " -> " ^  PolyML.makestring (pCons b s) ^
      ", r: " ^ PolyML.makestring r ^ " -> " ^  PolyML.makestring (pCons a r -- smult b q))
  in (pCons b s, pCons a r -- smult b q) end
 (*yyyyy = fn: real -> real poly * real poly -> real poly * real poly*)
*} 

value (code) "
let a = 10::real; 
    s = pCons 20 (0::real poly); 
    r = pCons 30 (0::real poly);
    p = pCons 1 (pCons 2 (pCons 3 (0::real poly)));
    q = pCons 4 (pCons 5 (0::real poly));
    yyyyy = (\<lambda>a (s, r).
      let b = coeff (pCons a r) (degree q) / coeff q (degree q)
      in (pCons b s, pCons a r - smult b q)
   ) in 
  fold_coeffs yyyyy p (0, 0)"  (*"(Poly [-2 / 25, 3 / 5], Poly [33 / 25])"
                                   Poly [-0.08,   0.6  ], Poly [1.32   ]*)
ML {*
~2.0 / 25.0; 3.0 / 5.0; 33.0 / 25.0;
*} 

subsubsection {* pdivmod_fold_coeffs: compare Isar -- ML with [9,8,7, 6,5,4] div [1,2,3] ------- *}
value "degree [:1,2,3::int:] = 2"
value "pdivmod [:9::int,8,7, 6,5,4:] [:1,2,3:]"
--{*"(Poly [112 / 81,    28 / 27,  7 / 9,  4 / 3], Poly [617 / 81 , 340 / 81])"*}
ML {*
  (*          1.382 ,     1.037 ,  0.777,  1.333          7.617   ,   4.197    *) 
           112.0/81.0;  28.0/27.0;7.0/9.0;4.0/3.0;      617.0/81.0;340.0/81.0
*}
ML {* 7.0/9.0(*=0.777*); 56.0/9.0(*=6.222*); 28.0/9.0(*=3.111*); 28.0/27.0(*=1.037*);
*}
(*see ~/projs/CTPprog/gcd/transparent/Prep_Transparent.thy 
  text {* Example used to develop pdivmod2: *}*)
ML {*
val p = Poly [9.0, 8.0, 7.0,  6.0, 5.0, 4.0]
val q = Poly [1.0, 2.0, 3.0];
fun yyyyy a (s, r) = 
  let
    val b = coeff (pCons a r) (degree q) / coeff q (degree q)
    val _ = writeln ("a = " ^ PolyML.makestring a ^ 
      ", b = " ^ PolyML.makestring b ^ 
(*    ", pCons a r = " ^ PolyML.makestring (pCons a r) ^ 
      ", smult b q = " ^ PolyML.makestring (smult b q) ^ *)
      ", s: " ^ PolyML.makestring s ^ " --> " ^  PolyML.makestring (pCons b s) ^
      ", r: " ^ PolyML.makestring r ^ " --> " ^  PolyML.makestring (pCons a r -- smult b q))
  in (pCons b s, pCons a r -- smult b q) end
*} ML {*
fold_coeffs yyyyy p (Poly [], Poly [])
(*!!! see output from writeln !!! ending with (same as in Isar ^^):
  (Poly [1.382, 1.037, 0.777, 1.3333, ~0.0,0.0], Poly [7.617, 4.197, 0.0,0.0, 0.0,0.0, 0.0,~0.0])*)
(*a = 4, b = 0,   s: Poly []             --> Poly [0],                   r: Poly []                       --> Poly [4, ~0, ~0] 
a = 5, b = ~0,    s: Poly [0]            --> Poly [~0, 0],               r: Poly [4, ~0, ~0]              --> Poly [5, 4, 0, ~0] 
a = 6, b = 1.333, s: Poly [~0, 0]        --> Poly [1.333, ~0, 0],        r: Poly [5, 4, 0, ~0]            --> Poly [4.666, 2.333, 0, 0, ~0] 
-----------------------------------------------------------------------------------------------------------------------------------------
a = 7, b = 0.777, s: Poly [1.333, ~0, 0] --> Poly [0.777, 1.333, ~0, 0], r: Poly [4.666, 2.333, 0, 0, ~0] --> Poly [6.222, 3.111, 0, 0, 0, ~0] 
a = 8, b = 1.037, s: Poly [0.777, 1.333, ~0, 0]        --> Poly [1.037, 0.777, 1.333, ~0, 0], 
                                                                         r: Poly [6.222, 3.111, 0,0,0,~0] --> Poly [6.962, 4.148, 0, 0, 0, 0, ~0] 
a = 9, b = 1.382, s: Poly [1.037, 0.777, 1.333, ~0, 0] --> Poly [1.382, 1.037, 0.777, 1.333, ~0, 0], 
                                                                         r: Poly [6.962, 4.148,0,0,0,0,~0]--> Poly [7.617, 4.197, 0, 0, 0, 0, 0, ~0] *)
*} ML {*
8.0 - 28.0/27.0; 56.0/9.0 - 56.0/27.0; 112.0/27.0; 
*}

subsubsection {* in ML compose pdivmod2_fold_coeffs with [9,8,7, 6,5,4] div2 [1,2,3 ------------- *}
ML {*
(*from GCD_Poly_ML.thy:*)
  infix div2
  fun a div2 b = 
    if a div b < 0 then (abs a) div (abs b) * ~1 else a div b
(*from Prep_Transparent.thy:*)
  fun fact_quot c1 c2 =
    let
      val d = abs (Integer.gcd c1 c2)
      val n = c2 div2 d
      val q = c1 div2 d
    in if n > 0 then (n, q) else (~1 * n, ~1 * q) end;
*} ML {*
pCons; smult'; op ---; coeff';
fact_quot 3 4; op %*%; op %*; op +++
*} ML {*
val trace_div2 = Unsynchronized.ref true;
fun writeln_trace0 a p q m m' n s r = 
  (if (! trace_div2)
  then 
    writeln ("a = " ^ PolyML.makestring a ^ 
      ", (m', n) = fact_quot " ^ PolyML.makestring (coeff' (pCons a r) (degree q)) ^ 
      " " ^ PolyML.makestring (coeff' q (degree q)) ^ 
      " = (" ^ PolyML.makestring m' ^ ", " ^ PolyML.makestring n ^ ")" ^
      ", s: " ^ PolyML.makestring s ^ " --> " ^ PolyML.makestring (pCons n (smult' m' s)) ^
      ", r: " ^ PolyML.makestring r ^ " --> " ^ 
        PolyML.makestring (smult' m' (pCons (a * m) r) --- smult' n q))
  else ()
  ;
  if drop' (degree (drop_tl_zeros' (smult' m p)) - (degree (drop_tl_zeros' ((s *** q) +++ r))))
      (drop_tl_zeros' (smult' m p)) = 
      drop_tl_zeros' ((s *** q) +++ r) 
    then () else writeln ("invariant broken with " ^ 
      PolyML.makestring (drop' (degree (drop_tl_zeros' (smult' m p)) - 
        (degree (drop_tl_zeros' ((s *** q) +++ r))))
          (drop_tl_zeros' (smult' m p))) ^ 
      " <> " ^ PolyML.makestring (drop_tl_zeros' ((s *** q) +++ r)))
  )
*} ML {*
val p = (*Poly [9, 8, 7,  6, 5, 4]*) Poly [2,2,2, 2,2,2];
val q = (*Poly [1, 2, 3];         *) Poly [7,8,6];
(* 1-1 translation from Prep_Transparent.div_int_up not possible ++ required analysis of pdivmod *)
fun yyyyy2 a ((m, s), r) = 
  let
    val (m', n) = fact_quot (coeff' (pCons a r) (degree q)) (coeff' q (degree q))
    val _ = writeln_trace0 a p q m m' n s r
  in
    ((if m' = 0 then m else m * m', pCons n (smult' m' s)), 
      smult' m' (pCons (a * m) r) --- smult' n q) 
  end
*} ML {*
val ((m, q'), r) = fold_coeffs yyyyy2 p ((1, Poly []), Poly []) (* <<<<<<<<<<<-----GOOON------*)
val _ = if drop_tl_zeros' (smult' m p) = drop_tl_zeros' ((q' *** q) +++ r) 
  then () else writeln "invariant broken";
(*
a = 4, (m, n') = (1, 0), s: Poly []        --> Poly [0],           r: Poly []           --> Poly [4, 0, 0] 
a = 5, (m, n') = (1, 0), s: Poly [0]       --> Poly [0, 0],        r: Poly [4, 0, 0]    --> Poly [5, 4, 0, 0] 
a = 6, (m, n') = (3, 4), s: Poly [0, 0]    --> Poly [4, 0, 0],     r: Poly [5, 4, 0, 0] --> Poly [14, 7, 0, 0, 0] 
-----------------------------------------------------------------------------------------------------------------------------------------
a = 7, (m', n) = (3, 7), s: Poly [4, 0, 0]              --> Poly [7, 12, 0, 0], 
                                                      r: Poly [14, 7, 0, 0, 0]          --> Poly [56, 28, 0, 0, 0, 0] 
a = 8, (m, n') = (3, 28), s: Poly [7, 12, 0, 0]         --> Poly [28, 21, 36, 0, 0], 
                                                      r: Poly [56, 28, 0, 0, 0, 0]      --> Poly [188, 112, 0, 0, 0, 0, 0] 
a = 9, (m, n') = (3, ~14), s: Poly [28, 21, 36, 0, 0]   --> Poly [112, 84, 63, 108, 0, 0], 
                                                      r: Poly [188, 112, 0, 0, 0, 0, 0] --> Poly [617, 340, 0, 0, 0, 0, 0, 0]
val it = ((81, Poly [112, 84, 63, 108, 0, 0]), Poly [617, 340, 0, 0, 0, 0, 0, 0]): (int * int poly) * int poly*)
*} ML {*
*} ML {*
*} 
value "xxx" --{**}
value "xxx" --{**}
value "xxx" --{**}

subsubsection {* definition pdivmod2_rel :: "'a::ring_div poly => ---------------------------- *}
(*!!!!!!!!!!!!!!!!!!!!!! CONTINUED IN TPPL/material/AD_Polynomial.thy !!!!!!!!!!!!!!!!!!!!!!!!!*)
(*
class div2 = dvd +
  fixes div2 :: "'a \<Rightarrow> 'a \<Rightarrow> ('b \<times> 'a)" (infixl "div2" 70)
    and mod2 :: "'a \<Rightarrow> 'a \<Rightarrow> ('b \<times> 'a)" (infixl "mod2" 70)
ERROR  Multiple type variables in class specification

--- SEE BELOW subsubsection {* instantiation poly :: (field --->ring_div)*)
(*definition pdivmod2_rel :: "'a::ring_div => 'a poly => 'a poly => 'a poly => 'a poly => bool"*)
definition pdivmod2_rel :: "int => int poly => int poly => int poly => int poly => bool"
where
  "pdivmod2_rel a x y q r <->
    smult a x = q * y + r \<and> (if y = 0 then q = 0 else r = 0 \<or> degree r < degree y)"

lemma pdivmod2_rel_0:
  "pdivmod2_rel a 0 y 0 0"
  unfolding pdivmod2_rel_def by simp

lemma pdivmod2_rel_by_0:
  "pdivmod2_rel 1 x 0 0 x"
  unfolding pdivmod2_rel_def by simp

(*lemma eq_zero_or_degree_less DOESN'T USE pdivmod_rel *)

(*lemma etc*)

lemma pdivmod2_rel_unique_div: 
  "pdivmod2_rel a1 x y q1 r1 \<Longrightarrow> pdivmod2_rel a2 x y q2 r2 \<Longrightarrow> a1 = a2  \<and> q1 = q2"
sorry
lemma pdivmod2_rel_unique_mod: 
  "pdivmod2_rel a1 x y q1 r1 \<Longrightarrow> pdivmod2_rel a2 x y q2 r2 \<Longrightarrow> a1 = a2  \<and> r1 = r2"
sorry

value "xxx" --{**}
value "xxx" --{**}

subsubsection {* MINIMAL pdivmod22 in FunPack *}
text {* "MINIMAL" means: go for execution without abstract algebra*}

definition fact_quot :: "int \<Rightarrow> int \<Rightarrow> int \<times> int" 
  where
    "fact_quot c1 c2 = (let d = gcd c1 c2; n = c2 div d; q = c1 div d
      in if n > 0 then (n, q) else (-1 * n, -1 * q))"
value "fact_quot 6 4 = (2, 3)" --{*"True" :: "bool"*}

fun pdivmod22 :: "int poly => int poly => (int \<times> int poly) \<times> int poly"
where
  "pdivmod22 p q = (if q = 0 then ((0, 0), p)
    else fold_coeffs (\<lambda>a ((m, s), r).
      let (m', n) = fact_quot (coeff (pCons a r) (degree q)) (coeff q (degree q))
      in ((if m' = 0 then m else m * m', pCons n (smult m' s)), 
        smult m' (pCons (a * m) r) - smult n q)
   ) p ((1, 0), 0))"
value "pdivmod22 [:9, 8, 7,  6, 5, 4:] [:9, 8, 7,  6, 5, 4:] = ((1, [:1:]), [:0:])"
value "pdivmod22 [:9, 8, 7,  6, 5, 4:] [:1, 2, 3:]
  = ((81, [:112, 84, 63, 108:]), [:617, 340:])"   --{*"True" :: "bool"*}

definition div22 :: "int poly \<Rightarrow> int poly \<Rightarrow> (int \<times> int poly)" (infixl "div22" 70)
where
  "x div22 y = fst (pdivmod22 x y)"
definition mod22 :: "int poly \<Rightarrow> int poly \<Rightarrow> int poly" (infixl "mod22" 70)
where
  "x mod22 y = snd (pdivmod22 x y)"

value "[:9, 8, 7,  6, 5, 4:] div22 [:1, 2, 3:] = (81, [:112, 84, 63, 108:])"
value "[:9, 8, 7,  6, 5, 4:] mod22 [:1, 2, 3:] = [:617, 340:]"  --{*"True" :: "bool"*}

ML {*
*} ML {*
*} 
value "xxx" --{**}

subsubsection {* instantiation poly :: (field --->ring_div) ring_div ---------------------------*}
text {* = subsection "Polynomial remainder sequences" in TPPL/material/AD_Polynomial

 explanation for "sort (field)" google "order-sorted algebra of types"
  # http://en.wikipedia.org/wiki/Many-sorted_logic
  # http://en.wikipedia.org/wiki/Structure_%28mathematical_logic%29#Many-sorted_structures
*}
(* code: INSTANTIATION OF A TYPE CLASS DOESN'T WORK:
instantiation poly :: (ring_div) ring_div
begin
  definition mod2_poly where
    "x div2 y = (THE (a, q). \<exists>r. pdivmod2_rel a x y q r)"
  definition mod2_poly where
    "x mod2 y = (THE (a, r). \<exists>q. pdivmod2_rel a x y q r)"
  instance proof
    fix x y :: "'a poly"
    show "x div y * y + x mod y = x"
    sorry
  next
    sorry
end
ERROR ...!!! extra type variable for scalar "'a" ... thus locale !!!...
*)
(*declare[[show_types]]*)
term "(THE (a, q). \<exists>r. pdivmod2_rel a x y q r)" --{* :: "'a \<times> 'a poly"*}
term "(THE (a, r). \<exists>q. pdivmod2_rel a x y q r)" --{* :: "'a \<times> 'a poly"*}
(**)
term "xxx"
value "xxx"

locale PRS (* polynomial remainder sequence *) =
(*fixes div2 :: "'a::ring_div poly \<Rightarrow> 'a poly \<Rightarrow> ('a \<times> 'a poly)" (infixl "div2" 70)
  ...                                                                              *)
  fixes div2 :: "int poly \<Rightarrow> int poly \<Rightarrow> (int \<times> int poly)" (infixl "div2" 70)
    and mod2 :: "int poly \<Rightarrow> int poly \<Rightarrow> int poly" (infixl "mod2" 70)
  assumes div2_def "x div2 y = (THE (a, q). \<exists>r. pdivmod2_rel a x y q r)"
    and mod2_def "x mod2 y = (THE r. \<exists>a q. pdivmod2_rel a x y q r)"
begin
(*lemma ... show the axioms of class ring_div*)

(*definition pdivmod2 :: "'a::ring_div poly => 'a poly => ('a \<times> 'a poly) \<times> 'a poly"*)
definition pdivmod2 :: "int poly => int poly => (int \<times> int poly) \<times> int poly"
where
  "pdivmod2 p q = (p div2 q, p mod2 q)"

(* find a factor for the dividend, such the divisor divides to an integer quotient.
  fact_quot c1 c2 = (n, q)
  assumes c2 \<noteq> 0
  yields THE (n, q). c1 * n = q * c2 *)
(*definition fact_quot :: "'a::gcd \<Rightarrow> 'a \<Rightarrow> 'a \<times> 'a" where 
ERROR Sort constraint gcd inconsistent with default ring_div for type variable "'a"*)
definition fact_quot :: "int \<Rightarrow> int \<Rightarrow> int \<times> int"
where                                                                     
  "fact_quot c1 c2 = (let d = gcd c1 c2; n = c2 div d; q = c1 div d
    in if n > 0 then (n, q) else (-1 * n, -1 * q))"
value "fact_quot 6 4 = (2, 3)" --{*"True" :: "bool"*}

(*lemma ... show whatever is required for the final lemma for execution: *)

lemma pdivmod2_fold_coeffs [code]:
  "pdivmod2 p q = (if q = 0 then ((0, 0), p)
    else fold_coeffs (\<lambda>a ((m, s), r).
      let (m', n) = fact_quot (coeff (pCons a r) (degree q)) (coeff q (degree q))
      in ((if m' = 0 then m else m * m', pCons n (smult m' s)), 
        smult m' (pCons (a * m) r) - smult n q)
   ) p ((1, 0), 0))"
sorry
value "pdivmod2 [:9, 8, 7,  6, 5, 4:] [:9, 8, 7,  6, 5, 4:] = ((1, [:1:]), [:0:])"
value "pdivmod2 [:9, 8, 7,  6, 5, 4:] [:1, 2, 3:]
  = ((81, [:112, 84, 63, 108:]), [:617, 340:])"   --{*"True" :: "bool"*}

end (*locale*)

print_locales
print_locale PRS
print_locale! PRS
(*locale mod2_poly
  fixes div2 :: "'a poly \<Rightarrow> 'a poly \<Rightarrow> 'a \<times> 'a poly"   (infixl "div2" 70)
    and mod2 :: "'a poly \<Rightarrow> 'a poly \<Rightarrow> 'a \<times> 'a poly"   (infixl "mod2" 70)
  assumes "mod2_poly op div2 op mod2"
  notes "mod2_poly_axioms" = (`mod2_poly op div2 op mod2`) [attribute <attribute>]
  notes lemma "mod2_poly_eq" = `pdivmod2_rel ?a ?x ?y ?q ?r \<Longrightarrow> ?x div2 ?y = (?a, ?q)`
 
  ^^^^^ denotes a conclusion element, the "locale predicate"*)
thm PRS_def
(*mod2_poly ?div2.0 ?mod2.0 \<equiv>
((\<forall>div2_def. div2_def) \<and> (\<forall>x y. ?div2.0 x y = (THE (a, q). \<exists>r. pdivmod2_rel a x y q r))) \<and>
(\<forall>mod2_def. mod2_def) \<and> (\<forall>x y. ?mod2.0 x y = (THE (a, r). \<exists>q. pdivmod2_rel a x y q r))

~~/doc/locales.pdf p.2: assumptions, which have been turned into
conclusions and are available as theorems in the context of the locale.
~~/doc/locales.pdf p.3: conclusion has a foundational theorem as counterpart in the theory.
Technically, this is simply the theorem composed of context and conclusion ...*)

(*thm mod2_poly.trans  ...Unknown fact "mod2_poly.trans"*)

(* ~~/doc/locales.pdf p.12: ...*)
print_interps PRS

lemma pdivmod_rel_unique:
  assumes 1: "pdivmod_rel x y q1 r1"
  assumes 2: "pdivmod_rel x y q2 r2"
  shows "q1 = q2 \<and> r1 = r2"
proof (cases "y = 0")
  assume "y = 0" with assms show ?thesis
  sorry
next
  assume [simp]: "y \<noteq> 0"
  show "q1 = q2 \<and> r1 = r2"
  sorry
oops

subsection {* AD Order of polynomial roots =====================================================*}
subsection {* AD GCD of polynomials ============================================================*}
(*
|  instantiation poly :: (field) gcd
V  instantiation poly :: (ring) gcd    SEE  Winkler p.84 GCD_PRS

src/HOL/GCD.thy, + see subsubsection below:
class gcd = zero + one + dvd +
  fixes gcd :: "'a \<Rightarrow> 'a \<Rightarrow> 'a"
    and lcm :: "'a \<Rightarrow> 'a \<Rightarrow> 'a"
*)
(* DER UNIVARIATE GCD IST SCHON DA; multivariater gcd ??? *)
value "gcd [:-1, 0, 1::int:] [:-1, 0, 1:]" --"Poly [-1, 0, 1]"
value "gcd [:-1, 0, 1::int:] [: 0,-1, 1:]" --"Poly [-1, 1]"
value "gcd [:-18, -15, -20, 12, 20, -13, 2::int:] [:8, 28, 22, -11, -14, 1, 2::int:]"
  --"Poly [-2, -1, 1]  ..1/2 VON DIANA'S ARBEIT: DAS MONSTERBEISPIEL VON WINKLER"

(*function gcd_poly
"gcd (x::'a poly) 0 = smult (inverse (coeff x (degree x))) x"*)
value "[:3::rat:]" --""
value "smult (inverse (coeff [:2::rat:] (degree [:2::rat:]))) [:2::rat:]" --"Poly [1] ..PARTIALITY"
value "xxx" --""

value "xxx" --""(*lemma poly_gcd_monic*)
value "gcd [:6, 6::int:] [:4, 4:]" --"Poly [1, 1]   ...the primitive part, Winkler p.82"

(*lemma poly_gcd_unique: requires poly_gcd_monic ... gcd 0 0  *)

text {* !!! isar-ref.p.90 "5.6.3 Locale interpretation"
            locales.p.6 "4 Changing the Locale Hierarchy"...
...Locales enable to prove theorems abstractly, relative to sets of assumptions.
These theorems can then be used in other contexts where the assumptions
themselves, or instances of the assumptions, are theorems. This form of the-
orem reuse is called interpretation.

CODE:
interpretation gcd_poly!: abel_semigroup "gcd :: _ poly \<Rightarrow> _"

isar-ref.p.86: the qualifier is *mandatory* if followed by “!”
*}
value "xxx" --""

subsubsection {* Winklers example by ML --------------------------------------------------------*}
text {* output created by ML, see ~/projs/CTPprog/gcd/transparent/Prep_Transparent.thy
Euclid [~18, ~15, ~20, 12, 20, ~13, 2]  *  1  ==  [1]  **  [8, 28, 22, ~11, ~14, 1, 2]  ++  [~26, ~43, ~42, 23, 34, ~14] 
Euclid [8, 28, 22, ~11, ~14, 1, 2]  *  98  ==  [~41, ~14]  **  [~26, ~43, ~42, 23, 34, ~14]  ++  [~282, 617, ~168, ~723, 344] 
Euclid [~26, ~43, ~42, 23, 34, ~14]  *  59168  ==  [787, ~2408]  **  [~282, 617, ~168, ~723, 344]  ++  [~1316434, ~3708859, ~867104, 1525321] 
Euclid [~282, 617, ~168, ~723, 344]  *  6783102487  ==  [~2345549, 1529768]  **  [~1316434, ~3708859, ~867104, 1525321]  ++  [~5000595353600, ~2500297676800, 2500297676800] 
Euclid [~1316434, ~3708859, ~867104, 1525321]  *  7289497600  ==  [1919, 4447]  **  [~5000595353600, ~2500297676800, 2500297676800]  ++  [] 
                                                                                gcd ^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^^
*}
(*value "-5000595353600 / 7289497600" too large*)
ML{*
~5000595353600 div 7289497600 = ~686;
~5000595353600 mod 7289497600 = 0;

~2500297676800 div 7289497600 = ~343;
~2500297676800 mod 7289497600 = 0;
*}

subsubsection {* Winklers example by HOL/Library/Polynomials -----------------------------------*}
value "gcd [:-1, 0, 1::int:] [:1, 1:]" --{*"Poly [1, 1] :: "real poly"
                       ===                                  ===*}

value "[:-18, -15, -20, 12, 20, -13, 2::int:]" --{**}
value "[:8, 28, 22, -11, -14, 1, 2::int:]" --{**}

value "gcd [:-18, -15, -20, 12, 20, -13, 2::int:] [:8, 28, 22, -11, -14, 1, 2:]"
  --{*"Poly [-2, -1, 1]"*}

value "[:-18, -15, -20, 12, 20, -13, 2::int:] mod 
  [:8, 28, 22, -11, -14, 1, 2::int:]"
    --{*"Poly [-26, -43, -42, 23, 34, -14]" :: !!!!!!!!!! "real poly"*}
value "[:8, 28, 22, -11, -14, 1, 2::int:] mod 
  [:-26, -43, -42, 23, 34, -14::int:]" 
    --{*"Poly [-141 / 49, 617 / 98, -12 / 7, -723 / 98, 172 / 49]"*}
value "[:-26, -43, -42, 23, 34, -14::int:] mod 
  [:-141 / 49, 617 / 98, -12 / 7, -723 / 98, 172 / 49:]" 
    --{*"Poly [-658217 / 29584, -3708859 / 59168, -27097 / 1849, 1525321 / 59168]"*}
value "[:-141 / 49, 617 / 98, -12 / 7, -723 / 98, 172 / 49::real:] mod 
  [:-658217 / 29584, -3708859 / 59168, -27097 / 1849, 1525321 / 59168:]" 
    --{*"Poly [-1041356800 / 138430663, -520678400 / 138430663, 520678400 / 138430663]"*}
value "[:-658217 / 29584, -3708859 / 59168, -27097 / 1849, 1525321 / 59168::real:] mod 
  [:-1041356800 / 138430663, -520678400 / 138430663, 520678400 / 138430663:]" 
    --{*"Poly []"*}

(*value "-1041356800 / 138430663" too large*)
ML{*
~1041356800 div 138430663 = ~8;
~1041356800 mod 138430663 = 66088504;

~1041356800 div ~520678400 = 2;
~1041356800 mod ~520678400 = 0;
*}
value "xxx" --{**}

subsubsection {* GCD.thy -----------------------------------------------------------------------*}
text {* code
declare transfer_morphism_int_nat[transfer add return:
    transfer_int_nat_gcd transfer_int_nat_gcd_closures]

isar-ref.p.249: "12.2 Transfer package"
*}

subsection {* AD Composition of polynomials ====================================================*}
(* see Florian's mail 28.Nov.2013:
substitute for x in (1+x+x^2)       (1+x) = 1 + (1+x) + (1+x)^2 = 3 + 3x + x^2 *)
value "pcompose     [:1,1,1::int:] [:1,1::int:]" --"Poly [3, 3, 1]"

value "xxx" --""
value "xxx" --""

end
