
header {* TRY Constructing the recursive representation for multivariate polynomials *}

theory Try_Recursive_Construct
imports "~/repos/poly-WORK/Recursive_Construct" "~~/src/HOL/Library/Polynomial"
begin

subsection {* Type of recursive polynomial representation *}
(*On 03/07/2014 09:07 AM, Andreas Lochbihler wrote: 
3. 'b XXX = 'b nat_mapping:

datatype 'a poly_rec = Coeff_raw 'a | Powers_raw "('a poly_rec) nat_mapping"
Non-admissible type expression
'a poly_rec nat_mapping
"Nat_Mapping.nat_mapping" is not a datatype - can't use it in nested recursion

SEE MAIL On 03/27/2014 12:33 PM, Andreas Lochbihler Re: Rekursive Darstellung*)

(*datatype 'a poly_rec_raw = Coeff_raw 'a | Powers_raw "('a poly_rec_raw) list"*)
value "Powers_raw [Powers_raw [Powers_raw [Powers_raw [Coeff_raw 4, Coeff_raw 1], Coeff_raw 2]], 
             Coeff_raw 3]" --{*          4 + 3.x + 2.y + z    in (R [y,z]) [x]*}
value "Powers_raw [Powers_raw [Powers_raw [Powers_raw [Coeff_raw 4, Coeff_raw 3], Coeff_raw 2]], 
             Coeff_raw 1]" --{*          4 + 3.x + 2.y + z    in (R [y,z]) [x]*}

text {* example from 
  A.L. [isabelle] 
  Re: [isabelle] lift_definition + constructor
  Wed, 8 Jan 2014 17:40:58 +0100

  1.x.y.z^2 + 2.x^2.y^2.z^3 + 3.x^2.y.z^3

(R [z,y]) [x]: dense
   0.x^0 + (0.y^0 + (0.z^0 + 0.z^1 + 1.z^2).y^1) .x^1 + (0.y^0 + (0.z^0 + 0.z^1 + 0.z^2 + 2.z^3).y^1 + (0.z^0 + 0.z^1 + 0.z^2 + 3.z^3).y^2) .x^2
                       ---     ---     ---                          ---     ---     ---     ---           ---     ---     ---     ---   
              ===                           ===            ===                                   ===                                   ===
     ###                                          ###                                                                                        ###*}
value "Powers_raw [
  (*x^0*) Coeff_raw 0, 
  (*x^1*) Powers_raw [(*y^0*) Coeff_raw 0, 
                  (*y^1*) Powers_raw [(*z^0*) Coeff_raw 0, (*z^1*) Coeff_raw 0, (*z^2*) Coeff_raw 1]], 
  (*x^2*) Powers_raw [(*y^0*) Coeff_raw 0, 
                  (*y^1*) Powers_raw [(*z^0*) Coeff_raw 0, (*z^1*) Coeff_raw 0, (*z^2*) Coeff_raw 0, (*z^3*) Coeff_raw 2], 
                  (*y^2*) Powers_raw [(*z^0*) Coeff_raw 0, (*z^1*) Coeff_raw 0, (*z^2*) Coeff_raw 0, (*z^3*) Coeff_raw 3]]]"

text {*
(R [z,x]) [y]: dense
   0 .y^0 + (0.x^0 + (0.z^0 + 1.z^1).x^1 + (0.z^0 + 0.z^1 + 0.z^2 + 2.z^3).x^2) .y^1 + (0.x^0 + 0.x^1 + (0.z^0 + 0.z^1 + 0.z^2 + 3.z^3).x^2) .y^2
                        ---     ---           ---     ---     ---     ---                                  ---     ---     ---     ---
               ===                   ===                                   ===            ===     ===                                   ===
      ###                                                                        ###                                                          ###*}
value "Powers_raw [
  (*y^0*) Coeff_raw 0 , 
  (*y^1*) Powers_raw [(*x^0*) Coeff_raw 0, 
                  (*x^1*) Powers_raw [(*z^0*) Coeff_raw 0, (*z^1*) Coeff_raw 1], 
                  (*x^2*) Powers_raw [(*z^0*) Coeff_raw 0, (*z^1*) Coeff_raw 0, (*z^2*) Coeff_raw 1, (*z^3*) Coeff_raw 2]], 
  (*y^2*) Powers_raw [(*x^0*) Coeff_raw 0, 
                  (*x^1*) Coeff_raw 0, 
                  (*x^2*) Powers_raw [(*z^0*) Coeff_raw 0, (*z^1*) Coeff_raw 0, (*z^2*) Coeff_raw 0, (*z^3*) Coeff_raw 3]]]"

value "Powers_raw [Coeff_raw 6, Coeff_raw 0, Powers_raw [Coeff_raw 0, Coeff_raw 3], Coeff_raw 0, Coeff_raw 5]" 
  --{*6 + 3.x^2.y + 5.x^4*}

(*datatype 'a raw_poly_rec = Coeff_raw 'a | Powers_raw "('a raw_poly_rec) list"*)

value "Coeff_raw (333::int)" --{**}
value "Coeff" --{**}
value "xxx" --{**}
value "xxx" --{**}
(**)
value "xxx" --{**}
(**)
value "xxx" --{**}
(**)
value "xxx" --{**}

subsubsection {* in SML define type, examples of poly_rec for tests *}
ML {*
datatype 'a poly_rec = Coeff of 'a | Powers of ('a poly_rec) list
*} ML {*
val p = (*=== x + -1.y ===*)
Powers [Powers [Coeff 0, Coeff 1],  Powers [Coeff ~1]] : int poly_rec;
(*      y^0.   (  x^0.0 +  x^1.1) + y^1.   (  x^0.-1)) *)
val p' = (*=== 2.x + 3.y ===*)
Powers [Powers [Coeff 0, Coeff 2],  Powers [Coeff 3]] : int poly_rec;
*} ML {*
val q = (*=== x^2 + x.y + y^2 ===*)
Powers [Powers [Coeff 0, Coeff 0, Coeff 1],  Powers [Coeff 0, Coeff 1],   Powers [Coeff 1]];
(*     (y^0.   (  x^0.0 +  x^1.0 +  x^2.1) + y^1.   (  x^0.0 +  x^1.1) +  y^2.   (  x^0.1)) *)
*} ML {*
val pq= (*=== x^3 + -1.y^3 ===*)
Powers [Powers [Coeff 0, Coeff 0, Coeff 0, Coeff 1],  Powers [Coeff 0],  Powers [Coeff 0],   Powers [Coeff ~1]];
(*     (y^0.   (  x^0.0 +  x^1.0 +  x^2.0 +  x^3.1) + y^1.   (  x^0.0) + y^2.   (  x^0.0) +  y^3.   (  x^0.-1))*)
*} ML {*
*} 

subsection {* Constructors *}
value "xxx" --{**}

subsection {* Size function on @{typ "_ poly_rec"} *}
value "xxx" --{**}

subsection {* Examples of recursive functions *}
value "Coeff (1::int)" --{* :: "int poly_rec"*}
term "plus_poly_rec" --{*NOT EXECUTABLE:
  "Nat_Mapping.Abs_nat_mapping" is not a constructor in theorem: 
  Nat_Mapping.zip_with ?xb (Abs_nat_mapping ?xa) ...*}

value "xxx" --{**}
value "xxx" --{**}

end
