(* runs with Isabelle2016-1,

for inspecting ML Code: Makarius Re: [isabelle] where to add coding
in mail > systems > isabelle > grundlagen

This mail, partly:
Note that in order to browse Isabelle/ML sources of tools in
Isabelle/HOL, you need to do this with "isabelle jedit -l Pure", i.e. in
a session that does not yet contain Isabelle/HOL. In contrast, tools in
other sessions (e.g. src/HOL/Library) require the default HOL image.

It is also possible to browse Isabelle/Pure sources with full IDE
annotations by opening src/Pure/ROOT.ML in Isabelle/jEdit. ...
*)
theory Towards_Scala_Editor imports Complex_Main
begin
  
lemma "12345 * 67 + 12345 * 33 = (1234500 ::int)"
  by simp 
  
section {* Discussion with Marco *}
subsection {* trials on Isabelle2016/src/Pure/Syntax/ast.ML *}
ML {*
[] : Ast.ast list
*} ML {*
Ast.Constant "/"
*} ML {*
Ast.Variable "x"
*} ML {*
*} ML {*
[] : int list
*} ML {*
Ast.Appl [Ast.Constant "/", Ast.Variable "x : 3/5", Ast.Variable "y"] :: [];
*} ML {*
Ast.Appl [Ast.Constant "/", Ast.Variable "+", Ast.Variable "y"] :: [];
*} 
subsection {* ASTs nicht verwechseln mit typ "term" *}
ML {* (* copy from proto4/repos/isac-java/isac/gui/mawen/TestsDATA.scala, def tt6 () *)
@{term "6 + (2 * x) / (4 * z::real)"}
*} text {*
   Const ("Groups.plus_class.plus", "real \<Rightarrow> real \<Rightarrow> real") $
     (Const ("Num.numeral_class.numeral", "num \<Rightarrow> real") $
       (Const ("Num.num.Bit0", "num \<Rightarrow> num") $
         (Const ("Num.num.Bit1", "num \<Rightarrow> num") $ Const ("Num.num.One", "num")))) $
     (Const ("Rings.divide_class.divide", "real \<Rightarrow> real \<Rightarrow> real") $
       (Const ("Groups.times_class.times", "real \<Rightarrow> real \<Rightarrow> real") $
         (Const ("Num.numeral_class.numeral", "num \<Rightarrow> real") $
           (Const ("Num.num.Bit0", "num \<Rightarrow> num") $ Const ("Num.num.One", "num"))) $
         Free ("x", "real")) $
       (Const ("Groups.times_class.times", "real \<Rightarrow> real \<Rightarrow> real") $
         (Const ("Num.numeral_class.numeral", "num \<Rightarrow> real") $
           (Const ("Num.num.Bit0", "num \<Rightarrow> num") $
             (Const ("Num.num.Bit0", "num \<Rightarrow> num") $ Const ("Num.num.One", "num")))) $
         Free ("z", "real"))):
*}
section {* Survey on code for AST - AST translations *}
subsection {* How much do respective files change, e.g. Isabelle 2015 -- Isabelle2016-1 *}
text {*
  ~~/src/Pure/library.ML              - cd - pwd - user errors, + trim + align_right, ...
  ~~/src/Pure/term.ML                 + term_name + dependent_lambda_name + could_beta*, ...
  ~~/src/Pure/Isar/isac_cmd.ML        - have - hence - thus ...
  ~~/src/Pure/Syntax/ast.ML           - ML_system_pp ...
  ~~/src/Pure/Syntax/local_syntax.ML  + mixfix Structure _,  ...
  ~~/src/Pure/Syntax/syntax.ML        M install_operations: operations -> theory -> theory
  ~~/src/Pure/Syntax/syntax_phases.ML M dozens of details

Conclusion: investigation of Isabelle2015 makes still sense; is in the repository.
*}
subsection {* Occurrences of Ast.* in the whole distribution: *}
text {* 
wneuper@wneuper-w541:/usr/local/isabisac$ grep -r "Ast." *
NEWS:to structure Syntax (Ast, Lexicon, Mixfix, Parser, Printer etc.): less
NEWS:refer directly to Ast.Constant, Lexicon.is_identifier,

src/Doc/Classes/Setup.thy:    fun alpha_ast_tr [] = Ast.Variable "'a"
src/Doc/Isar_Ref/Inner_Syntax.thy:  @..{ML [display] \<open>Ast.Appl [Ast.Constant "_abs", Ast.Variable "x", Ast.Variable "t"]\<close>}

src/Pure/Proof/proof_syntax.ML:    [(Ast.mk_appl (Ast.Constant "_Lam")
src/Pure/sign.ML:    (string * (Proof.context -> Ast.ast list -> Ast.ast)) list -> theory -> theory
src/Pure/sign.ML:  val add_trrules: Ast.ast Syntax.trrule list -> theory -> theory
src/Pure/sign.ML:  val del_trrules: Ast.ast Syntax.trrule list -> theory -> theory

src/Pure/Syntax/syntax.ML:  val parse_ast_translation: syntax -> string -> (Proof.context -> Ast.ast list -> Ast.ast) option
src/Pure/Syntax/syntax.ML:  val parse_rules: syntax -> string -> (Ast.ast * Ast.ast) list
src/Pure/Syntax/syntax.ML:  val print_rules: syntax -> string -> (Ast.ast * Ast.ast) list
src/Pure/Syntax/syntax.ML:    Proof.context -> Ast.ast list -> Ast.ast  (*exception Match*)
src/Pure/Syntax/syntax.ML:    (string * ((Proof.context -> Ast.ast list -> Ast.ast) * stamp)) list *
src/Pure/Syntax/syntax.ML:    (string * ((Proof.context -> Ast.ast list -> Ast.ast) * stamp)) list -> syntax -> syntax
src/Pure/Syntax/syntax.ML:  val update_trrules: Ast.ast trrule list -> syntax -> syntax
src/Pure/Syntax/syntax.ML:  val remove_trrules: Ast.ast trrule list -> syntax -> syntax
src/Pure/Syntax/syntax.ML:type ruletab = (Ast.ast * Ast.ast) list Symtab.table;
src/Pure/Syntax/syntax.ML:val update_ruletab = fold_rev (fn r => Symtab.update_list (op =) (Ast.head_of_rule r, r));
src/Pure/Syntax/syntax.ML:val remove_ruletab = fold (fn r => Symtab.remove_list (op =) (Ast.head_of_rule r, r));
src/Pure/Syntax/syntax.ML:    parse_ast_trtab: ((Proof.context -> Ast.ast list -> Ast.ast) * stamp) Symtab.table,
src/Pure/Syntax/syntax.ML:    print_ast_trtab: ((Proof.context -> Ast.ast list -> Ast.ast) * stamp) list Symtab.table,
src/Pure/Syntax/syntax.ML:      Pretty.big_list name (map (Pretty.item o single o Ast.pretty_rule) (dest_ruletab tab));
src/Pure/Syntax/syntax.ML:  (case Ast.rule_error rule of
src/Pure/Syntax/syntax.ML:        Pretty.string_of (Ast.pretty_rule rule))

src/Pure/Syntax/syntax_ext.ML:      parse_ast_translation: (string * ((Proof.context -> Ast.ast list -> Ast.ast) * stamp)) list,
src/Pure/Syntax/syntax_ext.ML:      parse_rules: (Ast.ast * Ast.ast) list,
src/Pure/Syntax/syntax_ext.ML:      print_rules: (Ast.ast * Ast.ast) list,
src/Pure/Syntax/syntax_ext.ML:      print_ast_translation: (string * ((Proof.context -> Ast.ast list -> Ast.ast) * stamp)) list}
src/Pure/Syntax/syntax_ext.ML:  val syn_ext_rules: (Ast.ast * Ast.ast) list * (Ast.ast * Ast.ast) list -> syn_ext
src/Pure/Syntax/syntax_ext.ML:    parse_ast_translation: (string * ((Proof.context -> Ast.ast list -> Ast.ast) * stamp)) list,
src/Pure/Syntax/syntax_ext.ML:    parse_rules: (Ast.ast * Ast.ast) list,
src/Pure/Syntax/syntax_ext.ML:    print_rules: (Ast.ast * Ast.ast) list,
src/Pure/Syntax/syntax_ext.ML:    print_ast_translation: (string * ((Proof.context -> Ast.ast list -> Ast.ast) * stamp)) list};

src/Pure/Syntax/ast.ML:structure Ast: AST =

src/Pure/Syntax/printer.ML:    (string -> Proof.context -> Ast.ast list -> Ast.ast) ->

src/Pure/Syntax/syntax_trans.ML:  val tappl_ast_tr': Ast.ast * Ast.ast list -> Ast.ast
src/Pure/Syntax/syntax_trans.ML:  val appl_ast_tr': Ast.ast * Ast.ast list -> Ast.ast
src/Pure/Syntax/syntax_trans.ML:  val pure_parse_ast_translation: (string * (Proof.context -> Ast.ast list -> Ast.ast)) list
src/Pure/Syntax/syntax_trans.ML:  val pure_print_ast_translation: (string * (Proof.context -> Ast.ast list -> Ast.ast)) list
src/Pure/Syntax/syntax_trans.ML:fun strip_positions_ast_tr [ast] = Ast.strip_positions ast
src/Pure/Syntax/syntax_trans.ML:fun constify_ast_tr [Ast.Variable c] = Ast.Constant c
src/Pure/Syntax/syntax_trans.ML:fun tapp_ast_tr [ty, c] = Ast.Appl [c, ty]
src/Pure/Syntax/syntax_trans.ML:fun tappl_ast_tr [ty, tys, c] = Ast.mk_appl c (ty :: Ast.unfold_ast "_types" tys)
src/Pure/Syntax/syntax_trans.ML:fun appl_ast_tr [f, args] = Ast.Appl (f :: Ast.unfold_ast "_args" args)
src/Pure/Syntax/syntax_trans.ML:fun applC_ast_tr [f, args] = Ast.Appl (f :: Ast.unfold_ast "_cargs" args)
src/Pure/Syntax/syntax_trans.ML:fun idtyp_ast_tr [x, ty] = Ast.Appl [Ast.Constant "_constrain", x, ty]
src/Pure/Syntax/syntax_trans.ML:fun lambda_ast_tr [pats, body] = Ast.fold_ast_p "_abs" (Ast.unfold_ast "_pttrns" pats, body)
src/Pure/Syntax/syntax_trans.ML:fun indexvar_ast_tr [] = Ast.Appl [Ast.Constant "_index", Ast.Variable "some_index"]
src/Pure/Syntax/syntax_trans.ML:fun struct_ast_tr [Ast.Appl [Ast.Constant "_index", ast]] = ast
src/Pure/Syntax/syntax_trans.ML:fun tappl_ast_tr' (f, []) = raise Ast.AST ("tappl_ast_tr'", [f])
src/Pure/Syntax/syntax_trans.ML:fun appl_ast_tr' (f, []) = raise Ast.AST ("appl_ast_tr'", [f])
src/Pure/Syntax/syntax_trans.ML:fun idtyp_ast_tr' a [Ast.Appl [Ast.Constant "_constrain", x, ty], xs] =
src/Pure/Syntax/syntax_trans.ML:fun index_ast_tr' [Ast.Appl [Ast.Constant "_struct", ast]] = ast
src/Pure/Syntax/syntax_trans.ML:fun struct_ast_tr' ctxt [Ast.Constant "_indexdefault"] =

src/Pure/Syntax/syntax_phases.ML:  val parse_ast_pattern: Proof.context -> string * string -> Ast.ast
src/Pure/Syntax/syntax_phases.ML:    fun term_of (Ast.Constant a) = trans a []
src/Pure/Syntax/syntax_phases.ML:      | term_of (Ast.Variable x) = Lexicon.read_var x
src/Pure/Syntax/syntax_phases.ML:      | term_of (Ast.Appl (Ast.Constant a :: (asts as _ :: _))) =
src/Pure/Syntax/syntax_phases.ML:      | term_of (Ast.Appl (ast :: (asts as _ :: _))) =
src/Pure/Syntax/syntax_phases.ML:      | term_of (ast as Ast.Appl _) = raise Ast.AST ("ast_to_term: malformed ast", [ast]);
src/Pure/Syntax/syntax_phases.ML:        (Ast.normalize ctxt parse_rules #> Exn.interruptible_capture (ast_to_term ctxt tr)) asts;
src/Pure/Syntax/syntax_phases.ML:    fun decode_const ps c = (report ps (markup_entity ctxt) c; Ast.Constant c);
src/Pure/Syntax/syntax_phases.ML:    fun decode_var ps x = (report ps (fn () => [Markup.name x Markup.free]) (); Ast.Variable x);
src/Pure/Syntax/syntax_phases.ML:    fun decode_appl ps asts = Ast.Appl (map (decode ps) asts)
src/Pure/Syntax/syntax_phases.ML:    and decode ps (Ast.Constant c) = decode_const ps c
src/Pure/Syntax/syntax_phases.ML:    fun ast_of (Const (c, _)) = Ast.Constant c
src/Pure/Syntax/syntax_phases.ML:      | ast_of (Free (x, _)) = Ast.Variable x
src/Pure/Syntax/syntax_phases.ML:      | ast_of (Var (xi, _)) = Ast.Variable (tune_var (Term.string_of_vname xi))
src/Pure/Syntax/syntax_phases.ML:      | ast_of (Bound i) = Ast.Appl [Ast.Constant "_loose", Ast.Variable ("B." ^ string_of_int i)]
src/Pure/Syntax/syntax_phases.ML:    fun markup_trans a [Ast.Variable x] = token_trans a x

src/Pure/Isar/runtime.ML:            | Ast.AST (msg, asts) =>
src/Pure/Isar/attrib.ML:  register_config Ast.trace_raw #>
src/Pure/Isar/isar_cmd.ML:    "(string * (Proof.context -> Ast.ast list -> Ast.ast)) list"

src/HOL/  HOLCF/ex/Pattern_Match.thy:      fun app s (l, r) = Ast.mk_appl (Ast.Constant s) [l, r];
src/HOL/  HOLCF/Tools/Domain/domain_constructors.ML:      fun expvar n = Ast.Variable ("e" ^ showint n)
src/HOL/  HOLCF/Tools/Domain/domain_constructors.ML:      fun argvar n (m, _) = Ast.Variable ("a" ^ showint n ^ "_" ^ showint m)
src/HOL/  HOLCF/Tools/Domain/domain_constructors.ML:      val trans_rules : Ast.ast Syntax.trrule list =
src/HOL/  HOLCF/Tools/cont_consts.ML:    val extra_parse_rule = Syntax.Parse_Rule (Ast.Constant name2, Ast.Constant name1)

src/HOL/Tools/string_syntax.ML:  Ast.Constant o Lexicon.mark_const o
src/HOL/Tools/string_syntax.ML:fun mk_string [] = Ast.Constant @..{const_syntax Nil}
src/HOL/Tools/string_syntax.ML:fun string_ast_tr [Ast.Variable str] =
*}
subsection {* Analysis of Ast. *}
subsubsection {* Can a LaTeX-level be handled analogously to Position ? *}
ML {* (***************************** Pure/Syntax/ast.ML: val strip_positions: ast -> ast *)
fun strip_positions (Ast.Appl ((t as Ast.Constant c) :: u :: (v as Ast.Variable x) :: asts)) =
      (* these are pos. data                      ^    ?!?                      ^ *)
      if member (op =) Term_Position.markers c andalso is_some (Term_Position.decode x)
      then Ast.mk_appl (strip_positions u) (map strip_positions asts)
      (* these are PROBABLY NOT pos.    ^                       ^^^^ *)
      else Ast.Appl (map strip_positions (t :: u :: v :: asts))
  | strip_positions (Ast.Appl asts) = Ast.Appl (map strip_positions asts)
  | strip_positions ast = ast;
(*
c: member of ["_constrain", "_constrainAbs", "_ofsort"]  ...see term_position.ML
x: string representing Pos ((i, j, k), norm_props props) ...see position.ML
*)

(*the list of subasts of an Appl node has to contain at least 2 elements, i.e.
  there are no empty asts or nullary applications; use mk_appl for convenience*)
fun mk_appl f [] = f
  | mk_appl f args = Ast.Appl (f :: args);
*} ML {*
*} ML {* (************************** Pure/Syntax/term_position.ML: also used in List.thy etc.!!! 
  val decode: string -> Position.T option
*)
val markers = ["_constrain", "_constrainAbs", "_ofsort"];
val position_dummy = "<position>";
val position_text = XML.Text position_dummy;

fun decode str =
  (case YXML.parse_body str handle Fail msg => error msg of
    [XML.Elem ((name, props), [arg])] =>
      if name = Markup.positionN andalso arg = position_text
      then SOME (Position.of_properties props)
      else NONE
  | _ => NONE);
*} ML {* (************************** Pure/General/properties.ML
  val of_properties: Properties.T -> T
*)
type entry = string * string;
type T = entry list;
*} ML {* (************************** Pure/General/position.ML
  val make: {line: int, offset: int, end_offset: int, props: Properties.T} -> T
  val of_properties: Properties.T -> T
*)
datatype T = Pos of (int * int * int) * Properties.T;
fun norm_props (props: Properties.T) =
  maps (fn a => the_list (find_first (fn (b, _) => a = b) props))
    Markup.position_properties';
fun make {line = i, offset = j, end_offset = k, props} = Pos ((i, j, k), norm_props props);
(*fun get (props: T) name = AList.lookup (op =) props name;
ML error\<here>:
Type error in function application. 
Function: AList.lookup (=) : (''a * 'b) list -> ''a -> 'b option 
Argument: props : T Reason: Can't unify (''a * 'b) list (*In Basis*) with T (Different type constructors)
*)
*} ML {* (************************** Pure/PIDE/markup.ML ,.scala *)
  type T = string * Properties.T

fun markup_elem name = (name, (name, []): T);
fun markup_string name prop = (name, fn s => (name, [(prop, s)]): T);
(* Isabelle2015
fun markup_int name prop = (name, fn i => (name, [(prop, Markup.print_int i)]): T);*)
fun markup_int name prop = (name, fn i => (name, [(prop, Value.print_int i)]): T);

val (positionN, position) = markup_elem "position";

*} ML {* (************************** Pure/General/value.ML ,.scala *)
*} text {*...    ??? val print_int = signed_string_of_int;
ML/ml_syntax.ML: ??? val print_int = string_of_int;
*} ML {*
*}

subsection {* syntax in List.thy *}
subsubsection {*  *}
text {*
WN150517: 
# for list-syntax with "[..]" the only entries are:
syntax
  \<comment> \<open>list Enumeration\<close>
  "_list" :: "args => 'a list"    ("[(_)]")

translations
  "[x, xs]" == "x#[xs]"
  "[x]" == "x#[]"
# there are print_rules, clear
# there are trf, trans, UNclear

# ast - ast -translation SPECIFIC FOR list_update
primrec list_update :: "'a list \<Rightarrow> nat \<Rightarrow> 'a \<Rightarrow> 'a list" where
"list_update [] i v = []" |
"list_update (x # xs) i v =
  (case i of 0 \<Rightarrow> v # xs | Suc j \<Rightarrow> x # list_update xs j v)"

nonterminal lupdbinds and lupdbind

syntax
  "_lupdbind":: "['a, 'a] => lupdbind"    ("(2_ :=/ _)")
  "" :: "lupdbind => lupdbinds"    ("_")
  "_lupdbinds" :: "[lupdbind, lupdbinds] => lupdbinds"    ("_,/ _")
  "_LUpdate" :: "['a, lupdbinds] => 'a"    ("_/[(_)]" [900,0] 900)

translations
  "_LUpdate xs (_lupdbinds b bs)" == "_LUpdate (_LUpdate xs b) bs"
  "xs[i:=x]" == "CONST list_update xs i x"
  
  ERROR LAST LINE ABOVE:
  Ambiguous input\<here> produces 2 parse trees:
  ("_LUpdate" ("_position" xs) ("_lupdbind" ("_position" i) ("_position" x)))
  ("_LUpdate" ("_position" xs) ("_lupdbind" ("_position" i) ("_position" x)))
*} ML {*
*}
  
  
ML {*
*} text {*
*} ML {*
*}

section {* Isabelle's tracing features *}
subsection {* Representation of subscripts *}
ML {* (************************** Pure/General/value.ML ,.scala *)
*} ML {*
val t1 = @{term "xxx\<^sub>1"};
val t2 = @{term "xxx\<^sub>1"}; (* separated by " ": "x x x \ < ^ s u b > 1"*)
val t3 = @{term "xxx\<^sub>a"};
val t4 = @{term "xxx\<^sub>123"};
val t5 = @{term "xxx\<^sub>_1"};
t1 = t2;
*} ML {*
val Free (str, _) = t1;
str = "xxx\<^sub>1";     (* Isabelle/ML has its own strings *)
*} ML {*
Symbol.explode str = ["x", "x", "x", "\<^sub>", "1"];
val strs = Symbol.explode str;
nth strs 3 = "\<^sub>"; (* Isabelle/ML has its own strings *)
*} ML {*
val sub = nth strs 3;
ord sub = 92
*} ML {*          (* trials about isar-ref.pdf p.53 *)
"\092"; sub = "\092";
"092";  sub = "092";
*} ML {*
*} ML {*
val Free (str, _) = t4;
str = "xxx\<^sub>123"; (* subscripts have 1 digit/letter; what about more ...*)
(*@{term "xxx\<^bsub>123\<^esub>"};*)
         "xxx\<^bsub>123\<^esub>";
(*@{term "xxx\ <^bsub>123\ <^esub>"};  ^^^ ??? *)
*} ML {*
*} ML {*
*}
subsection {* Inspection of ast-translations *}
text {*
  There seems no tracing for ast-translations
  isar-ref.pdf    p.vvv
*}
print_syntax   (* p.184 *)
(* with the sections:
# lexicon: "!" "!!" "#" "%" "&" "&&&" "(" "()" "(|" ")" "*" "*\<^sub>R" "+" "++" "," "-" "-->" "-`"
  :
# prods:
  Fun.updbind = any[0] ":=" any[0] => "_updbind" (1000)
  Fun.updbinds = Fun.updbind[0] "," Fun.updbinds[0] => "_updbinds" (1000)
  Fun.updbinds = Fun.updbind[-1] (-1)
  HOL.case_syn = any[0] "=>" any[0] => "_case1" (10)
  :
# print_modes: "ASCII" "epsilon" "iff" "input" "latex" "latex_prod" "latex_sum"
# consts: "\ <^const>Filter.Alm_all_binder" "\ <^const>Filter.Inf_many_binder"
  :
# parse_rules:
    ("_Bex" x A P)  ->  ("\ <^const>Set.Bex" A ("_abs" x P))
    ("_Eps" x P)  ->  ("\ <^const>Hilbert_Choice.Eps" ("_abs" x P))
    :
# print_rules:
    ("\ <^const>List.list.Cons" x ("_list" xs))  ->  ("_list" ("_args" x xs))
    ("\ <^const>List.list.Cons" x "\ <^const>List.list.Nil")  ->  ("_list" x)

# parse_ast_translation: "_appl" "_applC" "_bigimpl" "_bracket" "_constify" "_context_const"
  "_context_xconst" "_idtyp" "_indexdefault" "_indexvar" "_lambda" "_strip_positions"
  "_struct" "_tapp" "_tappl"

# print_ast_translation: "\ <^const>Pure.imp" "\ <^type>fun" "_abs" "_idts" "_index" "_list"
  "_pttrns" "_struct"

# parse_translations: "\ <^const>Filter.Alm_all_binder" "\ <^const>Filter.Inf_many_binder"
  "\ <^const>HOL.All_binder"
  :
# print_translations: "\ <^const>Complete_Lattices.INTER"
  "\ <^const>Complete_Lattices.Inf_class.INFIMUM"
  :
*) 
text {*
print_rules  (* thms, NOT confuse with print_rules contained in print_syntax *)
*}
  
subsection {* Tracing ast-translations *}
text {*
  Isabelle2016-1/isar-ref.pdf p.216:
    declare [[simp_break "?x ^ ?y"]]
  From this + ~~/src/Pure/Syntax/ast.ML:
    val trace_raw = Config.declare ("syntax_ast_trace", @ {here}) ..
  we infer ...
*}
declare [[syntax_ast_trace=true]]
declare [[syntax_ast_stats=true]] (*... doesn't add to the subsequent traces *)
declare [[show_types=false]]

subsubsection {* aaa + bbb + ccc *}
ML {*
@{term "aaa + bbb + ccc :: int"} (* trace vvv ... ONLY ------- ast_to_term ------- *)

*} text {* trace: 
pre:
("_constrain" 
  ("\ <^const>Groups.plus_class.plus" 
    ("\ <^const>Groups.plus_class.plus" ("_constrain" aaa <position>) ("_constrain" bbb <position>)
    )
    ("_constrain" ccc <position>)
  )
  "\ <^type>Int.int"
) 
*} ML {*
@{term "aaa + (bbb + ccc) :: int"} (* trace vvv ... ONLY ------- ast_to_term ------- *)
*} text {*
pre:
("_constrain" 
  ("\ <^const>Groups.plus_class.plus" ("_constrain" aaa <position>)
    ("\ <^const>Groups.plus_class.plus" ("_constrain" bbb <position>) ("_constrain" ccc <position>))
  )
  "\ <^type>Int.int"
)
*} text {*
  Conclusion: so far tracing is not very informative; we insert code into
  "source positions for further investigation", see below.
*}
subsubsection {* where are "()" in: a1 + (a2 + a3) *}
lemma "a1 + (a2 + a3) = a1 + a2 + (a3::int)"
  by simp
text {* COMPLETE OUTPUT FROM OUR "Ast.pretty_ast": NO "()" WITHIN AST-TRANSLATIONS,
  done outside Ast-translations:
    thus Editor handles associativity and "()" by Scala code as well.
  NOTE: "," MARKS INDENTATION APPROPRIATELY
---------------------------- ast_to_term ---------------------------- 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
           Appl(List(Constant("_constrain") ,   Variable("a1") ,   <position>)) ,  
           Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
             Appl(List(Constant("_constrain") ,   Variable("a2") ,   <position>)) ,  
             Appl(List(Constant("_constrain") ,   Variable("a3") ,   <position>))))))
         ,   Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
               Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                 Appl(List(Constant("_constrain") ,   Variable("a1") ,   <position>)) ,  
                 Appl(List(Constant("_constrain") ,   Variable("a2") ,   <position>))))
               ,   Appl(List(Constant("_constrain") ,  
                     Appl(List(Constant("_constrain") ,   Variable("a3") ,   <position>)) ,  
                     Constant("\ <^type>Int.int"))))))))) 
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
            Appl(List(Constant("_constrain") ,   Variable("a1") ,   <position>)) ,  
            Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
              Appl(List(Constant("_constrain") ,   Variable("a2") ,   <position>)) ,  
              Appl(List(Constant("_constrain") ,   Variable("a3") ,   <position>))))))
          ,   Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                  Appl(List(Constant("_constrain") ,   Variable("a1") ,   <position>)) ,  
                  Appl(List(Constant("_constrain") ,   Variable("a2") ,   <position>))))
                ,   Appl(List(Constant("_constrain") ,  
                      Appl(List(Constant("_constrain") ,   Variable("a3") ,   <position>)) ,  
                      Constant("\ <^type>Int.int")))))))))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Constant("\ <^type>Int.int") 
post: Constant("\ <^type>Int.int")
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Constant("\ <^type>Int.int") 
post: Constant("\ <^type>Int.int")
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Constant("\ <^type>Int.int") 
post: Constant("\ <^type>Int.int")
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Constant("\ <^type>Int.int") 
post: Constant("\ <^type>Int.int")
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Constant("\ <^type>Int.int") 
post: Constant("\ <^type>Int.int")
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Constant("\ <^type>Int.int") 
post: Constant("\ <^type>Int.int")
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
           Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("a1"))) ,  
             Constant("\ <^type>Int.int")))
           ,   Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                 Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("a2")))
                   ,   Constant("\ <^type>Int.int")))
                 ,   Appl(List(Constant("_constrain") ,  
                       Appl(List(Constant("_free") ,   Variable("a3"))) ,  
                       Constant("\ <^type>Int.int")))))))
         ,   Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
               Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                 Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("a1")))
                   ,   Constant("\ <^type>Int.int")))
                 ,   Appl(List(Constant("_constrain") ,  
                       Appl(List(Constant("_free") ,   Variable("a2"))) ,  
                       Constant("\ <^type>Int.int")))))
               ,   Appl(List(Constant("_constrain") ,  
                     Appl(List(Constant("_free") ,   Variable("a3"))) ,  
                     Constant("\ <^type>Int.int"))))))))) 
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
            Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("a1"))) ,  
              Constant("\ <^type>Int.int")))
            ,   Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                  Appl(List(Constant("_constrain") ,  
                    Appl(List(Constant("_free") ,   Variable("a2"))) ,   Constant("\ <^type>Int.int")))
                  ,   Appl(List(Constant("_constrain") ,  
                        Appl(List(Constant("_free") ,   Variable("a3"))) ,  
                        Constant("\ <^type>Int.int")))))))
          ,   Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                  Appl(List(Constant("_constrain") ,  
                    Appl(List(Constant("_free") ,   Variable("a1"))) ,   Constant("\ <^type>Int.int")))
                  ,   Appl(List(Constant("_constrain") ,  
                        Appl(List(Constant("_free") ,   Variable("a2"))) ,  
                        Constant("\ <^type>Int.int")))))
                ,   Appl(List(Constant("_constrain") ,  
                      Appl(List(Constant("_free") ,   Variable("a3"))) ,  
                      Constant("\ <^type>Int.int")))))))))
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
           Appl(List(Constant("_constrain") ,   Appl(List(Constant("_var") ,   Variable("?a"))) ,  
             Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
               Constant("\ <^class>Rings.comm_semiring_1")))))
           ,   Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                 Appl(List(Constant("_constrain") ,   Appl(List(Constant("_var") ,   Variable("?c")))
                   ,   Appl(List(Constant("_ofsort") ,  
                         Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
                         Constant("\ <^class>Rings.comm_semiring_1")))))
                 ,   Appl(List(Constant("_constrain") ,  
                       Appl(List(Constant("_var") ,   Variable("?d"))) ,  
                       Appl(List(Constant("_ofsort") ,  
                         Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
                         Constant("\ <^class>Rings.comm_semiring_1")))))))))
         ,   Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
               Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                 Appl(List(Constant("_constrain") ,   Appl(List(Constant("_var") ,   Variable("?a")))
                   ,   Appl(List(Constant("_ofsort") ,  
                         Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
                         Constant("\ <^class>Rings.comm_semiring_1")))))
                 ,   Appl(List(Constant("_constrain") ,  
                       Appl(List(Constant("_var") ,   Variable("?c"))) ,  
                       Appl(List(Constant("_ofsort") ,  
                         Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
                         Constant("\ <^class>Rings.comm_semiring_1")))))))
               ,   Appl(List(Constant("_constrain") ,  
                     Appl(List(Constant("_var") ,   Variable("?d"))) ,  
                     Appl(List(Constant("_ofsort") ,  
                       Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
                       Constant("\ <^class>Rings.comm_semiring_1"))))))))))) 
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
            Appl(List(Constant("_constrain") ,   Appl(List(Constant("_var") ,   Variable("?a"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
                Constant("\ <^class>Rings.comm_semiring_1")))))
            ,   Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                  Appl(List(Constant("_constrain") ,   Appl(List(Constant("_var") ,   Variable("?c")))
                    ,   Appl(List(Constant("_ofsort") ,  
                          Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
                          Constant("\ <^class>Rings.comm_semiring_1")))))
                  ,   Appl(List(Constant("_constrain") ,  
                        Appl(List(Constant("_var") ,   Variable("?d"))) ,  
                        Appl(List(Constant("_ofsort") ,  
                          Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
                          Constant("\ <^class>Rings.comm_semiring_1")))))))))
          ,   Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
                  Appl(List(Constant("_constrain") ,   Appl(List(Constant("_var") ,   Variable("?a")))
                    ,   Appl(List(Constant("_ofsort") ,  
                          Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
                          Constant("\ <^class>Rings.comm_semiring_1")))))
                  ,   Appl(List(Constant("_constrain") ,  
                        Appl(List(Constant("_var") ,   Variable("?c"))) ,  
                        Appl(List(Constant("_ofsort") ,  
                          Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
                          Constant("\ <^class>Rings.comm_semiring_1")))))))
                ,   Appl(List(Constant("_constrain") ,  
                      Appl(List(Constant("_var") ,   Variable("?d"))) ,  
                      Appl(List(Constant("_ofsort") ,  
                        Appl(List(Constant("_tvar") ,   Variable("?'a"))) ,  
                        Constant("\ <^class>Rings.comm_semiring_1")))))))))))
normalize: 1 passes, 0 changes, 0 matches failed 
Auto solve_direct: The current goal can be solved directly with
  Semiring_Normalization.comm_semiring_1_class.semiring_normalization_rules(25):
    ?a + (?c + ?d) = ?a + ?c + ?d
*} ML {*
*}
    
subsubsection {* how are numerals handled: "4 + 6 = 10" *}
lemma "4 + 6 = 10"
  by simp   
text {* COMPLETE OUTPUT FROM OUR "Ast.pretty_ast": conversion on term (not ast)
---------------------------- ast_to_term ---------------------------- 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
           Appl(List(Constant("_Numeral") ,  
             Appl(List(Constant("_constrain") ,   Constant("4") ,   <position>))))
           ,   Appl(List(Constant("_Numeral") ,  
                 Appl(List(Constant("_constrain") ,   Constant("6") ,   <position>))))))
         ,   Appl(List(Constant("_Numeral") ,  
               Appl(List(Constant("_constrain") ,   Constant("10") ,   <position>)))))))) 
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
            Appl(List(Constant("_Numeral") ,  
              Appl(List(Constant("_constrain") ,   Constant("4") ,   <position>))))
            ,   Appl(List(Constant("_Numeral") ,  
                  Appl(List(Constant("_constrain") ,   Constant("6") ,   <position>))))))
          ,   Appl(List(Constant("_Numeral") ,  
                Appl(List(Constant("_constrain") ,   Constant("10") ,   <position>))))))))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
       Constant("\ <^class>Num.numeral"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>Num.numeral")))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
       Constant("\ <^class>Num.numeral"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>Num.numeral")))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
       Constant("\ <^class>Num.numeral"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>Num.numeral")))
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
           Appl(List(Constant("_constrain") ,  
             Appl(List(Constant("_Numeral") ,   Variable("4"))) ,  
             Appl(List(Constant("_ofsort") ,  
               Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
               Constant("\ <^class>Num.numeral")))))
           ,   Appl(List(Constant("_constrain") ,  
                 Appl(List(Constant("_Numeral") ,   Variable("6"))) ,  
                 Appl(List(Constant("_ofsort") ,  
                   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                   Constant("\ <^class>Num.numeral")))))))
         ,   Appl(List(Constant("_constrain") ,  
               Appl(List(Constant("_Numeral") ,   Variable("10"))) ,  
               Appl(List(Constant("_ofsort") ,  
                 Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                 Constant("\ <^class>Num.numeral"))))))))) 
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Constant("\ <^const>Groups.plus_class.plus") ,  
            Appl(List(Constant("_constrain") ,  
              Appl(List(Constant("_Numeral") ,   Variable("4"))) ,  
              Appl(List(Constant("_ofsort") ,  
                Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                Constant("\ <^class>Num.numeral")))))
            ,   Appl(List(Constant("_constrain") ,  
                  Appl(List(Constant("_Numeral") ,   Variable("6"))) ,  
                  Appl(List(Constant("_ofsort") ,  
                    Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                    Constant("\ <^class>Num.numeral")))))))
          ,   Appl(List(Constant("_constrain") ,  
                Appl(List(Constant("_Numeral") ,   Variable("10"))) ,  
                Appl(List(Constant("_ofsort") ,  
                  Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                  Constant("\ <^class>Num.numeral")))))))))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Constant("\ <^type>Enum.finite_1") 
post: Constant("\ <^type>Enum.finite_1")
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Constant("\ <^type>Enum.finite_1") 
post: Constant("\ <^type>Enum.finite_1")
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
       Constant("\ <^class>Num.numeral"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>Num.numeral")))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Constant("\ <^class>Num.numeral") 
post: Constant("\ <^class>Num.numeral")
normalize: 1 passes, 0 changes, 0 matches failed
*} ML {*
*}

subsection {* Tracing ast-translations for list *}
lemma "[aaa,bbb] = ddd"
  oops

subsubsection {* handling input: ast_to_term *}
text {*
---------------------------- ast_to_term ---------------------------- 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("_list") ,  
           Appl(List(Constant("_args") ,   Appl(List(Constant("_constrain") ,   Variable("aaa") ,   <position>)) ,  
             Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>))))))
         ,   Appl(List(Constant("_constrain") ,   Variable("ddd") ,   <position>)))))) 
###try_rules ast: Appl(List(Constant("_list"), Appl(List(Constant("_args"), Appl(List(Constant("_constrain"), Variable("aaa"), Variable("<position>"))), Appl(List(Constant("_constrain"), Variable("bbb"), Variable("<position>"))))))) 
###try_rules lhs: Appl(List(Constant("_list"), Appl(List(Constant("_args"), Variable("x"), Variable("xs"))))) 
###try_rules rhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Appl(List(Constant("_list"), Variable("xs"))))) 
rewrote:
  Appl(List(Constant("_list") ,  
    Appl(List(Constant("_args") ,   Appl(List(Constant("_constrain") ,   Variable("aaa") ,   <position>)) ,  
      Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>))))))  ->
    Appl(List(Constant("\ <^const>List.list.Cons") ,   Appl(List(Constant("_constrain") ,   Variable("aaa") ,   <position>)) ,  
      Appl(List(Constant("_list") ,   Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)))))) 
###try_rules ast: Appl(List(Constant("_list"), Appl(List(Constant("_constrain"), Variable("bbb"), Variable("<position>"))))) 
###try_rules lhs: Appl(List(Constant("_list"), Variable("x"))) 
###try_rules rhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Constant("\ <^const>List.list.Nil"))) 
rewrote:
  Appl(List(Constant("_list") ,   Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>))))  ->
    Appl(List(Constant("\ <^const>List.list.Cons") ,   Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)) ,  
      Constant("\ <^const>List.list.Nil"))) 
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Constant("\ <^const>List.list.Cons") ,   Appl(List(Constant("_constrain") ,   Variable("aaa") ,   <position>)) ,  
            Appl(List(Constant("\ <^const>List.list.Cons") ,   Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)) ,  
              Constant("\ <^const>List.list.Nil")))))
          ,   Appl(List(Constant("_constrain") ,   Variable("ddd") ,   <position>))))))
normalize: 2 passes, 2 changes, 1 matches failed 
pre: Appl(List(Constant("\ <^type>List.list") ,  
       Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type"))))) 
post: Appl(List(Constant("\ <^type>List.list") ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type")))))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type")))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type")))
normalize: 1 passes, 0 changes, 0 matches failed 

---------------------------- term_to_ast ---------------------------- vvv
*}
subsubsection {* creating output: term_to_ast *}
text {*
---------------------------- term_to_ast ---------------------------- 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("\ <^const>List.list.Cons") ,  
           Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,  
             Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type")))))
           ,   Appl(List(Constant("\ <^const>List.list.Cons") ,  
                 Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
                   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                     Constant("\ <^class>HOL.type")))))
                 ,   Constant("\ <^const>List.list.Nil")))))
         ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
               Appl(List(Constant("\ <^type>List.list") ,  
                 Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                   Constant("\ <^class>HOL.type"))))))))))) 
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("bbb"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))), Constant("\ <^const>List.list.Nil"))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Constant("\ <^const>List.list.Nil"))) 
###try_rules rhs: Appl(List(Constant("_list"), Variable("x"))) 
rewrote:
  Appl(List(Constant("\ <^const>List.list.Cons") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type")))))
    ,   Constant("\ <^const>List.list.Nil")))  ->
    Appl(List(Constant("_list") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type"))))))) 
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("aaa"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_list"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("bbb"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))))))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Appl(List(Constant("_list"), Variable("xs"))))) 
###try_rules rhs: Appl(List(Constant("_list"), Appl(List(Constant("_args"), Variable("x"), Variable("xs"))))) 
rewrote:
  Appl(List(Constant("\ <^const>List.list.Cons") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type")))))
    ,   Appl(List(Constant("_list") ,  
          Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
            Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
              Constant("\ <^class>HOL.type")))))))))  ->
    Appl(List(Constant("_list") ,  
      Appl(List(Constant("_args") ,  
        Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,  
          Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type")))))
        ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                Constant("\ <^class>HOL.type"))))))))) 
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Constant("_list") ,  
            Appl(List(Constant("_args") ,  
              Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,  
                Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type")))))
              ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                      Constant("\ <^class>HOL.type")))))))))
          ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                Appl(List(Constant("\ <^type>List.list") ,  
                  Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                    Constant("\ <^class>HOL.type")))))))))))
normalize: 2 passes, 2 changes, 5 matches failed 
---------------------------- term_to_ast ---------------------------- 
pre: Constant("\ <^const>Enum.finite_1.a-sub-1") 
post: Constant("\ <^const>Enum.finite_1.a-sub-1")
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
pre: Constant("\ <^const>Enum.finite_1.a-sub-1") 
post: Constant("\ <^const>Enum.finite_1.a-sub-1")
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
pre: Constant("\ <^const>List.list.Nil") 
post: Constant("\ <^const>List.list.Nil")
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
pre: Appl(List(Constant("\ <^const>List.list.Cons") ,  
       Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,   Constant("\ <^type>Enum.finite_1"))) ,  
       Appl(List(Constant("\ <^const>List.list.Cons") ,  
         Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,   Constant("\ <^type>Enum.finite_1"))) ,  
         Constant("\ <^const>List.list.Nil"))))) 
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("bbb"))), Constant("\ <^type>Enum.finite_1"))), Constant("\ <^const>List.list.Nil"))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Constant("\ <^const>List.list.Nil"))) 
###try_rules rhs: Appl(List(Constant("_list"), Variable("x"))) 
rewrote:
  Appl(List(Constant("\ <^const>List.list.Cons") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,   Constant("\ <^type>Enum.finite_1"))) ,  
    Constant("\ <^const>List.list.Nil")))  ->
    Appl(List(Constant("_list") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,   Constant("\ <^type>Enum.finite_1"))))) 
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("aaa"))), Constant("\ <^type>Enum.finite_1"))), Appl(List(Constant("_list"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("bbb"))), Constant("\ <^type>Enum.finite_1"))))))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Appl(List(Constant("_list"), Variable("xs"))))) 
###try_rules rhs: Appl(List(Constant("_list"), Appl(List(Constant("_args"), Variable("x"), Variable("xs"))))) 
rewrote:
  Appl(List(Constant("\ <^const>List.list.Cons") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,   Constant("\ <^type>Enum.finite_1"))) ,  
    Appl(List(Constant("_list") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
        Constant("\ <^type>Enum.finite_1")))))))  ->
    Appl(List(Constant("_list") ,  
      Appl(List(Constant("_args") ,  
        Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,   Constant("\ <^type>Enum.finite_1"))) ,  
        Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,   Constant("\ <^type>Enum.finite_1"))))))) 
post: Appl(List(Constant("_list") ,  
        Appl(List(Constant("_args") ,  
          Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,   Constant("\ <^type>Enum.finite_1"))) , 
           Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
             Constant("\ <^type>Enum.finite_1")))))))
normalize: 2 passes, 2 changes, 5 matches failed 
---------------------------- term_to_ast ---------------------------- 
pre: Appl(List(Constant("\ <^const>List.list.Cons") ,   Constant("\ <^const>Enum.finite_1.a-sub-1") ,  
       Appl(List(Constant("\ <^const>List.list.Cons") ,   Constant("\ <^const>Enum.finite_1.a-sub-1") ,   Constant("\ <^const>List.list.Nil"))))) 
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Constant("\ <^const>Enum.finite_1.a-sub-1"), Constant("\ <^const>List.list.Nil"))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Constant("\ <^const>List.list.Nil"))) 
###try_rules rhs: Appl(List(Constant("_list"), Variable("x"))) 
rewrote:
  Appl(List(Constant("\ <^const>List.list.Cons") ,   Constant("\ <^const>Enum.finite_1.a-sub-1") ,   Constant("\ <^const>List.list.Nil")))  ->
    Appl(List(Constant("_list") ,   Constant("\ <^const>Enum.finite_1.a-sub-1"))) 
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Constant("\ <^const>Enum.finite_1.a-sub-1"), Appl(List(Constant("_list"), Constant("\ <^const>Enum.finite_1.a-sub-1"))))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Appl(List(Constant("_list"), Variable("xs"))))) 
###try_rules rhs: Appl(List(Constant("_list"), Appl(List(Constant("_args"), Variable("x"), Variable("xs"))))) 
rewrote:
  Appl(List(Constant("\ <^const>List.list.Cons") ,   Constant("\ <^const>Enum.finite_1.a-sub-1") ,  
    Appl(List(Constant("_list") ,   Constant("\ <^const>Enum.finite_1.a-sub-1")))))  ->
    Appl(List(Constant("_list") ,  
      Appl(List(Constant("_args") ,   Constant("\ <^const>Enum.finite_1.a-sub-1") ,   Constant("\ <^const>Enum.finite_1.a-sub-1"))))) 
post: Appl(List(Constant("_list") ,  
        Appl(List(Constant("_args") ,   Constant("\ <^const>Enum.finite_1.a-sub-1") ,   Constant("\ <^const>Enum.finite_1.a-sub-1")))))
normalize: 2 passes, 2 changes, 5 matches failed 
Auto Quickcheck found a counterexample:
  aaa = a-sub-1
  bbb = a-sub-1
  ddd = []
Evaluated terms:
*}
  
subsubsection {* handling input @{term "[aaa,bbb]"}: ast_to_term *}
ML {*
@{term "[aaa,bbb]"}
*}
text {*
---------------------------- ast_to_term ---------------------------- 
pre: Appl(List(Constant("_list") ,  
       Appl(List(Constant("_args") ,  
         Appl(List(Constant("_constrain") ,   Variable("aaa") ,   <position>)) ,  
         Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)))))) 
rewrote:
  Appl(List(Constant("_list") ,  
    Appl(List(Constant("_args") ,  
      Appl(List(Constant("_constrain") ,   Variable("aaa") ,   <position>)) ,  
      Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>))))))  ->
    Appl(List(Constant("\ <^const>List.list.Cons") ,  
      Appl(List(Constant("_constrain") ,   Variable("aaa") ,   <position>)) ,  
      Appl(List(Constant("_list") ,  
        Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)))))) 
rewrote:
  Appl(List(Constant("_list") ,  
    Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>))))  ->
    Appl(List(Constant("\ <^const>List.list.Cons") ,  
      Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)) ,  
      Constant("\ <^const>List.list.Nil"))) 
post: Appl(List(Constant("\ <^const>List.list.Cons") ,  
        Appl(List(Constant("_constrain") ,   Variable("aaa") ,   <position>)) ,  
        Appl(List(Constant("\ <^const>List.list.Cons") ,  
          Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)) ,  
          Constant("\ <^const>List.list.Nil")))))
normalize: 2 passes, 2 changes, 1 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
       Constant("\ <^class>HOL.type"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
       Constant("\ <^class>HOL.type"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("\ <^type>fun") ,  
       Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
         Constant("\ <^class>HOL.type")))
       ,   Appl(List(Constant("\ <^type>fun") ,  
             Appl(List(Constant("\ <^type>List.list") ,  
               Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,
                   Constant("\ <^class>HOL.type")))))
             ,   Appl(List(Constant("\ <^type>List.list") ,  
                   Appl(List(Constant("_ofsort") ,  
                     Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                     Constant("\ <^class>HOL.type"))))))))) 
post: Appl(List(Constant("\ <^type>fun") ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
          Constant("\ <^class>HOL.type")))
        ,   Appl(List(Constant("\ <^type>fun") ,  
              Appl(List(Constant("\ <^type>List.list") ,  
                Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a")))
                  ,   Constant("\ <^class>HOL.type")))))
              ,   Appl(List(Constant("\ <^type>List.list") ,  
                    Appl(List(Constant("_ofsort") ,  
                      Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                      Constant("\ <^class>HOL.type")))))))))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
       Constant("\ <^class>HOL.type"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("\ <^type>fun") ,  
       Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
         Constant("\ <^class>HOL.type")))
       ,   Appl(List(Constant("\ <^type>fun") ,  
             Appl(List(Constant("\ <^type>List.list") ,  
               Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,
                   Constant("\ <^class>HOL.type")))))
             ,   Appl(List(Constant("\ <^type>List.list") ,  
                   Appl(List(Constant("_ofsort") ,  
                     Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                     Constant("\ <^class>HOL.type"))))))))) 
post: Appl(List(Constant("\ <^type>fun") ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
          Constant("\ <^class>HOL.type")))
        ,   Appl(List(Constant("\ <^type>fun") ,  
              Appl(List(Constant("\ <^type>List.list") ,  
                Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a")))
                  ,   Constant("\ <^class>HOL.type")))))
              ,   Appl(List(Constant("\ <^type>List.list") ,  
                    Appl(List(Constant("_ofsort") ,  
                      Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                      Constant("\ <^class>HOL.type")))))))))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
       Constant("\ <^class>HOL.type"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("\ <^type>List.list") ,  
       Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
         Constant("\ <^class>HOL.type"))))) 
post: Appl(List(Constant("\ <^type>List.list") ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
          Constant("\ <^class>HOL.type")))))
normalize: 1 passes, 0 changes, 0 matches failed 
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*}
subsubsection {* handling output "[aaa,bbb,ccc]": term_to_ast *}
lemma "[aaa,bbb,ccc] = ddd"
  oops
text {* 
---------------------------- ast_to_term ---------------------------- 
:
---------------------------- term_to_ast ---------------------------- 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("\ <^const>List.list.Cons") ,  
           Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,  
             Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
               Constant("\ <^class>HOL.type")))))
           ,   Appl(List(Constant("\ <^const>List.list.Cons") ,  
                 Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
                   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                     Constant("\ <^class>HOL.type")))))
                 ,   Appl(List(Constant("\ <^const>List.list.Cons") ,  
                       Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                         Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                           Constant("\ <^class>HOL.type")))))
                       ,   Constant("\ <^const>List.list.Nil")))))))
         ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
               Appl(List(Constant("\ <^type>List.list") ,  
                 Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                   Constant("\ <^class>HOL.type"))))))))))) 
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ccc"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))), Constant("\ <^const>List.list.Nil"))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Constant("\ <^const>List.list.Nil"))) 
###try_rules rhs: Appl(List(Constant("_list"), Variable("x"))) 
rewrote:
  Appl(List(Constant("\ <^const>List.list.Cons") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Constant("\ <^const>List.list.Nil")))  ->
    Appl(List(Constant("_list") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
          Constant("\ <^class>HOL.type"))))))) 
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("bbb"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_list"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ccc"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))))))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Appl(List(Constant("_list"), Variable("xs"))))) 
###try_rules rhs: Appl(List(Constant("_list"), Appl(List(Constant("_args"), Variable("x"), Variable("xs"))))) 
rewrote:
  Appl(List(Constant("\ <^const>List.list.Cons") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Appl(List(Constant("_list") ,  
          Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
            Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
              Constant("\ <^class>HOL.type")))))))))  ->
    Appl(List(Constant("_list") ,  
      Appl(List(Constant("_args") ,  
        Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
          Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
            Constant("\ <^class>HOL.type")))))
        ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                Constant("\ <^class>HOL.type"))))))))) 
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("aaa"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_list"), Appl(List(Constant("_args"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("bbb"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ccc"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))))))))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Appl(List(Constant("_list"), Variable("xs"))))) 
###try_rules rhs: Appl(List(Constant("_list"), Appl(List(Constant("_args"), Variable("x"), Variable("xs"))))) 
rewrote:
  Appl(List(Constant("\ <^const>List.list.Cons") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Appl(List(Constant("_list") ,  
          Appl(List(Constant("_args") ,  
            Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                Constant("\ <^class>HOL.type")))))
            ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                  Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                    Constant("\ <^class>HOL.type")))))))))))  ->
    Appl(List(Constant("_list") ,  
      Appl(List(Constant("_args") ,  
        Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,  
          Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
            Constant("\ <^class>HOL.type")))))
        ,   Appl(List(Constant("_args") ,  
              Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
                Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                  Constant("\ <^class>HOL.type")))))
              ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                      Constant("\ <^class>HOL.type"))))))))))) 
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Constant("_list") ,  
            Appl(List(Constant("_args") ,  
              Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,  
                Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                  Constant("\ <^class>HOL.type")))))
              ,   Appl(List(Constant("_args") ,  
                    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
                      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                        Constant("\ <^class>HOL.type")))))
                    ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                          Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                            Constant("\ <^class>HOL.type")))))))))))
          ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                Appl(List(Constant("\ <^type>List.list") ,  
                  Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                    Constant("\ <^class>HOL.type")))))))))))
normalize: 2 passes, 3 changes, 9 matches failed 
---------------------------- term_to_ast ---------------------------- 
pre: Constant("\ <^const>Enum.finite_1.a-SUB-1") 
post: Constant("\ <^const>Enum.finite_1.a-SUB-1")
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
:
Auto Quickcheck found a counterexample:
  aaa = a-SUB-1
  bbb = a-SUB-1
  ccc = a-SUB-1
  ddd = []
Evaluated terms:
  [aaa, bbb, ccc] = [a-SUB-1, a-SUB-1, a-SUB-1]*}
  
subsubsection {* SUB out "[aaa,bbb,ccc]": writeln(term_to_ast) *}
text {*
lemma "[aaa,bbb,ccc] = ddd"

post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,   Constant("\ <^class>HOL.type")))
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
@@@term_to_ast, c =       \ <^const>List.list.Nil 
@@@term_to_ast, Const(c,_)Const(\ <^const>List.list.Nil,_) 
@@@term_to_ast, trans\<rightarrow>:  [] 
@@@term_to_ast, \<rightarrow>trans:  Constant("\ <^const>List.list.Nil") 
@@@term_to_ast, c =       \ <^const>List.list.Cons 
@@@term_to_ast, Const(c,_)Const(\ <^const>List.list.Cons,_) 
@@@term_to_ast, trans\<rightarrow>:  [(Const(_free,_) $ Free(ccc,_)), Const(\ <^const>List.list.Nil,_)] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Constant("\ <^const>List.list.Nil")] 
@@@term_to_ast, c =       \ <^const>List.list.Cons 
@@@term_to_ast, Const(c,_)Const(\ <^const>List.list.Cons,_) 
@@@term_to_ast, trans\<rightarrow>:  [(Const(_free,_) $ Free(bbb,_)), ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(ccc,_))) $ Const(\ <^const>List.list.Nil,_))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("bbb")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Constant("\ <^const>List.list.Nil")]] 
@@@term_to_ast, c =       \ <^const>List.list.Cons 
@@@term_to_ast, Const(c,_)Const(\ <^const>List.list.Cons,_) 
@@@term_to_ast, trans\<rightarrow>:  [(Const(_free,_) $ Free(aaa,_)), ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(bbb,_))) $ ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(ccc,_))) $ Const(\ <^const>List.list.Nil,_)))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("aaa")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("bbb")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Constant("\ <^const>List.list.Nil")]]] 
@@@term_to_ast, c =       \ <^const>HOL.eq 
@@@term_to_ast, Const(c,_)Const(\ <^const>HOL.eq,_) 
@@@term_to_ast, trans\<rightarrow>:  [((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(aaa,_))) $ ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(bbb,_))) $ ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(ccc,_))) $ Const(\ <^const>List.list.Nil,_)))), (Const(_free,_) $ Free(ddd,_))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>HOL.eq"), Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("aaa")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("bbb")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Constant("\ <^const>List.list.Nil")]]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ddd")], Appl [Constant("\ <^type>List.list"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]]]] 
@@@term_to_ast, c =       \ <^const>HOL.Trueprop 
@@@term_to_ast, Const(c,_)Const(\ <^const>HOL.Trueprop,_) 
@@@term_to_ast, trans\<rightarrow>:  [((Const(\ <^const>HOL.eq,_) $ ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(aaa,_))) $ ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(bbb,_))) $ ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(ccc,_))) $ Const(\ <^const>List.list.Nil,_))))) $ (Const(_free,_) $ Free(ddd,_)))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>HOL.Trueprop"), Appl [Constant("\ <^const>HOL.eq"), Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("aaa")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("bbb")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Constant("\ <^const>List.list.Nil")]]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ddd")], Appl [Constant("\ <^type>List.list"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]]]]] 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
*}

subsection {* UCs for MAWEN: Pair *}
subsubsection {* "Problem (Biegelinie, [setzeRandbedingungen, Biegelinien])" *}
lemma  "Problem (Biegelinie, [setzeRandbedingungen, Biegelinien]) = xxx"
  oops
ML {* (* --- term_to_ast --- all *)
*} text {*
---------------------------- term_to_ast ---------------------------- 
@@@term_to_ast, c =       \ <^const>List.list.Nil 
@@@term_to_ast, Const(c,_)Const(\ <^const>List.list.Nil,_) 
@@@term_to_ast, trans\<rightarrow>:  [] 
@@@term_to_ast, \<rightarrow>trans:  Constant("\ <^const>List.list.Nil") 
@@@term_to_ast, c =       \ <^const>List.list.Cons 
@@@term_to_ast, Const(c,_)Const(\ <^const>List.list.Cons,_) 
@@@term_to_ast, trans\<rightarrow>:  [(Const(_free,_) $ Free(Biegelinien,_)), Const(\ <^const>List.list.Nil,_)] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("Biegelinien")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]], Constant("\ <^const>List.list.Nil")] 
@@@term_to_ast, c =       \ <^const>List.list.Cons 
@@@term_to_ast, Const(c,_)Const(\ <^const>List.list.Cons,_) 
@@@term_to_ast, trans\<rightarrow>:  [(Const(_free,_) $ Free(setzeRandbedingungen,_)), ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(Biegelinien,_))) $ Const(\ <^const>List.list.Nil,_))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("setzeRandbedingungen")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("Biegelinien")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]], Constant("\ <^const>List.list.Nil")]] 
@@@term_to_ast, c =       \ <^const>Product_Type.Pair 
@@@term_to_ast, Const(c,_)Const(\ <^const>Product_Type.Pair,_) 
@@@term_to_ast, trans\<rightarrow>:  [(Const(_free,_) $ Free(Biegelinie,_)), ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(setzeRandbedingungen,_))) $ ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(Biegelinien,_))) $ Const(\ <^const>List.list.Nil,_)))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("Biegelinie")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("setzeRandbedingungen")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("Biegelinien")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]], Constant("\ <^const>List.list.Nil")]]] 
@@@term_to_ast, c =       \ <^const>HOL.eq 
@@@term_to_ast, Const(c,_)Const(\ <^const>HOL.eq,_) 
@@@term_to_ast, trans\<rightarrow>:  [((Const(_free,_) $ Free(Problem,_)) $ ((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(Biegelinie,_))) $ ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(setzeRandbedingungen,_))) $ ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(Biegelinien,_))) $ Const(\ <^const>List.list.Nil,_))))), (Const(_free,_) $ Free(xxx,_))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>HOL.eq"), Appl [Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("Problem")], Appl [Constant("\ <^type>fun"), Appl [Constant("\ <^type>Product_Type.prod"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")], Appl [Constant("\ <^type>List.list"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]]], Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("Biegelinie")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("setzeRandbedingungen")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("Biegelinien")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]], Constant("\ <^const>List.list.Nil")]]]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("xxx")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]]] 
@@@term_to_ast, c =       \ <^const>HOL.Trueprop 
@@@term_to_ast, Const(c,_)Const(\ <^const>HOL.Trueprop,_) 
@@@term_to_ast, trans\<rightarrow>:  [((Const(\ <^const>HOL.eq,_) $ ((Const(_free,_) $ Free(Problem,_)) $ ((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(Biegelinie,_))) $ ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(setzeRandbedingungen,_))) $ ((Const(\ <^const>List.list.Cons,_) $ (Const(_free,_) $ Free(Biegelinien,_))) $ Const(\ <^const>List.list.Nil,_)))))) $ (Const(_free,_) $ Free(xxx,_)))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>HOL.Trueprop"), Appl [Constant("\ <^const>HOL.eq"), Appl [Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("Problem")], Appl [Constant("\ <^type>fun"), Appl [Constant("\ <^type>Product_Type.prod"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")], Appl [Constant("\ <^type>List.list"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]]], Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("Biegelinie")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("setzeRandbedingungen")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>List.list.Cons"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("Biegelinien")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]], Constant("\ <^const>List.list.Nil")]]]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("xxx")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]]]] 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Appl(List(Constant("_constrain") ,  
                     Appl(List(Constant("_free") ,   Variable("Problem"))) ,  
                     Appl(List(Constant("\ <^type>fun") ,  
                       Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                         Appl(List(Constant("_ofsort") ,  
                           Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                           Constant("\ <^class>HOL.type")))
                         ,   Appl(List(Constant("\ <^type>List.list") ,  
                               Appl(List(Constant("_ofsort") ,  
                                 Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                                 Constant("\ <^class>HOL.type")))))))
                       ,   Appl(List(Constant("_ofsort") ,  
                             Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                             Constant("\ <^class>HOL.type")))))))
           ,   Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
                 Appl(List(Constant("_constrain") ,  
                   Appl(List(Constant("_free") ,   Variable("Biegelinie"))) ,  
                   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b")))
                     ,   Constant("\ <^class>HOL.type")))))
                 ,   Appl(List(Constant("\ <^const>List.list.Cons") ,  
                       Appl(List(Constant("_constrain") ,  
                         Appl(List(Constant("_free") ,   Variable("setzeRandbedingungen"))) ,  
                         Appl(List(Constant("_ofsort") ,  
                           Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                           Constant("\ <^class>HOL.type")))))
                       ,   Appl(List(Constant("\ <^const>List.list.Cons") ,  
                             Appl(List(Constant("_constrain") ,  
                               Appl(List(Constant("_free") ,   Variable("Biegelinien"))) ,  
                               Appl(List(Constant("_ofsort") ,  
                                 Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                                 Constant("\ <^class>HOL.type")))))
                             ,   Constant("\ <^const>List.list.Nil")))))))))
         ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("xxx"))) ,  
               Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                 Constant("\ <^class>HOL.type"))))))))) 
###try_rules ast: Appl(List(Constant("\ <^const>Product_Type.Pair"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("Biegelinie"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'b"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("setzeRandbedingungen"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'c"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("Biegelinien"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'c"))), Constant("\ <^class>HOL.type"))))), Constant("\ <^const>List.list.Nil"))))))) 
###try_rules lhs: Appl(List(Constant("\ <^const>Product_Type.Pair"), Variable("x"), Variable("y"))) 
###try_rules rhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_arg"), Variable("y"))))) 
rewrote:
  Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("Biegelinie"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Appl(List(Constant("\ <^const>List.list.Cons") ,  
          Appl(List(Constant("_constrain") ,  
            Appl(List(Constant("_free") ,   Variable("setzeRandbedingungen"))) ,  
            Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
              Constant("\ <^class>HOL.type")))))
          ,   Appl(List(Constant("\ <^const>List.list.Cons") ,  
                Appl(List(Constant("_constrain") ,  
                  Appl(List(Constant("_free") ,   Variable("Biegelinien"))) ,  
                  Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,
                      Constant("\ <^class>HOL.type")))))
                ,   Constant("\ <^const>List.list.Nil")))))))  ->
    Appl(List(Constant("_tuple") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("Biegelinie"))) ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
          Constant("\ <^class>HOL.type")))))
      ,   Appl(List(Constant("_tuple_arg") ,  
            Appl(List(Constant("\ <^const>List.list.Cons") ,  
              Appl(List(Constant("_constrain") ,  
                Appl(List(Constant("_free") ,   Variable("setzeRandbedingungen"))) ,  
                Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                  Constant("\ <^class>HOL.type")))))
              ,   Appl(List(Constant("\ <^const>List.list.Cons") ,  
                    Appl(List(Constant("_constrain") ,  
                      Appl(List(Constant("_free") ,   Variable("Biegelinien"))) ,  
                      Appl(List(Constant("_ofsort") ,  
                        Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                        Constant("\ <^class>HOL.type")))))
                    ,   Constant("\ <^const>List.list.Nil"))))))))) 
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("Biegelinien"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'c"))), Constant("\ <^class>HOL.type"))))), Constant("\ <^const>List.list.Nil"))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Constant("\ <^const>List.list.Nil"))) 
###try_rules rhs: Appl(List(Constant("_list"), Variable("x"))) 
rewrote:
  Appl(List(Constant("\ <^const>List.list.Cons") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("Biegelinien"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Constant("\ <^const>List.list.Nil")))  ->
    Appl(List(Constant("_list") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("Biegelinien"))) , 
         Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
           Constant("\ <^class>HOL.type"))))))) 
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("setzeRandbedingungen"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'c"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_list"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("Biegelinien"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'c"))), Constant("\ <^class>HOL.type"))))))))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Appl(List(Constant("_list"), Variable("xs"))))) 
###try_rules rhs: Appl(List(Constant("_list"), Appl(List(Constant("_args"), Variable("x"), Variable("xs"))))) 
rewrote:
  Appl(List(Constant("\ <^const>List.list.Cons") ,  
    Appl(List(Constant("_constrain") ,  
      Appl(List(Constant("_free") ,   Variable("setzeRandbedingungen"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Appl(List(Constant("_list") ,  
          Appl(List(Constant("_constrain") ,  
            Appl(List(Constant("_free") ,   Variable("Biegelinien"))) ,  
            Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
              Constant("\ <^class>HOL.type")))))))))  ->
    Appl(List(Constant("_list") ,  
      Appl(List(Constant("_args") ,  
        Appl(List(Constant("_constrain") ,  
          Appl(List(Constant("_free") ,   Variable("setzeRandbedingungen"))) ,  
          Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
            Constant("\ <^class>HOL.type")))))
        ,   Appl(List(Constant("_constrain") ,  
              Appl(List(Constant("_free") ,   Variable("Biegelinien"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                Constant("\ <^class>HOL.type"))))))))) 
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Appl(List(Constant("_constrain") ,  
                      Appl(List(Constant("_free") ,   Variable("Problem"))) ,  
                      Appl(List(Constant("\ <^type>fun") ,  
                        Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                          Appl(List(Constant("_ofsort") ,  
                            Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                            Constant("\ <^class>HOL.type")))
                          ,   Appl(List(Constant("\ <^type>List.list") ,  
                                Appl(List(Constant("_ofsort") ,  
                                  Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                                  Constant("\ <^class>HOL.type")))))))
                        ,   Appl(List(Constant("_ofsort") ,  
                              Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                              Constant("\ <^class>HOL.type")))))))
            ,   Appl(List(Constant("_tuple") ,  
                  Appl(List(Constant("_constrain") ,  
                    Appl(List(Constant("_free") ,   Variable("Biegelinie"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b")))
                      ,   Constant("\ <^class>HOL.type")))))
                  ,   Appl(List(Constant("_tuple_arg") ,  
                        Appl(List(Constant("_list") ,  
                          Appl(List(Constant("_args") ,  
                            Appl(List(Constant("_constrain") ,  
                              Appl(List(Constant("_free") ,   Variable("setzeRandbedingungen"))) ,  
                              Appl(List(Constant("_ofsort") ,  
                                Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                                Constant("\ <^class>HOL.type")))))
                            ,   Appl(List(Constant("_constrain") ,  
                                  Appl(List(Constant("_free") ,   Variable("Biegelinien"))) ,  
                                  Appl(List(Constant("_ofsort") ,  
                                    Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                                    Constant("\ <^class>HOL.type")))))))))))))))
          ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("xxx"))) , 
                 Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) , 
                    Constant("\ <^class>HOL.type")))))))))
normalize: 2 passes, 3 changes, 10 matches failed 
---------------------------- term_to_ast ---------------------------- 
@@@term_to_ast, c =       \ <^const>Enum.finite_2.a_sub_2 
*} ML {* (* --- term_to_ast --- the final post *)
*} text {*
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Appl(List(Constant("_constrain") ,  
                      Appl(List(Constant("_free") ,   Variable("Problem"))) ,  
                      Appl(List(Constant("\ <^type>fun") ,  
                        Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                          Appl(List(Constant("_ofsort") ,  
                            Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                            Constant("\ <^class>HOL.type")))
                          ,   Appl(List(Constant("\ <^type>List.list") ,  
                                Appl(List(Constant("_ofsort") ,  
                                  Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                                  Constant("\ <^class>HOL.type")))))))
                        ,   Appl(List(Constant("_ofsort") ,  
                              Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                              Constant("\ <^class>HOL.type")))))))
            ,   Appl(List(Constant("_tuple") ,  
                  Appl(List(Constant("_constrain") ,  
                    Appl(List(Constant("_free") ,   Variable("Biegelinie"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b")))
                      ,   Constant("\ <^class>HOL.type")))))
                  ,   Appl(List(Constant("_tuple_arg") ,  
                        Appl(List(Constant("_list") ,  
                          Appl(List(Constant("_args") ,  
                            Appl(List(Constant("_constrain") ,  
                              Appl(List(Constant("_free") ,   Variable("setzeRandbedingungen"))) ,  
                              Appl(List(Constant("_ofsort") ,  
                                Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                                Constant("\ <^class>HOL.type")))))
                            ,   Appl(List(Constant("_constrain") ,  
                                  Appl(List(Constant("_free") ,   Variable("Biegelinien"))) ,  
                                  Appl(List(Constant("_ofsort") ,  
                                    Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                                    Constant("\ <^class>HOL.type")))))))))))))))
          ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("xxx"))) , 
                 Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) , 
                    Constant("\ <^class>HOL.type")))))))))
*} ML {* (* --- term_to_ast --- final post _ = xxx*)
*} text {*
          Appl(List(Appl(List(Constant("_constrain") ,  
                      Appl(List(Constant("_free") ,   Variable("Problem"))) ,  
                      Appl(List(Constant("\ <^type>fun") ,  
                        Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                          Appl(List(Constant("_ofsort") ,  
                            Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                            Constant("\ <^class>HOL.type")))
                          ,   Appl(List(Constant("\ <^type>List.list") ,  
                                Appl(List(Constant("_ofsort") ,  
                                  Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                                  Constant("\ <^class>HOL.type")))))))
                        ,   Appl(List(Constant("_ofsort") ,  
                              Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                              Constant("\ <^class>HOL.type")))))))
            ,   Appl(List(Constant("_tuple") ,  
                  Appl(List(Constant("_constrain") ,  
                    Appl(List(Constant("_free") ,   Variable("Biegelinie"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b")))
                      ,   Constant("\ <^class>HOL.type")))))
                  ,   Appl(List(Constant("_tuple_arg") ,  
                        Appl(List(Constant("_list") ,  
                          Appl(List(Constant("_args") ,  
                            Appl(List(Constant("_constrain") ,  
                              Appl(List(Constant("_free") ,   Variable("setzeRandbedingungen"))) ,  
                              Appl(List(Constant("_ofsort") ,  
                                Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                                Constant("\ <^class>HOL.type")))))
                            ,   Appl(List(Constant("_constrain") ,  
                                  Appl(List(Constant("_free") ,   Variable("Biegelinien"))) ,  
                                  Appl(List(Constant("_ofsort") ,  
                                    Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                                    Constant("\ <^class>HOL.type")))))))))))))))
*} ML {* (* --- term_to_ast --- final post _ = xxx DEL types *)
*} text {*
          Appl(List(
                .
                            Variable("Problem") ,  
                .
            ,   Appl(List(Constant("_tuple") ,  
                  Appl(List(
                    .   Variable("Biegelinie") ,  
                    . ))
                  ,   Appl(List(Constant("_tuple_arg") ,  
                        Appl(List(Constant("_list") ,  
                          Appl(List(Constant("_args") ,  
                            Appl(List( 
                              .   Variable("setzeRandbedingungen") ,  
                              . ))
                            ,   Appl(List( 
                                  .    Variable("Biegelinien") ,  
                                  . )) )) )))))) ))
*} ML {* (* --- term_to_ast --- final post _ = xxx NO types *)
*} text {*
*}

subsubsection {* "(aaa, bbb, ccc, ddd)" *}
lemma  "(aaa, bbb, ccc, ddd) = xxx"
  oops
ML {* (* --- term_to_ast --- first pre _ = xxx WITH types *)
*} text {* checked by Scala
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
           Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,  
             Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
               Constant("\ <^class>HOL.type")))))
           ,   Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
                 Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
                   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                     Constant("\ <^class>HOL.type")))))
                 ,   Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
                       Appl(List(Constant("_constrain") ,  
                         Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                         Appl(List(Constant("_ofsort") ,  
                           Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                           Constant("\ <^class>HOL.type")))))
                       ,   Appl(List(Constant("_constrain") ,  
                             Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                             Appl(List(Constant("_ofsort") ,  
                               Appl(List(Constant("_tfree") ,   Variable("'d"))) ,  
                               Constant("\ <^class>HOL.type")))))))))))
         ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("xxx"))) ,  
               Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                 Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                   Constant("\ <^class>HOL.type")))
                 ,   Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                       Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b")))
                         ,   Constant("\ <^class>HOL.type")))
                       ,   Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                             Appl(List(Constant("_ofsort") ,  
                               Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                               Constant("\ <^class>HOL.type")))
                             ,   Appl(List(Constant("_ofsort") ,  
                                   Appl(List(Constant("_tfree") ,   Variable("'d"))) ,  
                                   Constant("\ <^class>HOL.type"))))))))))))))) 
*}
ML {* (* --- term_to_ast --- first pre _ = xxx NO types *)
*} text {* checked by Scala
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
           Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,  
             Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
               Constant("\ <^class>HOL.type")))))
           ,   Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
                 Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
                   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                     Constant("\ <^class>HOL.type")))))
                 ,   Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
                       Appl(List(Constant("_constrain") ,  
                         Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                         Appl(List(Constant("_ofsort") ,  
                           Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                           Constant("\ <^class>HOL.type")))))
                       ,   Appl(List(Constant("_constrain") ,  
                             Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                             Appl(List(Constant("_ofsort") ,  
                               Appl(List(Constant("_tfree") ,   Variable("'d"))) ,  
                               Constant("\ <^class>HOL.type")))))))))))
         ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("xxx"))) ,  
               Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                 Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                   Constant("\ <^class>HOL.type")))
                 ,   Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                       Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b")))
                         ,   Constant("\ <^class>HOL.type")))
                       ,   Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                             Appl(List(Constant("_ofsort") ,  
                               Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                               Constant("\ <^class>HOL.type")))
                             ,   Appl(List(Constant("_ofsort") ,  
                                   Appl(List(Constant("_tfree") ,   Variable("'d"))) ,  
                                   Constant("\ <^class>HOL.type"))))))))))))))) 
*}
ML {* (* --- term_to_ast --- final post _ = xxx WITH types *)
*} text {* post_ast: checked by Scala
Appl(List(Constant("_tuple") ,  
  Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("aaa"))) ,  
    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
      Constant("HOL.type")))))
  ,   Appl(List(Constant("_tuple_args") ,  
        Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) , 
           Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) , 
              Constant("HOL.type")))))
        ,   Appl(List(Constant("_tuple_args") ,  
              Appl(List(Constant("_constrain") ,  
                Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                Appl(List(Constant("_ofsort") ,  
                  Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                  Constant("HOL.type")))))
              ,   Appl(List(Constant("_tuple_arg") ,  
                    Appl(List(Constant("_constrain") ,  
                      Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                      Appl(List(Constant("_ofsort") ,  
                        Appl(List(Constant("_tfree") ,   Variable("'d"))) ,  
                        Constant("HOL.type")))))))))))))
*} ML {* (* --- term_to_ast --- final post _ = xxx NO types *)
*} text {* post_ast: checked by Scala
Appl(List(
  Constant("_tuple"),  
  Variable("aaa"),
  Appl(List(
    Constant("_tuple_args"),  
    Variable("bbb"),
    Appl(List(
      Constant("_tuple_args"),  
      Appl(List(
        Variable("ccc"))),
        Appl(List(
          Constant("_tuple_arg"),  
          Variable("ddd")))))))))
*}

  subsubsection {* "(bbb, ccc, ddd)" *}
lemma  "(bbb, ccc, ddd) = xxx"
  oops
ML {* (* --- term_to_ast --- all *)
*} text {*         
---------------------------- ast_to_term ---------------------------- 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("_tuple") ,   Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)) ,  
           Appl(List(Constant("_tuple_args") ,   Appl(List(Constant("_constrain") ,   Variable("ccc") ,   <position>)) ,  
             Appl(List(Constant("_tuple_arg") ,  
               Appl(List(Constant("_constrain") ,   Variable("ddd") ,   <position>))))))))
         ,   Appl(List(Constant("_constrain") ,   Variable("xxx") ,   <position>)))))) 
###try_rules ast: Appl(List(Constant("_tuple"), Appl(List(Constant("_constrain"), Variable("bbb"), Variable("<position>"))), Appl(List(Constant("_tuple_args"), Appl(List(Constant("_constrain"), Variable("ccc"), Variable("<position>"))), Appl(List(Constant("_tuple_arg"), Appl(List(Constant("_constrain"), Variable("ddd"), Variable("<position>"))))))))) 
###try_rules lhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_args"), Variable("y"), Variable("z"))))) 
###try_rules rhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_arg"), Appl(List(Constant("_tuple"), Variable("y"), Variable("z"))))))) 
rewrote:
  Appl(List(Constant("_tuple") ,   Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)) ,  
    Appl(List(Constant("_tuple_args") ,   Appl(List(Constant("_constrain") ,   Variable("ccc") ,   <position>)) ,  
      Appl(List(Constant("_tuple_arg") ,   Appl(List(Constant("_constrain") ,   Variable("ddd") ,   <position>))))))))  ->
    Appl(List(Constant("_tuple") ,   Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)) ,  
      Appl(List(Constant("_tuple_arg") ,  
        Appl(List(Constant("_tuple") ,   Appl(List(Constant("_constrain") ,   Variable("ccc") ,   <position>)) ,  
          Appl(List(Constant("_tuple_arg") ,  
            Appl(List(Constant("_constrain") ,   Variable("ddd") ,   <position>)))))))))) 
###try_rules ast: Appl(List(Constant("_tuple"), Appl(List(Constant("_constrain"), Variable("bbb"), Variable("<position>"))), Appl(List(Constant("_tuple_arg"), Appl(List(Constant("_tuple"), Appl(List(Constant("_constrain"), Variable("ccc"), Variable("<position>"))), Appl(List(Constant("_tuple_arg"), Appl(List(Constant("_constrain"), Variable("ddd"), Variable("<position>"))))))))))) 
###try_rules lhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_arg"), Variable("y"))))) 
###try_rules rhs: Appl(List(Constant("\ <^const>Product_Type.Pair"), Variable("x"), Variable("y"))) 
rewrote:
  Appl(List(Constant("_tuple") ,   Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)) ,  
    Appl(List(Constant("_tuple_arg") ,  
      Appl(List(Constant("_tuple") ,   Appl(List(Constant("_constrain") ,   Variable("ccc") ,   <position>)) ,  
        Appl(List(Constant("_tuple_arg") ,  
          Appl(List(Constant("_constrain") ,   Variable("ddd") ,   <position>))))))))))  ->
    Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
      Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)) ,  
      Appl(List(Constant("_tuple") ,   Appl(List(Constant("_constrain") ,   Variable("ccc") ,   <position>)) ,  
        Appl(List(Constant("_tuple_arg") ,   Appl(List(Constant("_constrain") ,   Variable("ddd") ,   <position>)))))))) 
###try_rules ast: Appl(List(Constant("_tuple"), Appl(List(Constant("_constrain"), Variable("ccc"), Variable("<position>"))), Appl(List(Constant("_tuple_arg"), Appl(List(Constant("_constrain"), Variable("ddd"), Variable("<position>"))))))) 
###try_rules lhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_arg"), Variable("y"))))) 
###try_rules rhs: Appl(List(Constant("\ <^const>Product_Type.Pair"), Variable("x"), Variable("y"))) 
rewrote:
  Appl(List(Constant("_tuple") ,   Appl(List(Constant("_constrain") ,   Variable("ccc") ,   <position>)) ,  
    Appl(List(Constant("_tuple_arg") ,   Appl(List(Constant("_constrain") ,   Variable("ddd") ,   <position>))))))  ->
    Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
      Appl(List(Constant("_constrain") ,   Variable("ccc") ,   <position>)) ,  
      Appl(List(Constant("_constrain") ,   Variable("ddd") ,   <position>)))) 
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
            Appl(List(Constant("_constrain") ,   Variable("bbb") ,   <position>)) ,  
            Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
              Appl(List(Constant("_constrain") ,   Variable("ccc") ,   <position>)) ,  
              Appl(List(Constant("_constrain") ,   Variable("ddd") ,   <position>))))))
          ,   Appl(List(Constant("_constrain") ,   Variable("xxx") ,   <position>))))))
normalize: 2 passes, 3 changes, 1 matches failed 
pre: Appl(List(Constant("\ <^type>Product_Type.prod") ,  
       Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
         Constant("\ <^class>HOL.type")))
       ,   Appl(List(Constant("\ <^type>Product_Type.prod") ,  
             Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
               Constant("\ <^class>HOL.type")))
             ,   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                   Constant("\ <^class>HOL.type"))))))) 
post: Appl(List(Constant("\ <^type>Product_Type.prod") ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
          Constant("\ <^class>HOL.type")))
        ,   Appl(List(Constant("\ <^type>Product_Type.prod") ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                Constant("\ <^class>HOL.type")))
              ,   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                    Constant("\ <^class>HOL.type")))))))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
       Constant("\ <^class>HOL.type"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
        Constant("\ <^class>HOL.type")))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
       Constant("\ <^class>HOL.type"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
        Constant("\ <^class>HOL.type")))
normalize: 1 passes, 0 changes, 0 matches failed 
pre: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
       Constant("\ <^class>HOL.type"))) 
post: Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
@@@term_to_ast, c =       \ <^const>Product_Type.Pair 
@@@term_to_ast, Const(c,_)Const(\ <^const>Product_Type.Pair,_) 
@@@term_to_ast, trans\<rightarrow>:  [(Const(_free,_) $ Free(ccc,_)), (Const(_free,_) $ Free(ddd,_))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ddd")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]] 
@@@term_to_ast, c =       \ <^const>Product_Type.Pair 
@@@term_to_ast, Const(c,_)Const(\ <^const>Product_Type.Pair,_) 
@@@term_to_ast, trans\<rightarrow>:  [(Const(_free,_) $ Free(bbb,_)), ((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(ccc,_))) $ (Const(_free,_) $ Free(ddd,_)))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("bbb")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ddd")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]]] 
@@@term_to_ast, c =       \ <^const>HOL.eq 
@@@term_to_ast, Const(c,_)Const(\ <^const>HOL.eq,_) 
@@@term_to_ast, trans\<rightarrow>:  [((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(bbb,_))) $ ((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(ccc,_))) $ (Const(_free,_) $ Free(ddd,_)))), (Const(_free,_) $ Free(xxx,_))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>HOL.eq"), Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("bbb")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ddd")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("xxx")], Appl [Constant("\ <^type>Product_Type.prod"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")], Appl [Constant("\ <^type>Product_Type.prod"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]]]] 
@@@term_to_ast, c =       \ <^const>HOL.Trueprop 
@@@term_to_ast, Const(c,_)Const(\ <^const>HOL.Trueprop,_) 
@@@term_to_ast, trans\<rightarrow>:  [((Const(\ <^const>HOL.eq,_) $ ((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(bbb,_))) $ ((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(ccc,_))) $ (Const(_free,_) $ Free(ddd,_))))) $ (Const(_free,_) $ Free(xxx,_)))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>HOL.Trueprop"), Appl [Constant("\ <^const>HOL.eq"), Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("bbb")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ddd")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("xxx")], Appl [Constant("\ <^type>Product_Type.prod"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")], Appl [Constant("\ <^type>Product_Type.prod"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]]]]] 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
           Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
             Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
               Constant("\ <^class>HOL.type")))))
           ,   Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
                 Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                     Constant("\ <^class>HOL.type")))))
                 ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                       Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                         Constant("\ <^class>HOL.type")))))))))
         ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("xxx"))) ,  
               Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                 Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                   Constant("\ <^class>HOL.type")))
                 ,   Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                       Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                         Constant("\ <^class>HOL.type")))
                       ,   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                             Constant("\ <^class>HOL.type"))))))))))))) 
###try_rules ast: Appl(List(Constant("\ <^const>Product_Type.Pair"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("bbb"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("\ <^const>Product_Type.Pair"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ccc"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'b"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ddd"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'c"))), Constant("\ <^class>HOL.type"))))))))) 
###try_rules lhs: Appl(List(Constant("\ <^const>Product_Type.Pair"), Variable("x"), Variable("y"))) 
###try_rules rhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_arg"), Variable("y"))))) 
rewrote:
  Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
          Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
            Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
              Constant("\ <^class>HOL.type")))))
          ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                  Constant("\ <^class>HOL.type")))))))))  ->
    Appl(List(Constant("_tuple") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
          Constant("\ <^class>HOL.type")))))
      ,   Appl(List(Constant("_tuple_arg") ,  
            Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
              Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                  Constant("\ <^class>HOL.type")))))
              ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                      Constant("\ <^class>HOL.type"))))))))))) 
###try_rules ast: Appl(List(Constant("\ <^const>Product_Type.Pair"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ccc"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'b"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ddd"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'c"))), Constant("\ <^class>HOL.type"))))))) 
###try_rules lhs: Appl(List(Constant("\ <^const>Product_Type.Pair"), Variable("x"), Variable("y"))) 
###try_rules rhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_arg"), Variable("y"))))) 
rewrote:
  Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
          Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
            Constant("\ <^class>HOL.type")))))))  ->
    Appl(List(Constant("_tuple") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
          Constant("\ <^class>HOL.type")))))
      ,   Appl(List(Constant("_tuple_arg") ,  
            Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                Constant("\ <^class>HOL.type"))))))))) 
###try_rules ast: Appl(List(Constant("_tuple"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("bbb"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_tuple_arg"), Appl(List(Constant("_tuple"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ccc"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'b"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_tuple_arg"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ddd"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'c"))), Constant("\ <^class>HOL.type"))))))))))))) 
###try_rules lhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_arg"), Appl(List(Constant("_tuple"), Variable("y"), Variable("z"))))))) 
###try_rules rhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_args"), Variable("y"), Variable("z"))))) 
rewrote:
  Appl(List(Constant("_tuple") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Appl(List(Constant("_tuple_arg") ,  
          Appl(List(Constant("_tuple") ,  
            Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                Constant("\ <^class>HOL.type")))))
            ,   Appl(List(Constant("_tuple_arg") ,  
                  Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                      Constant("\ <^class>HOL.type")))))))))))))  ->
    Appl(List(Constant("_tuple") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
          Constant("\ <^class>HOL.type")))))
      ,   Appl(List(Constant("_tuple_args") ,  
            Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                Constant("\ <^class>HOL.type")))))
            ,   Appl(List(Constant("_tuple_arg") ,  
                  Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                      Constant("\ <^class>HOL.type"))))))))))) 
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Constant("_tuple") ,  
            Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                Constant("\ <^class>HOL.type")))))
            ,   Appl(List(Constant("_tuple_args") ,  
                  Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                      Constant("\ <^class>HOL.type")))))
                  ,   Appl(List(Constant("_tuple_arg") ,  
                        Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                          Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                            Constant("\ <^class>HOL.type")))))))))))
          ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("xxx"))) ,  
                Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                  Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                    Constant("\ <^class>HOL.type")))
                  ,   Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                          Constant("\ <^class>HOL.type")))
                        ,   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                              Constant("\ <^class>HOL.type")))))))))))))
normalize: 2 passes, 3 changes, 7 matches failed 
---------------------------- term_to_ast ---------------------------- 
@@@term_to_ast, c =       \ <^const>Enum.finite_2...
:
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
@@@term_to_ast, c =       \ <^const>Enum.finite_2....
:
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
@@@term_to_ast, c =       \ <^const>Enum.finite_2....
:
normalize: 1 passes, 0 changes, 0 matches failed 
---------------------------- term_to_ast ---------------------------- 
@@@term_to_ast, c =       \ <^const>Enum.finite_2....
:
normalize: 2 passes, 3 changes, 7 matches failed 
---------------------------- term_to_ast ---------------------------- 
@@@term_to_ast, c =       \ <^const>Product_Type.Pair...
:
                      Constant("\ <^type>Enum.finite_2")))))))))
normalize: 2 passes, 3 changes, 7 matches failed 
---------------------------- term_to_ast ---------------------------- 
@@@term_to_ast, c =       \ <^const>Enum.finite_2....
:
  (bbb, ccc, ddd) = (a 2, a 1, a 1)
*}
ML {* (* --- term_to_ast --- @@@term_to_ast  *)
*} text {*
---------------------------- term_to_ast ---------------------------- 
@@@term_to_ast, c =       \ <^const>Product_Type.Pair 
@@@term_to_ast, Const(c,_)Const(\ <^const>Product_Type.Pair,_) 
@@@term_to_ast, trans\<rightarrow>:  [(Const(_free,_) $ Free(ccc,_)), (Const(_free,_) $ Free(ddd,_))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ddd")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]] 
@@@term_to_ast, c =       \ <^const>Product_Type.Pair 
@@@term_to_ast, Const(c,_)Const(\ <^const>Product_Type.Pair,_) 
@@@term_to_ast, trans\<rightarrow>:  [(Const(_free,_) $ Free(bbb,_)), ((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(ccc,_))) $ (Const(_free,_) $ Free(ddd,_)))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("bbb")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ddd")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]]] 
@@@term_to_ast, c =       \ <^const>HOL.eq 
@@@term_to_ast, Const(c,_)Const(\ <^const>HOL.eq,_) 
@@@term_to_ast, trans\<rightarrow>:  [((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(bbb,_))) $ ((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(ccc,_))) $ (Const(_free,_) $ Free(ddd,_)))), (Const(_free,_) $ Free(xxx,_))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>HOL.eq"), Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("bbb")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ddd")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("xxx")], Appl [Constant("\ <^type>Product_Type.prod"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")], Appl [Constant("\ <^type>Product_Type.prod"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]]]] 
@@@term_to_ast, c =       \ <^const>HOL.Trueprop 
@@@term_to_ast, Const(c,_)Const(\ <^const>HOL.Trueprop,_) 
@@@term_to_ast, trans\<rightarrow>:  [((Const(\ <^const>HOL.eq,_) $ ((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(bbb,_))) $ ((Const(\ <^const>Product_Type.Pair,_) $ (Const(_free,_) $ Free(ccc,_))) $ (Const(_free,_) $ Free(ddd,_))))) $ (Const(_free,_) $ Free(xxx,_)))] 
@@@term_to_ast, \<rightarrow>trans:  Appl [Constant("\ <^const>HOL.Trueprop"), Appl [Constant("\ <^const>HOL.eq"), Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("bbb")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")]], Appl [Constant("\ <^const>Product_Type.Pair"), Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ccc")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("ddd")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]]], Appl [Constant("_constrain"), Appl [Constant("_free"), Variable("xxx")], Appl [Constant("\ <^type>Product_Type.prod"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'a")], Constant("\ <^class>HOL.type")], Appl [Constant("\ <^type>Product_Type.prod"), Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'b")], Constant("\ <^class>HOL.type")], Appl [Constant("_ofsort"), Appl [Constant("_tfree"), Variable("'c")], Constant("\ <^class>HOL.type")]]]]]] 
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
*}
ML {* (* --- term_to_ast --- first pre  *)
*} text {*
pre: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
       Appl(List(Constant("\ <^const>HOL.eq") ,  
         Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
           Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
             Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
               Constant("\ <^class>HOL.type")))))
           ,   Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
                 Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                     Constant("\ <^class>HOL.type")))))
                 ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                       Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                         Constant("\ <^class>HOL.type")))))))))
         ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("xxx"))) ,  
               Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                 Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                   Constant("\ <^class>HOL.type")))
                 ,   Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                       Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                         Constant("\ <^class>HOL.type")))
                       ,   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                             Constant("\ <^class>HOL.type"))))))))))))) 
*}
ML {* (* --- term_to_ast --- ###try_rules  *)
*} text {*
###try_rules ast: Appl(List(Constant("\ <^const>Product_Type.Pair"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("bbb"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("\ <^const>Product_Type.Pair"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ccc"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'b"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ddd"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'c"))), Constant("\ <^class>HOL.type"))))))))) 
###try_rules lhs: Appl(List(Constant("\ <^const>Product_Type.Pair"), Variable("x"), Variable("y"))) 
###try_rules rhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_arg"), Variable("y"))))) 
rewrote:
*}
ML {* (* --- term_to_ast --- rewrote  *)
*} text {*
rewrote:
  Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
          Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
            Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
              Constant("\ <^class>HOL.type")))))
          ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                  Constant("\ <^class>HOL.type")))))))))  ->
    Appl(List(Constant("_tuple") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
          Constant("\ <^class>HOL.type")))))
      ,   Appl(List(Constant("_tuple_arg") ,  
            Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
              Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                  Constant("\ <^class>HOL.type")))))
              ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                      Constant("\ <^class>HOL.type"))))))))))) 
*}
ML {* (* --- term_to_ast --- ###try_rules *)
*} text {*
###try_rules ast: Appl(List(Constant("\ <^const>Product_Type.Pair"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ccc"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'b"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ddd"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'c"))), Constant("\ <^class>HOL.type"))))))) 
###try_rules lhs: Appl(List(Constant("\ <^const>Product_Type.Pair"), Variable("x"), Variable("y"))) 
###try_rules rhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_arg"), Variable("y"))))) 
rewrote:
*}
ML {* (* --- term_to_ast --- rewrote *)
*} text {*
  Appl(List(Constant("\ <^const>Product_Type.Pair") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
          Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
            Constant("\ <^class>HOL.type")))))))  ->
    Appl(List(Constant("_tuple") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
          Constant("\ <^class>HOL.type")))))
      ,   Appl(List(Constant("_tuple_arg") ,  
            Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                Constant("\ <^class>HOL.type"))))))))) 
*}
ML {* (* --- term_to_ast --- ###try_rules *)
*} text {*
###try_rules ast: Appl(List(Constant("_tuple"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("bbb"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_tuple_arg"), Appl(List(Constant("_tuple"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ccc"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'b"))), Constant("\ <^class>HOL.type"))))), Appl(List(Constant("_tuple_arg"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("ddd"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'c"))), Constant("\ <^class>HOL.type"))))))))))))) 
###try_rules lhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_arg"), Appl(List(Constant("_tuple"), Variable("y"), Variable("z"))))))) 
###try_rules rhs: Appl(List(Constant("_tuple"), Variable("x"), Appl(List(Constant("_tuple_args"), Variable("y"), Variable("z"))))) 
rewrote:
*}
ML {* (* --- term_to_ast --- rewrote *)
*} text {*
rewrote:
  Appl(List(Constant("_tuple") ,  
    Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
      Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
        Constant("\ <^class>HOL.type")))))
    ,   Appl(List(Constant("_tuple_arg") ,  
          Appl(List(Constant("_tuple") ,  
            Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                Constant("\ <^class>HOL.type")))))
            ,   Appl(List(Constant("_tuple_arg") ,  
                  Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                      Constant("\ <^class>HOL.type")))))))))))))  ->
    Appl(List(Constant("_tuple") ,  
      Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
          Constant("\ <^class>HOL.type")))))
      ,   Appl(List(Constant("_tuple_args") ,  
            Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                Constant("\ <^class>HOL.type")))))
            ,   Appl(List(Constant("_tuple_arg") ,  
                  Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                      Constant("\ <^class>HOL.type"))))))))))) 
*}
ML {* (* --- term_to_ast --- last post _ = xxx WITH types *)
*} text {*
post: Appl(List(Constant("\ <^const>HOL.Trueprop") ,  
        Appl(List(Constant("\ <^const>HOL.eq") ,  
          Appl(List(Constant("_tuple") ,  
            Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
              Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                Constant("\ <^class>HOL.type")))))
            ,   Appl(List(Constant("_tuple_args") ,  
                  Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ccc"))) ,  
                    Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                      Constant("\ <^class>HOL.type")))))
                  ,   Appl(List(Constant("_tuple_arg") ,  
                        Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("ddd"))) ,  
                          Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                            Constant("\ <^class>HOL.type")))))))))))
          ,   Appl(List(Constant("_constrain") ,   Appl(List(Constant("_free") ,   Variable("xxx"))) ,  
                Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                  Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                    Constant("\ <^class>HOL.type")))
                  ,   Appl(List(Constant("\ <^type>Product_Type.prod") ,  
                        Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'b"))) ,  
                          Constant("\ <^class>HOL.type")))
                        ,   Appl(List(Constant("_ofsort") ,   Appl(List(Constant("_tfree") ,   Variable("'c"))) ,  
                              Constant("\ <^class>HOL.type")))))))))))))
*}


section {* Comments on Isabelle's code *}
text {*
  This section follows the respective one in Towards_Pretty_Printing.thy (in Isabelle2016),
  but running in Isabelle2016-1.
*}
subsection {* How use Pretty.T ? *}
text {* This seems unseful in ast.ML:
  val pretty_ast: ast -> Pretty.T
  val pretty_rule: ast * ast -> Pretty.T
added this function to ast.ML:
  val print_ast = (tracing o Pretty.string_of o pretty_ast)
*} ML {*
Ast.print_ast; (* defined in Isabelle216-1 *)
*} ML {*
tracing;
*} ML {*
*}
subsection {* Find source positions for further investigation *}
text {*
  From the above traces it is not clear,
# if the translation from string to term is shown (!) or vice versa (?)
# how the ast exaclty looks like before/after transation
# which rules are applied.
*} ML {*
*} text {*
ast_to_term   local
term_to_ast   local
*} ML {*
*}
lemma "aaa + bbb = (ccc :: int)"
  sorry
text {* ^^^ gives:
------- ast_to_term ------- 
pre: ("\ <^const>HOL.Trueprop"
       ("\ <^const>HOL.eq"
         ("\ <^const>Groups.plus_class.plus" ("_constrain" aaa <position>) ("_constrain" bbb <position>))
         ("_constrain" ("_constrain" ccc <position>) "\ <^type>Int.int"))) 
post: ="=
:
------- term_to_ast ------- : knows about type constraints...
pre: ("\ <^const>HOL.Trueprop"
       ("\ <^const>HOL.eq"
         ("\ <^const>Groups.plus_class.plus" ("_constrain" ("_free" aaa) "\ <^type>Int.int")
           ("_constrain" ("_free" bbb) "\ <^type>Int.int"))
         ("_constrain" ("_free" ccc) "\ <^type>Int.int"))) 
post: ="=
:
------- term_to_ast ------- 
------- term_to_ast ------- 
:
Auto Quickcheck found a counterexample:
  aaa = - 1
  bbb = - 1
  ccc = - 1

Conclusion:
# ast_to_term knows about positions
# term_to_ast knows about type constraints
# but what kind of further translations ?!?!?!?
*} ML {*
*}

subsection {* Investigate: term_to_ast (for rendering Terms) *}
ML {*
@{term "sin(a + b) / c ::real"}
*}
lemma "sin(aaa + bbb) = (ccc ::real)"
  oops
text {*
:
------- term_to_ast ------- 
pre:  ("\ <^const>HOL.Trueprop"
        ("\ <^const>HOL.eq"
          ("\ <^const>Transcendental.sin"
            ("\ <^const>Groups.plus_class.plus" ("_constrain" ("_free" aaa) "\ <^type>Real.real")
              ("_constrain" ("_free" bbb) "\ <^type>Real.real")))
          ("_constrain" ("_free" ccc) "\ <^type>Real.real"))) 
post: ("\ <^const>HOL.Trueprop"
        ("\ <^const>HOL.eq"
          ("\ <^const>Transcendental.sin"
            ("\ <^const>Groups.plus_class.plus" ("_constrain" ("_free" aaa) "\ <^type>Real.real")
              ("_constrain" ("_free" bbb) "\ <^type>Real.real")))
          ("_constrain" ("_free" ccc) "\ <^type>Real.real")))
:
((last))------- term_to_ast ------- : for quickcheck ?!? contains no "aaa" ...
:
post: ("\ <^const>Pure.eq"
        ("\ <^const>Filter.Inf_filter_inst.Inf_filter"
          ("_constrain" ("_var" ?s) ("\ <^type>Set.set" ("\ <^type>Filter.filter" ("_ofsort" ("_tvar" ?'a) "\ <^class>HOL.equal")))))
        ("\ <^const>Filter.Sup_filter_inst.Sup_filter"
          ("_Coll" ("_constrain" ("_bound" F) ("\ <^type>Filter.filter" ("_ofsort" ("_tvar" ?'a) "\ <^class>HOL.equal")))
            ("\ <^const>Set.Ball"
              ("_constrain" ("_var" ?s) ("\ <^type>Set.set" ("\ <^type>Filter.filter" ("_ofsort" ("_tvar" ?'a) "\ <^class>HOL.equal"))))
              ("\ <^const>Filter.ord_filter_inst.less_eq_filter"
                ("_constrain" ("_bound" F) ("\ <^type>Filter.filter" ("_ofsort" ("_tvar" ?'a) "\ <^class>HOL.equal"))))))))
normalize: 1 passes, 0 changes, 2 matches failed
*} ML {* (* How does the pre:ast look as datastructure ?*)
*} ML {* (* How does the pre:ast look as datastructure ?*)
*} ML {* (* How does the pre:ast look as datastructure ?*)
*} ML {* (* How does the pre:ast look as datastructure ?*)
*}
declare [[syntax_ast_trace=false]]
declare [[syntax_ast_stats=false]]

subsection {* How is an Ast rendered finally ?!? *}
text {*
  Ast.pretty_ast: ONLY (** print asts in a LISP-like style **)
  Rather see:
    printer.ML
    isar-ref.pdf \<section>8.5 p.197 Printing of terms
      After application of macros (\<section>8.5.2), the AST is finally pretty-printed.
      For the actual printing process, the priority grammar (\<section>8.4.2) plays a vital role.
      The resulting output is concatenated with the syntactic sugar ...

      If an AST application (c x1 ... xm) has more arguments than the corresponding
      production, it is first split into ((c x1 ... xn) xn+1 ... xm) and
      then printed recursively as above.
      Applications with too few arguments or with non-constant head or without a
      corresponding production are printed in prefix-form like f t1 ... tn for terms.
      Multiple productions associated with some name c are tried in order of appearance
      within the grammar. An occurrence of some AST variable x is printed as x outright.
*} ML {*
fun to_string (Ast.Constant str) = "Constant(" ^ quote str ^ ")"
  | to_string (Ast.Variable str) = "Variable(" ^ quote str ^ ")"
  | to_string (Ast.Appl asts) = "Appl " ^ (map to_string asts |> commas |> enclose "[" "]")
*} ML {*
val a1 = Ast.Appl [Ast.Constant "+", Ast.Variable "aaa", Ast.Variable "bbb"]
*} ML {*
to_string a1          (* "Appl [Constant(\"+\"), Variable(\"aaa\"), Variable(\"bbb\")]" *)
*} ML {*
tracing (to_string a1)(*  Appl [Constant("+"), Variable("aaa"), Variable("bbb")] *)
*} ML {*
val trace_ast = (tracing o to_string)
*} ML {*
trace_ast a1
*} ML {*
tracing ("AST: " ^ to_string a1)
*} ML {*
@{term "aaa + 4 / bbb ::real"}
*} ML {*
@{term "List.Cons"}
*} ML {*
@{term "Num.Bit0"}
*}

section {* Separate Isabelle's code for translation to Scala *}
subsection {* inital trials *}
ML {*
*} ML {*
val t = @{term "a + b"}
*} ML {*
val Const ("Groups.plus_class.plus", typ) $ Free ("a", _) $ Free ("b", _) = t
*} ML {*
val (str, typs) = Term.dest_Type typ;
length typs = 2; (* this is the number of arguments !!! *)
*} ML {*
dest_comb t;
size_of_term t = 3;
size_of_typ typ = 5;
*} ML {* (* ML format, already in ast.ML, syntax_phases.ML *)
(*WN*)fun string_of_raw (Ast.Constant str) = "Constant(" ^ quote str ^ ")"
(*WN*)  | string_of_raw (Ast.Variable str) = "Variable(" ^ quote str ^ ")"
(*WN*)  | string_of_raw (Ast.Appl asts) =                                 
(*WN*)    "Appl " ^ (map string_of_raw asts |> commas |> enclose "[" "]") 
*} ML {* (* Scala format *)
fun raw_string_of (Ast.Constant str) = "Ast.Constant" ^ enclose "(" ")" (quote str)
  | raw_string_of (Ast.Variable str) = "Ast.Variable" ^ enclose "(" ")" (quote str)
  | raw_string_of (Ast.Appl asts) = "Ast.Appl" ^ enclose "(List(" "))" (commas (map raw_string_of asts))
*} ML {*
val ast = Ast.Appl[Ast.Constant "werwerwer", Ast.Variable "asdasdasd"]
*} ML {*
raw_string_of ast |> writeln
*} ML {*
open Ast
*} ML {*
(*WN*)fun pretty_ast (Constant a) = Pretty.str ("Constant(" ^ quote a ^ ")")
(*WN*)  | pretty_ast (Variable x) =
(*WN*)      (case Term_Position.decode x of
(*WN*)        SOME pos => Term_Position.pretty pos
(*WN*)      | NONE => Pretty.str ("Variable(" ^ quote x ^ ")"))
(*WN*)  | pretty_ast (Appl asts) = 
(*WN*)      Pretty.enclose "Appl(List(" "))" 
(*WN*)        (Pretty.breaks (Pretty.commas (map pretty_ast asts)));
*} ML {*
*} ML {*
*} ML {*
(*WN*)fun raw_term_str (Const(s, _)) = "Const(" ^ s ^ ",_)"
(*WN*)  | raw_term_str (Free(s, _)) = "Free(" ^ s ^ ",_)"
(*WN*)  | raw_term_str (Var((s, i),_)) = "Var(" ^ s ^ ", " ^ string_of_int i ^ ",_)"
(*WN*)  | raw_term_str (Bound i) = "B." ^ string_of_int i
(*WN*)  | raw_term_str (Abs(s, _, t)) = "Abs (" ^ s ^ ", " ^ raw_term_str t ^ ")"
(*WN*)  | raw_term_str _ = error "WN raw_term_str ";
(*WN*)fun strs2str' strl = "[" ^ (commas strl) ^ "]";
(*WN*)val raw_terms_str = strs2str' o (map raw_term_str);
*} ML {*
()
*} ML {*
val ttt = Const ("xxx", Type ("DUMMy", []))
val tt = [ttt,ttt,ttt]
*} ML {*
*} ML {*
raw_term_str ttt;
raw_terms_str tt
*} ML {*
*}
  
subsection {* term_to_ast *}
ML {*
*} ML {*
*} ML {*
*} ML {* (* ~/src/Pure/Syntax/syntax_phases.ML *)
(** encode parse trees **)

(* term_of_sort *)

(* = fn: string list -> term*)
fun term_of_sort S =
  let
    val class = Syntax.const o Lexicon.mark_class; (* = fn: string -> term *)

    fun classes [c] = class c (* = fn: string list -> term*)
      | classes (c :: cs) = Syntax.const "_classes" $ class c $ classes cs;
  in
    (case S of
      [] => Syntax.const "_topsort"
    | [c] => class c
    | cs => Syntax.const "_sort" $ classes cs)
  end;

*} ML {* (* ~/src/Pure/Syntax/syntax_phases.ML *)
(* term_of_typ *)

(* = fn: Proof.context -> typ -> term*)
fun term_of_typ ctxt ty =
  let
    (* = true: bool*)
    val show_sorts = Config.get ctxt show_sorts orelse Config.get ctxt show_markup;

    (* = fn: term -> sort -> term*)
    fun ofsort t raw_S =
      if show_sorts then
        let val S = #2 (Term_Position.decode_positionS raw_S)
        in if S = dummyS then t else Syntax.const "_ofsort" $ t $ term_of_sort S end
      else t;

    (* = fn: typ -> term*)
    fun term_of (Type (a, Ts)) =
          Term.list_comb (Syntax.const (Lexicon.mark_type a), map term_of Ts)
      | term_of (TFree (x, S)) =
          if is_some (Term_Position.decode x) then Syntax.free x
          else ofsort (Syntax.const "_tfree" $ Syntax.free x) S
      | term_of (TVar (xi, S)) = ofsort (Syntax.const "_tvar" $ Syntax.var xi) S;
  in term_of ty end;


*} ML {* (* ~/src/Pure/Syntax/syntax_phases.ML *)
(* simple_ast_of *)

(* = fn: Proof.context -> term -> Ast.ast*)
fun simple_ast_of (*ctxt*)_ =
  let
   (* = fn: string -> string*)
   (*val tune_var = if Config.get ctxt show_question_marks then I else unprefix "?";*)
   (* = fn: term -> Ast.ast*)
   fun ast_of (Const (c, _)) = Ast.Constant c
      | ast_of (Free (x, _)) = Ast.Variable x
      | ast_of (Var (xi, _)) = Ast.Variable ((*tune_var*) (Term.string_of_vname xi))
      | ast_of (t as _ $ _) =
          let val (f, args) = strip_comb t
          in Ast.mk_appl (ast_of f) (map ast_of args) end
      | ast_of (Bound i) = Ast.Appl [Ast.Constant "_loose", Ast.Variable ("B." ^ string_of_int i)]
      | ast_of (Abs _) = raise Fail "simple_ast_of: Abs";
  in ast_of end;
*} ML {* (* ~/src/Pure/Syntax/syntax_phases.ML *)
(* sort_to_ast and typ_to_ast *)

(* = fn: Proof.context -> (string -> Proof.context -> typ -> term list -> term) -> term -> Ast.ast*)
fun ast_of_termT ctxt trf tm =
  let
    (* = <context>: Proof.context*)
    val ctxt' = Config.put show_sorts false ctxt;
    (* = fn: term -> Ast.ast*)
    fun ast_of (t as Const ("_tfree", _) $ Free _) = simple_ast_of ctxt t
      | ast_of (t as Const ("_tvar", _) $ Var _) = simple_ast_of ctxt t
      | ast_of (Const (a, _)) = trans a []
      | ast_of (t as _ $ _) =
          (case strip_comb t of
            (Const (a, _), args) => trans a args
          | (f, args) => Ast.Appl (map ast_of (f :: args)))
      | ast_of t = simple_ast_of ctxt t
    (* vvv = fn: string -> (typ -> term list) -> Ast.ast*)
    and trans a args = ast_of (trf a ctxt' dummyT args)
      handle Match => Ast.mk_appl (Ast.Constant a) (map ast_of args);
  in ast_of tm end;
*} ML {* (* ~/src/Pure/Syntax/syntax_phases.ML *)
(* term_to_ast *)

local

(* = fn: term -> term*)
fun mark_aprop tm =
  let
    (* = fn: term -> term*)
    fun aprop t = Syntax.const "_aprop" $ t;

    (* = fn: typ list -> term -> bool*)
    fun is_prop Ts t =
      Type_Annotation.clean (Type_Annotation.fastype_of Ts t) = propT (*~~/src/Pure/term.ML*)
        handle TERM _ => false;

    (* = fn: term -> bool*)
    fun is_term (Const ("Pure.term", _) $ _) = true
      | is_term _ = false;

    (* = fn: typ list -> term -> term*)
    fun mark _ (t as Const _) = t
      | mark Ts (t as Const ("_bound", _) $ u) = if is_prop Ts u then aprop t else t
      | mark Ts (t as Free _) = if is_prop Ts t then aprop t else t
      | mark Ts (t as Var _) = if is_prop Ts t then aprop t else t
      | mark Ts (t as Bound _) = if is_prop Ts t then aprop t else t
      | mark Ts (Abs (x, T, t)) = Abs (x, T, mark (T :: Ts) t)
      | mark Ts (t as t1 $ (t2 as Const ("Pure.type", Type ("itself", [T])))) =
          if is_prop Ts t andalso not (is_term t) then Const ("_type_prop", T) $ mark Ts t1
          else mark Ts t1 $ mark Ts t2
      | mark Ts (t as t1 $ t2) =
          (if is_Const (Term.head_of t) orelse not (is_prop Ts t) then I else aprop)
            (mark Ts t1 $ mark Ts t2);
  in mark [] tm end;

(* = fn: term -> term*)
fun prune_types tm =
  let
    (* = fn: term -> term -> term list -> term * term list*)
    fun regard t t' seen =
      if Type_Annotation.is_omitted (Type_Annotation.fastype_of [] t) then (t, seen)
      else if member (op aconv) seen t then (t', seen)
      else (t, t :: seen);

    (* = fn: term -> term*)
    fun prune (t as Const _, seen) = (t, seen)
      | prune (t as Free (x, T), seen) = regard t (Free (x, Type_Annotation.ignore_type T)) seen
      | prune (t as Var (xi, T), seen) = regard t (Var (xi, Type_Annotation.ignore_type T)) seen
      | prune (t as Bound _, seen) = (t, seen)
      | prune (Abs (x, T, t), seen) =
          let val (t', seen') = prune (t, seen);
          in (Abs (x, T, t'), seen') end
      | prune (t1 $ t2, seen) =
          let
            val (t1', seen') = prune (t1, seen);
            val (t2', seen'') = prune (t2, seen');
          in (t1' $ t2', seen'') end;
  in #1 (prune (tm, [])) end;

(* = fn: (string -> bool) -> Proof.context -> term -> term *)
fun mark_atoms is_syntax_const ctxt tm =
  let
    (*structs = []: string list,  = []: string list*)
    val {structs, fixes} = Syntax_Trans.get_idents ctxt;
    (* = false: bool*)
    val show_structs = Config.get ctxt show_structs;

    (* = fn: term -> term*)
    fun mark ((t as Const (c, _)) $ u) =
          if member (op =) Pure_Thy.token_markers c
          then t $ u else mark t $ mark u
      | mark (t $ u) = mark t $ mark u
      | mark (Abs (x, T, t)) = Abs (x, T, mark t)
      | mark (t as Const (c, T)) =
          if is_syntax_const c then t
          else Const (Lexicon.mark_const c, T)
      | mark (t as Free (x, T)) =
          let val i = find_index (fn s => s = x) structs + 1 in
            if i = 0 andalso member (op =) fixes x then
              Const (Lexicon.mark_fixed x, T)
            else if i = 1 andalso not show_structs then
              Syntax.const "_struct" $ Syntax.const "_indexdefault"
            else Syntax.const "_free" $ t
          end
      | mark (t as Var (xi, T)) =
          if xi = Auto_Bind.dddot then Const ("_DDDOT", T)
          else Syntax.const "_var" $ t
      | mark a = a;
  in mark tm end;

in
(* = fn: (string -> bool) -> Proof.context
  -> (string -> Proof.context -> typ -> term list -> term)
  -> term -> Ast.ast*)
fun term_to_ast is_syntax_const ctxt trf tm =
  let
(*  val show_types = Config.get ctxt show_types orelse Config.get ctxt show_sorts;*)
(*  val show_markup = Config.get ctxt show_markup;*)

    (* = fn: term -> Ast.ast*)
    fun ast_of tm =
      (case strip_comb tm of
        (t as Abs _, ts) => Ast.mk_appl (ast_of (Syntax_Trans.abs_tr' ctxt t)) (map ast_of ts)
      | ((c as Const ("_free", _)), Free (x, T) :: ts) =>
          Ast.mk_appl (constrain (c $ Syntax.free x) T) (map ast_of ts)
      | ((c as Const ("_var", _)), Var (xi, T) :: ts) =>
          Ast.mk_appl (constrain (c $ Syntax.var xi) T) (map ast_of ts)
      | ((c as Const ("_bound", B)), Free (x, T) :: ts) =>
          let
            val X =
              if (*show_markup andalso not show_types orelse*) B <> dummyT then T
              else dummyT;
          in Ast.mk_appl (constrain (c $ Syntax.free x) X) (map ast_of ts) end
      | (Const ("_idtdummy", T), ts) =>
          Ast.mk_appl (constrain (Syntax.const "_idtdummy") T) (map ast_of ts)
      | (Const (c, T), ts) => (*WN..*)
(*WN*)    let val xxx = 
                trans c (Type_Annotation.smash T) ts
(*WN*)      val _ = writeln("@@@term_to_ast, c =       " ^ c)
(*WN*)      val _ = writeln("@@@term_to_ast, Const(c,_)" ^ raw_term_str (Const (c, T)))
(*WN*)      val _ = writeln("@@@term_to_ast, trans\<rightarrow>:  " ^ raw_terms_str ts)
(*WN*)      val _ = writeln("@@@term_to_ast, \<rightarrow>trans:  " ^ raw_string_of xxx)
(*WN*)    in
(*WN*)      xxx
(*WN*)    end
      | (t, ts) => Ast.mk_appl (simple_ast_of ctxt t) (map ast_of ts))

    (*vvv  = fn: string -> typ -> term list -> Ast.ast*)
    and trans a T args = ast_of (trf a ctxt T args)
      handle Match => Ast.mk_appl (Ast.Constant a) (map ast_of args)

    (* vvv = fn: term -> typ -> Ast.ast*)
    and constrain t T0 = (* = fn: term -> typ -> Ast.ast*)
      let
        val T = (*
          if show_markup andalso not show_types
          then*) Type_Annotation.clean T0
          (*else Type_Annotation.smash T0*);
      in
        if (*(show_types orelse show_markup) andalso*) T <> dummyT then
          Ast.Appl [Ast.Constant "_constrain", simple_ast_of ctxt t,
            ast_of_termT ctxt trf (term_of_typ ctxt T)]
        else simple_ast_of ctxt t
      end;
  in
    tracing "------- term_to_ast -------"; (*WN*)
    writeln("term" ^ scala_of_term tm);
    writeln("simple_ast" ^ Ast.scala_of(simple_ast_of ctxt tm));
    tm
    |> mark_aprop
    |> (*show_types ?*) prune_types
    |> Variable.revert_bounds ctxt
    |> mark_atoms is_syntax_const ctxt
    |> ast_of
  end;

end;
*} ML {*
fun contains_Abs (Abs _) = true
  | contains_Abs (Const _) = false
  | contains_Abs (Free _) = false
  | contains_Abs (Var _) = false
  | contains_Abs (Bound _) = false
  | contains_Abs (t1 $ t2) = contains_Abs t1 orelse contains_Abs t2
*} ML {*
val thy = @{theory}
val ctxt = Proof_Context.init_global thy
*} ML {*
term_to_ast (* = fn: (string -> bool) -> Proof.context ->
    (string -> Proof.context -> typ -> term list -> term) ->
  term -> Ast.ast*)
*} ML {*
*} ML {*
*} ML {*

*} 
subsubsection {* term_to_ast: open local functions *}
ML {*
val typ = Type ("dummy", [])
*} ML {*
fun xxx "dummy" (ctxt : Proof.context) typ ([] : term list) = Const ("dummy", typ)
(* = fn: string -> Proof.context -> typ -> term list -> term*)
*} ML {*
val trf = xxx
*} ML {*
*} ML {*
*} ML {*
    fun ast_of tm =
      (case strip_comb tm of
        (t as Abs _, ts) => Ast.mk_appl (ast_of (Syntax_Trans.abs_tr' ctxt t)) (map ast_of ts)
      | ((c as Const ("_free", _)), Free (x, T) :: ts) =>
          Ast.mk_appl (constrain (c $ Syntax.free x) T) (map ast_of ts)
      | ((c as Const ("_var", _)), Var (xi, T) :: ts) =>
          Ast.mk_appl (constrain (c $ Syntax.var xi) T) (map ast_of ts)
      | ((c as Const ("_bound", B)), Free (x, T) :: ts) =>
          let
            val X =
              if (*show_markup andalso not show_types orelse*) B <> dummyT then T
              else dummyT;
          in Ast.mk_appl (constrain (c $ Syntax.free x) X) (map ast_of ts) end
      | (Const ("_idtdummy", T), ts) =>
          Ast.mk_appl (constrain (Syntax.const "_idtdummy") T) (map ast_of ts)
      | (Const (c, T), ts) => trans c (Type_Annotation.smash T) ts
      | (t, ts) => Ast.mk_appl (simple_ast_of ctxt t) (map ast_of ts))

    and trans a T args = ast_of (trf a ctxt T args)
      handle Match => Ast.mk_appl (Ast.Constant a) (map ast_of args)

    and constrain t T0 =
      let
        val T = (*
          if show_markup andalso not show_types
          then Type_Annotation.clean T0
          else*) Type_Annotation.smash T0;
      in
        if (*(show_types orelse show_markup) andalso*) T <> dummyT then
          Ast.Appl [Ast.Constant "_constrain", simple_ast_of ctxt t,
            ast_of_termT ctxt trf (term_of_typ ctxt T)]
        else simple_ast_of ctxt t
      end;

constrain   (* = fn: term -> typ -> Ast.ast*);
trans       (* = fn: string -> typ -> term list -> Ast.ast*);
Ast.mk_appl (* = fn: Ast.ast -> Ast.ast list -> Ast.ast*)
*} ML {*
    val class = Syntax.const o Lexicon.mark_class; (* = fn: string -> term *)
    fun classes [c] = class c
      | classes (c :: cs) = Syntax.const "_classes" $ class c $ classes cs;
*} ML {*
fun mark_atoms is_syntax_const ctxt tm =
  let
    val {structs, fixes} = Syntax_Trans.get_idents ctxt;
    val show_structs = Config.get ctxt show_structs;

    fun mark ((t as Const (c, _)) $ u) =
          if member (op =) Pure_Thy.token_markers c
          then t $ u else mark t $ mark u
      | mark (t $ u) = mark t $ mark u
      | mark (Abs (x, T, t)) = Abs (x, T, mark t)
      | mark (t as Const (c, T)) =
          if is_syntax_const c then t
          else Const (Lexicon.mark_const c, T)
      | mark (t as Free (x, T)) =
          let val i = find_index (fn s => s = x) structs + 1 in
            if i = 0 andalso member (op =) fixes x then
              Const (Lexicon.mark_fixed x, T)
            else if i = 1 andalso not show_structs then
              Syntax.const "_struct" $ Syntax.const "_indexdefault"
            else Syntax.const "_free" $ t
          end
      | mark (t as Var (xi, T)) =
          if xi = Auto_Bind.dddot then Const ("_DDDOT", T)
          else Syntax.const "_var" $ t
      | mark a = a;
  in mark tm end;
*} ML {*
    val {structs, fixes} = Syntax_Trans.get_idents ctxt;
*} ML {*
    val show_structs = Config.get ctxt show_structs;
*} ML {*
fun is_syntax_const _ = true;

    fun mark ((t as Const (c, _)) $ u) =
          if member (op =) Pure_Thy.token_markers c
          then t $ u else mark t $ mark u
      | mark (t $ u) = mark t $ mark u
      | mark (Abs (x, T, t)) = Abs (x, T, mark t)
      | mark (t as Const (c, T)) =
          if is_syntax_const c then t
          else Const (Lexicon.mark_const c, T)
      | mark (t as Free (x, T)) =
          let val i = find_index (fn s => s = x) structs + 1 in
            if i = 0 andalso member (op =) fixes x then
              Const (Lexicon.mark_fixed x, T)
            else if i = 1 andalso not show_structs then
              Syntax.const "_struct" $ Syntax.const "_indexdefault"
            else Syntax.const "_free" $ t
          end
      | mark (t as Var (xi, T)) =
          if xi = Auto_Bind.dddot then Const ("_DDDOT", T)
          else Syntax.const "_var" $ t
      | mark a = a;
*} ML {*
fun prune_types tm =
  let
    fun regard t t' seen =
      if Type_Annotation.is_omitted (Type_Annotation.fastype_of [] t) then (t, seen)
      else if member (op aconv) seen t then (t', seen)
      else (t, t :: seen);

    fun prune (t as Const _, seen) = (t, seen)
      | prune (t as Free (x, T), seen) = regard t (Free (x, Type_Annotation.ignore_type T)) seen
      | prune (t as Var (xi, T), seen) = regard t (Var (xi, Type_Annotation.ignore_type T)) seen
      | prune (t as Bound _, seen) = (t, seen)
      | prune (Abs (x, T, t), seen) =
          let val (t', seen') = prune (t, seen);
          in (Abs (x, T, t'), seen') end
      | prune (t1 $ t2, seen) =
          let
            val (t1', seen') = prune (t1, seen);
            val (t2', seen'') = prune (t2, seen');
          in (t1' $ t2', seen'') end;
  in #1 (prune (tm, [])) end;
*} ML {*
    fun regard t t' seen =
      if Type_Annotation.is_omitted (Type_Annotation.fastype_of [] t) then (t, seen)
      else if member (op aconv) seen t then (t', seen)
      else (t, t :: seen);
*} ML {*
    fun prune (t as Const _, seen) = (t, seen)
      | prune (t as Free (x, T), seen) = regard t (Free (x, Type_Annotation.ignore_type T)) seen
      | prune (t as Var (xi, T), seen) = regard t (Var (xi, Type_Annotation.ignore_type T)) seen
      | prune (t as Bound _, seen) = (t, seen)
      | prune (Abs (x, T, t), seen) =
          let val (t', seen') = prune (t, seen);
          in (Abs (x, T, t'), seen') end
      | prune (t1 $ t2, seen) =
          let
            val (t1', seen') = prune (t1, seen);
            val (t2', seen'') = prune (t2, seen');
          in (t1' $ t2', seen'') end;
*} ML {*
*} ML {*
fun mark_aprop tm =
  let
    fun aprop t = Syntax.const "_aprop" $ t;

    fun is_prop Ts t =
      Type_Annotation.clean (Type_Annotation.fastype_of Ts t) = propT
        handle TERM _ => false;

    fun is_term (Const ("Pure.term", _) $ _) = true
      | is_term _ = false;

    fun mark _ (t as Const _) = t
      | mark Ts (t as Const ("_bound", _) $ u) = if is_prop Ts u then aprop t else t
      | mark Ts (t as Free _) = if is_prop Ts t then aprop t else t
      | mark Ts (t as Var _) = if is_prop Ts t then aprop t else t
      | mark Ts (t as Bound _) = if is_prop Ts t then aprop t else t
      | mark Ts (Abs (x, T, t)) = Abs (x, T, mark (T :: Ts) t)
      | mark Ts (t as t1 $ (t2 as Const ("Pure.type", Type ("itself", [T])))) =
          if is_prop Ts t andalso not (is_term t) then Const ("_type_prop", T) $ mark Ts t1
          else mark Ts t1 $ mark Ts t2
      | mark Ts (t as t1 $ t2) =
          (if is_Const (Term.head_of t) orelse not (is_prop Ts t) then I else aprop)
            (mark Ts t1 $ mark Ts t2);
  in mark [] tm end;
*} ML {*
fun ast_of_termT ctxt trf tm = (**)
  let
    val ctxt' = Config.put show_sorts false ctxt;
    fun ast_of (t as Const ("_tfree", _) $ Free _) = simple_ast_of ctxt t
      | ast_of (t as Const ("_tvar", _) $ Var _) = simple_ast_of ctxt t
      | ast_of (Const (a, _)) = trans a []
      | ast_of (t as _ $ _) =
          (case strip_comb t of
            (Const (a, _), args) => trans a args
          | (f, args) => Ast.Appl (map ast_of (f :: args)))
      | ast_of t = simple_ast_of ctxt t
   (* vvv = fn: string -> typ -> term list -> Ast.ast*)
    and trans a args = ast_of (trf a ctxt' dummyT args)
      handle Match => Ast.mk_appl (Ast.Constant a) (map ast_of args);
  in ast_of tm end;
*} ML {*
    val ctxt' = Config.put show_sorts false ctxt;
*} ML {*
   fun ast_of (t as Const ("_tfree", _) $ Free _) = simple_ast_of ctxt t
      | ast_of (t as Const ("_tvar", _) $ Var _) = simple_ast_of ctxt t
      | ast_of (Const (a, _)) = trans a []
      | ast_of (t as _ $ _) =
          (case strip_comb t of
            (Const (a, _), args) => trans a args
          | (f, args) => Ast.Appl (map ast_of (f :: args)))
      | ast_of t = simple_ast_of ctxt t
    (* vvv = fn: string -> (typ -> term list) -> Ast.ast*)
    and trans a args = ast_of (trf a ctxt' dummyT args)
      handle Match => Ast.mk_appl (Ast.Constant a) (map ast_of args);
*} ML {*

*} ML {*
fun simple_ast_of ctxt =
  let
    val tune_var = if Config.get ctxt show_question_marks then I else unprefix "?";
    fun ast_of (Const (c, _)) = Ast.Constant c
      | ast_of (Free (x, _)) = Ast.Variable x
      | ast_of (Var (xi, _)) = Ast.Variable (tune_var (Term.string_of_vname xi))
      | ast_of (t as _ $ _) =
          let val (f, args) = strip_comb t
          in Ast.mk_appl (ast_of f) (map ast_of args) end
      | ast_of (Bound i) = Ast.Appl [Ast.Constant "_loose", Ast.Variable ("B." ^ string_of_int i)]
      | ast_of (Abs _) = raise Fail "simple_ast_of: Abs";
  in ast_of end;
*} ML {*
    val tune_var = if Config.get ctxt show_question_marks then I else unprefix "?";
*} ML {*
   fun ast_of (Const (c, _)) = Ast.Constant c
      | ast_of (Free (x, _)) = Ast.Variable x
      | ast_of (Var (xi, _)) = Ast.Variable (tune_var (Term.string_of_vname xi))
      | ast_of (t as _ $ _) =
          let val (f, args) = strip_comb t
          in Ast.mk_appl (ast_of f) (map ast_of args) end
      | ast_of (Bound i) = Ast.Appl [Ast.Constant "_loose", Ast.Variable ("B." ^ string_of_int i)]
      | ast_of (Abs _) = raise Fail "simple_ast_of: Abs";
*} ML {*
*} ML {*
fun term_of_typ ctxt ty =
  let
    val show_sorts = Config.get ctxt show_sorts orelse Config.get ctxt show_markup;

    fun ofsort t raw_S =
      if show_sorts then
        let val S = #2 (Term_Position.decode_positionS raw_S)
        in if S = dummyS then t else Syntax.const "_ofsort" $ t $ term_of_sort S end
      else t;

    fun term_of (Type (a, Ts)) =
          Term.list_comb (Syntax.const (Lexicon.mark_type a), map term_of Ts)
      | term_of (TFree (x, S)) =
          if is_some (Term_Position.decode x) then Syntax.free x
          else ofsort (Syntax.const "_tfree" $ Syntax.free x) S
      | term_of (TVar (xi, S)) = ofsort (Syntax.const "_tvar" $ Syntax.var xi) S;
  in term_of ty end;
*} ML {*
    val show_sorts = Config.get ctxt show_sorts orelse Config.get ctxt show_markup;
*} ML {*
    fun ofsort t raw_S =
      if show_sorts then
        let val S = #2 (Term_Position.decode_positionS raw_S)
        in if S = dummyS then t else Syntax.const "_ofsort" $ t $ term_of_sort S end
      else t;
*} ML {*
    fun term_of (Type (a, Ts)) =
          Term.list_comb (Syntax.const (Lexicon.mark_type a), map term_of Ts)
      | term_of (TFree (x, S)) =
          if is_some (Term_Position.decode x) then Syntax.free x
          else ofsort (Syntax.const "_tfree" $ Syntax.free x) S
      | term_of (TVar (xi, S)) = ofsort (Syntax.const "_tvar" $ Syntax.var xi) S;
*} ML {*
fun term_of_sort S =
  let
    val class = Syntax.const o Lexicon.mark_class; (* = fn: string -> term *)

    fun classes [c] = class c (* = fn: string list -> term*)
      | classes (c :: cs) = Syntax.const "_classes" $ class c $ classes cs;
  in
    (case S of
      [] => Syntax.const "_topsort"
    | [c] => class c
    | cs => Syntax.const "_sort" $ classes cs)
  end;
*}
subsubsection {* term_to_ast: prerequisites *}
ML {*
*} ML {*
Ast.mk_appl (* = fn: Ast.ast -> Ast.ast list -> Ast.ast*)
*} ML {*
Term.string_of_vname (* = fn: indexname -> string*)
*} ML {*
*} ML {*
*} ML {*
*}
subsection {* normalization of asts *}
ML {*  (* ~/src/Pure/Syntax/ast.ML *)
         (** normalization of asts **)
*} ML {*
*}
subsubsection {* ast translation utilities *}
ML {* 
  (** ast translation utilities **)
*} ML {*
*}
subsubsection {* match *}
ML {*
  (** normalization of asts **)
*} text {*
  equivalent in Scala:
  see http://stackoverflow.com/questions/12018011/tree-collections-in-scala,
  points at http://www.scala-lang.org/api/2.12.0/scala/collection/immutable/TreeMap.html
*} ML {*
(*  match = fn: ast -> ast -> (ast Symtab.table * ast list) option*)
fun match ast pat =
  let
    exception NO_MATCH;
    (*  mtch = fn: ast -> ast -> ast Symtab.table -> ast Symtab.table *)
    fun mtch (Constant a) (Constant b) env =
          if a = b then env else raise NO_MATCH
      | mtch (Variable a) (Constant b) env =
          if a = b then env else raise NO_MATCH
      | mtch ast (Variable x) env = Symtab.update (x, ast) env
                                         (*update: key * 'a -> 'a table -> 'a table*)
      | mtch (Appl asts) (Appl pats) env = mtch_lst asts pats env
      | mtch _ _ _ = raise NO_MATCH
    (*  mtch_lst = fn: ast list -> ast list -> ast Symtab.table -> ast Symtab.table *)
    and mtch_lst (ast :: asts) (pat :: pats) env =
          mtch_lst asts pats (mtch ast pat env)
      | mtch_lst [] [] env = env
      | mtch_lst _ _ _ = raise NO_MATCH;
    (*   ast * (ast list) *)
    val (head, args) =
      (case (ast, pat) of
        (Appl asts, Appl pats) =>
          let val a = length asts and p = length pats in
            if a > p then (Appl (take p asts), drop p asts)
            else (ast, [])
          end
      | _ => (ast, []));
  in
    SOME (mtch head pat Symtab.empty, args) handle NO_MATCH => NONE
      (* (ast Symtab.table          * ast list) *)
  end;
*} ML {*
*} ML {*
ast;
"--------------------------------";
val pat = Constant "123"
    val (head, args) =
      (case (ast, pat) of
        (Appl asts, Appl pats) =>
          let val a = length asts and p = length pats in
            if a > p then (Appl (take p asts), drop p asts)
            else (ast, [])
          end
      | _ => (ast, []));
*}
subsubsection {* normalize *}
subsubsection {* SUB: separate normalize *}
ML {*
*} ML {*
(*    = fn: string -> Pretty.T -> string *)
fun message head body =
  Pretty.string_of (Pretty.block [Pretty.str head, Pretty.brk 1, body]);
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} ML {*
(* syntax_phases.ML: Ast.normalize ctxt (Syntax.print_rules syn) *)
Syntax.print_rules
(* = fn: Syntax.syntax -> string -> (ast * ast) list *)
*} ML {*
(*      = fn: Proof.context -> (string -> (ast * ast) list) -> ast -> ast*)
fun normalize ctxt get_rules pre_ast =
  let
    val trace = Config.get ctxt trace;
    val stats = Config.get ctxt stats;

    val passes = Unsynchronized.ref 0;
    val failed_matches = Unsynchronized.ref 0;
    val changes = Unsynchronized.ref 0;
    (* = fn: ast Symtab.table -> ast -> ast*)
    fun subst _ (ast as Constant _) = ast
      | subst env (Variable x) = the (Symtab.lookup env x)
      | subst env (Appl asts) = Appl (map (subst env) asts);
    (*      = fn: (ast * ast) list -> ast -> ast option*)
    fun try_rules ((lhs, rhs) :: pats) ast =
          (case match ast lhs of
            SOME (env, args) =>
              (Unsynchronized.inc changes; SOME (mk_appl (subst env rhs) args))
          | NONE => (Unsynchronized.inc failed_matches; try_rules pats ast))
      | try_rules [] _ = NONE;
    val try_headless_rules = try_rules (get_rules "");

    fun try ast a =
      (case try_rules (get_rules a) ast of
        NONE => try_headless_rules ast
      | some => some);

    fun rewrite (ast as Constant a) = try ast a
      | rewrite (ast as Variable a) = try ast a
      | rewrite (ast as Appl (Constant a :: _)) = try ast a
      | rewrite (ast as Appl (Variable a :: _)) = try ast a
      | rewrite ast = try_headless_rules ast;

    fun rewrote old_ast new_ast =
      if trace then tracing (message "rewrote:" (pretty_rule (old_ast, new_ast)))
      else ();

    fun norm_root ast =
      (case rewrite ast of
        SOME new_ast => (rewrote ast new_ast; norm_root new_ast)
      | NONE => ast);

    fun norm ast =
      (case norm_root ast of
        Appl sub_asts =>
          let
            val old_changes = ! changes;
            val new_ast = Appl (map norm sub_asts);
          in
            if old_changes = ! changes then new_ast else norm_root new_ast
          end
      | atomic_ast => atomic_ast);

    fun normal ast =
      let
        val old_changes = ! changes;
        val new_ast = norm ast;
      in
        Unsynchronized.inc passes;
        if old_changes = ! changes then new_ast else normal new_ast
      end;


    val _ = if trace then tracing (message "pre:" (pretty_ast pre_ast)) else ();
    val post_ast = normal pre_ast;
    val _ =
      if trace orelse stats then
        tracing (message "post:" (pretty_ast post_ast) ^ "\nnormalize: " ^
          string_of_int (! passes) ^ " passes, " ^
          string_of_int (! changes) ^ " changes, " ^
          string_of_int (! failed_matches) ^ " matches failed")
      else ();
  in post_ast end;
*} ML {*
*} ML {*
*} 
subsubsection {* SUB: decompose normalize to try_rules (calls match)*}
ML {*
*} ML {*
    val failed_matches = Unsynchronized.ref 0;
    val changes = Unsynchronized.ref 0;
*} ML {*
    (* = fn: ast Symtab.table -> ast -> ast *)
    fun subst _ (ast as Constant _) = ast
      | subst env (Variable x) = the (Symtab.lookup env x)
      | subst env (Appl asts) = Appl (map (subst env) asts);
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} ML {*
    (*      = fn: (ast * ast) list -> ast -> ast option*)
    fun try_rules ((lhs, rhs) :: pats) ast = (*WN*)
          (case match ast lhs of
            SOME (env, args) =>
(*WN*)      ( writeln("###try_rules ast: " ^ raw_string_of ast);
(*WN*)        writeln("###try_rules lhs: " ^ raw_string_of lhs);
(*WN*)        writeln("###try_rules rhs: " ^ raw_string_of rhs);
              (Unsynchronized.inc changes; SOME (mk_appl (subst env rhs) args))
(*WN*)      )
          | NONE => (Unsynchronized.inc failed_matches; try_rules pats ast))
      | try_rules [] _ = NONE;
*} ML {*
*} ML {*
*} 
subsubsection {* SUB: decompose normalize for translation to Scala *}
ML {*
*} ML {*
(*WN*) fun get_rules (_: string) = [(Constant"DUMMY lhs", Constant"DUMMY rhs")]
*} ML {*
    (* = fn: ast -> ast option *)
    val try_headless_rules = try_rules (get_rules "");
*} ML {*
    (* = fn: ast -> string -> ast option *)
    fun try ast a =
      (case try_rules (get_rules a) ast of
        NONE => try_headless_rules ast
      | some => some);
*} ML {*
    (* = fn: ast -> ast option *)
    fun rewrite (ast as Constant a) = try ast a
      | rewrite (ast as Variable a) = try ast a
      | rewrite (ast as Appl (Constant a :: _)) = try ast a
      | rewrite (ast as Appl (Variable a :: _)) = try ast a
      | rewrite ast = try_headless_rules ast;
*} ML {*
(*WN*) val trace = false
*} ML {*
    (* = fn: ast -> ast -> unit *)
    fun rewrote old_ast new_ast =
      if trace then tracing (message "rewrote:" (pretty_rule (old_ast, new_ast)))
      else ();
*} ML {*
    (* = fn: ast -> ast *)
    fun norm_root ast =
      (case rewrite ast of
        SOME new_ast => (rewrote ast new_ast; norm_root new_ast)
      | NONE => ast);
*} ML {*
    (* = fn: ast -> ast *)
    fun norm ast =
      (case norm_root ast of
        Appl sub_asts =>
          let
            val old_changes = ! changes;
            val new_ast = Appl (map norm sub_asts);
          in
            if old_changes = ! changes then new_ast else norm_root new_ast
          end
      | atomic_ast => atomic_ast);
*} ML {*
    (* = fn: ast -> ast *)
    fun normal ast =
      let
        val old_changes = ! changes;
        val new_ast = norm ast;
      in
(*WN    Unsynchronized.inc passes; *)
        if old_changes = ! changes then new_ast else normal new_ast
      end;
*} ML {*
    (* *)
*} ML {*
    (* *)
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*}
subsection {* Syntax_Phases.unparse_term *}
ML {*
*} ML {*
*} ML {*
*} ML {*
fun markup_class ctxt c =
  [Name_Space.markup (Type.class_space (Proof_Context.tsig_of ctxt)) c];

fun markup_type ctxt c =
  [Name_Space.markup (Type.type_space (Proof_Context.tsig_of ctxt)) c];

fun markup_const ctxt c =
  [Name_Space.markup (Consts.space_of (Proof_Context.consts_of ctxt)) c];
*} ML {*
*} ML {*
val typing_elem = YXML.output_markup_elem Markup.typing;
val sorting_elem = YXML.output_markup_elem Markup.sorting;
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*} ML {*
fun free_or_skolem ctxt x =
  let
    val m =
      if Variable.is_fixed ctxt x orelse Syntax.is_pretty_global ctxt
      then Markup.fixed x else Markup.intensify;
  in
    if Name.is_skolem x
    then ([m, Markup.skolem], Variable.revert_fixed ctxt x)
    else ([m, Markup.free], x)
  end;
*} ML {*
*} ML {*
*} text {* (*10.5.2017: there appeared a type error with try *)
try (* = fn: ast -> string -> ast option *);
Name.dest_skolem (* = fn: string -> string *);
fun var_or_skolem s =
  (case Lexicon.read_variable s of
    SOME (x, i) =>
      (case try Name.dest_skolem x of
        NONE => (Markup.var, s)
      | SOME x' => (Markup.skolem, Term.string_of_vname (x', i)))
  | NONE => (Markup.var, s));
*} ML {*
*} ML {*
(*val unparse_t = fn:
   (Proof.context -> (string -> Proof.context -> typ -> term list -> term) -> 'a -> ast) ->
     (Proof.context ->
        Printer.prtabs ->
          (string -> Proof.context -> ast list -> ast) ->
            (string -> ast list -> Pretty.T option) ->
              (string -> T list * string) -> ast -> Pretty.T list) -> 
       T -> Proof.context -> 'a -> Pretty.T
*)
fun unparse_t t_to_ast prt_t markup ctxt t =
  let
    val show_markup = false(*Config.get ctxt show_markup; ..1ST APPROACH*)
    val show_sorts = false(*Config.get ctxt show_sorts;   ..1ST APPROACH*)
    val show_types = Config.get ctxt show_types orelse show_sorts;

    val syn = Proof_Context.syn_of ctxt;
    val prtabs = Syntax.prtabs syn;
    val trf = Syntax.print_ast_translation syn;
                                              
    fun markup_extern c =
      (case Syntax.lookup_const syn c of
        SOME "" => ([], c)
      | SOME b => markup_extern b
      | NONE => c |> Lexicon.unmark
         {case_class = fn x => (markup_class ctxt x, Proof_Context.extern_class ctxt x),
          case_type = fn x => (markup_type ctxt x, Proof_Context.extern_type ctxt x),
          case_const = fn x => (markup_const ctxt x, Proof_Context.extern_const ctxt x),
          case_fixed = fn x => free_or_skolem ctxt x,
          case_default = fn x => ([], x)});

    fun token_trans "_tfree" x = SOME (Pretty.mark_str (Markup.tfree, x))
      | token_trans "_tvar" x = SOME (Pretty.mark_str (Markup.tvar, x))
      | token_trans "_free" x = SOME (Pretty.marks_str (free_or_skolem ctxt x))
      | token_trans "_bound" x = SOME (Pretty.mark_str (Markup.bound, x))
      | token_trans "_loose" x = SOME (Pretty.mark_str (Markup.bad, x))
(*     | token_trans "_var" x = SOME (Pretty.mark_str (var_or_skolem x))         WN*)
      | token_trans "_numeral" x = SOME (Pretty.mark_str (Markup.numeral, x))
      | token_trans "_inner_string" x = SOME (Pretty.mark_str (Markup.inner_string, x))
      | token_trans _ _ = NONE;

    fun markup_trans a [Ast.Variable x] = token_trans a x
      | markup_trans "_constrain" [t, ty] = constrain_trans t ty
      | markup_trans "_idtyp" [t, ty] = constrain_trans t ty
      | markup_trans "_ofsort" [ty, s] = ofsort_trans ty s
      | markup_trans _ _ = NONE

    and constrain_trans t ty =
      if show_markup andalso not show_types then
        let
          val ((bg1, bg2), en) = typing_elem;
          val bg = bg1 ^ Pretty.symbolic_output (pretty_typ_ast Markup.empty ty) ^ bg2;
          val info = {markup = (bg, en), consistent = false, indent = 0};
        in SOME (Pretty.make_block info [pretty_ast Markup.empty t]) end
      else NONE

    and ofsort_trans ty s =
      if show_markup andalso not show_sorts then
        let
          val ((bg1, bg2), en) = sorting_elem;
          val bg = bg1 ^ Pretty.symbolic_output (pretty_typ_ast Markup.empty s) ^ bg2;
          val info = {markup = (bg, en), consistent = false, indent = 0};
        in SOME (Pretty.make_block info [pretty_typ_ast Markup.empty ty]) end
      else NONE

    and pretty_typ_ast m ast = ast
      |> Printer.pretty_typ_ast ctxt prtabs trf markup_trans markup_extern
      |> Pretty.markup m

    and pretty_ast m ast = ast
      |> prt_t ctxt prtabs trf markup_trans markup_extern
      |> Pretty.markup m;
  in
    t_to_ast ctxt (Syntax.print_translation syn) t
    |> Ast.normalize ctxt (Syntax.print_rules syn)
    |> pretty_ast markup
  end;
*} ML {*
*} ML {*
(*= fn: Proof.context -> term -> Pretty.T *)
fun unparse_term ctxt =
  let
    val thy = Proof_Context.theory_of ctxt;
    val syn = Proof_Context.syn_of ctxt;
  in
    unparse_t (term_to_ast (is_some o Syntax.lookup_const syn))
      (Printer.pretty_term_ast (not (Pure_Thy.old_appl_syntax thy)))
      (Markup.language_term false) ctxt
  end;
*} ML {*
*} ML {*
*}
section {* tests comparing SML -- Scala *}
subsection {* match *}
ML {*
*} ML {* (* isac.gui.mawen.syntax.TestAst.test_list_match *)
val SOME (sym, ast) = match (Ast.Constant "a") (Ast.Constant "a");
(Symtab.dest sym, ast);
(* it = ([], []): (Symtab.key * ast) list * ast list
   Scala: Some((Map(),List()))
 *)
*} ML {*
val SOME (sym, ast) = match (Ast.Variable "b") (Ast.Variable "b");
(Symtab.dest sym, ast);
(* it = ([("b", Variable("b"))], [])
   Scala: Some((Map(b -> Variable(b)),List()))
*)
*} ML {*
val SOME (sym, ast) = match (Ast.Appl[Ast.Variable "b"]) (Ast.Appl[Ast.Variable "b"]);
(Symtab.dest sym, ast);
(* it = ([("b", Variable("b"))], [])
   Some((Map(),List()))
*)
*} 
subsubsection {* test-output from isac-java *}
text {*
BEFORE update of output in try_rules:

  def test_list_match() {
    println("/--BEGIN isac.gui.mawen.asttrans.TestAst#test_list_match");
    
    val ast =
      Ast.Appl(List(
        Ast.Constant("List.list.Cons"),
        Ast.Variable("aaa"),
        Ast.Appl(List(
          Ast.Constant("List.list.Cons"),
          Ast.Variable("bbb"),
          Ast.Appl(List(
            Ast.Constant("List.list.Cons"),
            Ast.Variable("ccc"),
            Ast.Constant("List.list.Nil")))))))
    /*from ast.ML: fun try_rules ((lhs, rhs) :: pats) ast = (*WN*)
    ###try_rules Appl(List(Constant("List.list.Cons"), Variable("x"), Constant("List.list.Nil"))) 
    ###try_rules=> Appl(List(Constant("_list"), Variable("x"))) 
     */
    var lhs =
      Appl(List(
        Constant("List.list.Cons"),
        Variable("x"),
        Constant("List.list.Nil")))
    var rhs =
      Appl(List(
        Constant("_list"),
        Variable("x")))

    println("------------------------- 1 ---")
    println(Ast.matches(ast, lhs))
*} 
subsubsection {* test-output from Isabelle2016-1-MAWEN *}
text {* (* copied from above <- from Isabelle2016-1-MAWEN *)
AFTER update of output in try_rules:
###try_rules ast: Appl(List(Constant("\ <^const>List.list.Cons"), Appl(List(Constant("_constrain"), Appl(List(Constant("_free"), Variable("bbb"))), Appl(List(Constant("_ofsort"), Appl(List(Constant("_tfree"), Variable("'a"))), Constant("\ <^class>HOL.type"))))), Constant("\ <^const>List.list.Nil"))) 
###try_rules lhs: Appl(List(Constant("\ <^const>List.list.Cons"), Variable("x"), Constant("\ <^const>List.list.Nil"))) 
###try_rules rhs: Appl(List(Constant("_list"), Variable("x"))) 
*} text {* (* remove \ <^const> *)
###try_rules ast: Appl[Constant("List.list.Cons"), Appl[Constant("_constrain"), Appl[Constant("_free"), Variable("bbb"]), Appl[Constant("_ofsort"), Appl[Constant("_tfree"), Variable("'a"]), Constant("\ <^class>HOL.type"]]), Constant("List.list.Nil"]) 
###try_rules lhs: Appl[Constant("List.list.Cons"), Variable("x"), Constant("List.list.Nil"]) 
###try_rules rhs: Appl[Constant("_list"), Variable("x"]) 
*} ML {*
    val ast =
      Appl[
        Constant("List.list.Cons"),
        Appl[
          Constant("_constrain"),
          Appl[
            Constant("_free"),
            Variable("bbb")],
          Appl[
            Constant("_ofsort"),
            Appl[
             Constant("_tfree"),
              Variable("'a")],
             Constant("HOL.type")] ],
        Constant("List.list.Nil")] 

    val lhs =
      Appl[Constant("List.list.Cons"),
        Variable("x"),
        Constant("List.list.Nil")] 

    val rhs =
      Appl[
        Constant("_list"),
        Variable("x")]
*} ML {*
try_rules [(lhs, rhs)] ast
(*val it =
   SOME (
           Appl(List(Constant("_list") ,  
             Appl(List(Constant("_constrain") ,  
               Appl(List(Constant("_free") ,   Variable("bbb"))) ,  
               Appl(List(Constant("_ofsort") ,  
                 Appl(List(Constant("_tfree") ,   Variable("'a"))) ,  
                 Constant("HOL.type")))))))
           ):
   ast option*)
*} ML {*
*} 
subsubsection {* drop types *}
ML {*                                                                 
    val ast =
      Appl[
        Constant("List.list.Cons"),
        Variable("bbb"),
        Constant("List.list.Nil")] 
*} ML {*
try_rules [(lhs, rhs)] ast
(*val it = SOME (Appl(List(Constant("_list") ,   Variable("bbb")))): ast option*)
*}
section {* further trials *}
subsection {* key on asts *}
ML {*
*} ML {* (* proto4/../syntax/ast.scala introduces a key *)
*} text {*
  case class AST_NO_KEY(message: String = "") extends Exception(message)
  
  def upd_list (asts: List[Ast], i: Integer, ast: Ast) = asts.updated(i - 1, ast)
  
  /* add ast to ast <code>upd</code> at a position given by <code>key</code>.
   * This is the only function modifying an immutable ast,
   * because "remove" means: add Constant("GAP") at <code>key</code>
   */
  def add (key: List[Int], ad: Ast, ast: Ast): Ast = ast match {
    case Constant(str) => Constant(str)
    case Variable(str) => Variable(str)
    case Appl(asts) => {
      if (key.length == 1)
        Appl(upd_list(asts, key.head, ad))
      else {
        if (key.isEmpty)
          throw new AST_NO_KEY("Index out of range of list")
        else {
          val uu = add(key.tail, ad, asts(key.head -1))
          Appl(upd_list(asts, key.head, uu)) }}
    }
  }
*} ML {*
*} text {*
~~/src/Tools/isac/Interpret/ptyps.sml

(* val scan : string list -> 'a ptyp list -> string list list *)
fun scan _  [] = [] (* no base case, for empty doms only *)
  | scan id ((Ptyp ((i, _, []))) :: []) = [id @ [i]]
  | scan id ((Ptyp ((i, _, pl))) :: []) = scan (id @ [i]) pl
  | scan id ((Ptyp ((i, _, []))) :: ps) = [id @ [i]] @ (scan id ps)
  | scan id ((Ptyp ((i, _, pl))) :: ps) = (scan (id @ [i]) pl) @ (scan id ps);

fun show_ptyps () = (writeln o format_pblIDl o (scan [])) (get_ptyps ()); (* for tests *)
*} text {*
~/proto4/repos/isac-java/src/java/isac/gui/mawen/syntax/ast.scala

  def add (key: List[Int], ad: Ast, ast: Ast): Ast = ast match {
    case Constant(str) => Constant(str)
    case Variable(str) => Variable(str)
    case Appl(asts) => {
      if (key.length == 1)
        Appl(upd_list(asts, key.head, ad))
      else {
        if (key.isEmpty)
          throw new AST_NO_KEY("Index out of range of list")
        else {
          val uu = add(key.tail, ad, asts(key.head -1))
          Appl(upd_list(asts, key.head, uu)) }}
    }
  }
*} ML {*
*} ML {*
fun string_of_key key = commas (map string_of_int key) |> enclose "[" "]" 
fun last xs = snd (split_last xs)
*} ML {*
(* apply a function 'f' to each Constant and Variable in an Ast.
 = fn: (int list * ast -> ast) -> int list -> ast -> ast*)
fun appl f (key, Ast.Constant str) = f (key, Ast.Constant str)
  | appl f (key, Ast.Variable str) = f (key, Ast.Variable str)
  | appl f (key, Ast.Appl asts) = Ast.Appl (applys 1 f (key, asts))
and applys i f (key, ast :: asts) = (appl f (key @ [i], ast)) :: (applys (i + 1) f (key, ast :: asts))
  | applys _ _ (_, []) = []
fun apply f ast = appl f ([], ast)
*} ML {*
val ast = Ast.Appl[Ast.Constant "+", Ast.Variable "a", Ast.Variable "b"]
fun xxx (key, ast) = (writeln (string_of_key key ^ string_of_raw ast); ast)
*} ML {*
*} text {*
apply xxx ast (*GOON: loops*)
*} ML {*
(* = fn: ('a list * ast -> 'b) -> 'a list -> ast -> 'b *)
fun apply_a f (key, Ast.Constant str) = f (key, Ast.Constant str)
  | apply_a f (key, Ast.Variable str) = f (key, Ast.Variable str)
  | apply_a f (key, Ast.Appl asts) = apply_a f ((*GOON..stubs*) tl key, nth asts 0)
fun apply_at f key ast = apply_a f ([(*GOON ???*)], ast)
*} ML {*
val key = [1,2,3,4,5];
nth key 3
*} ML {*
*} ML {*
*} ML {*
*} ML {*
*}
section {* template *}
subsection {* template *}
subsubsection {* template *}
ML {*
*} ML {*
*} ML {*
*}
  
end